<?php
/*
 * Dashboard module to display Metrics
 */

// output the number of new hosts added to the hosts table in last 7 days
$query = "SELECT count(ip)
          FROM hosts
          where TO_DAYS(now()) - TO_DAYS(createdate) <7";
$hcount = $dbconn->GetOne($query);
if($hcount == 1) {
   $hctext = "was 1 new host";   
} else {
   $hctext = "were $hcount new hosts";
}
echo "<p>There $hctext added to the database in the past 7 days.</p>";

// get the host scanstate summary
$query="select scanstate, count(scanstate) as count
        from hosts
        where ";
// add status flags to exclude from query
/*
$nscount = 0;
foreach ($nostatus as $ns) {
   if ($nscount >=1) { $query .= " and "; }
   $query .= " status <> '$ns' ";
   $nscount++;
}
*/
if(is_array($nostatusArray)){
   $query .= " status NOT IN ('" . implode("','",$nostatusArray) . "') ";
}
$query .= " group by scanstate";
//$query .= " order by ip";
//$result=$dbconn->execute($query);
$ssarray=$dbconn->GetArray($query);
//$hostarray=$dbconn->GetArray($query);
//foreach($hostarray as $host) {
//   $ssarray[$host[scanstate]]++;
//}
echo "<P></P>";
echo "<b>Scan State Summary:</b><hr>";
$tothosts = 0;
//foreach($ssarray as $sstate=>$scount) {
echo "<table summary='Host Scan State Summary'>
      <tr><th>Scan State</th><th>Count of IPs</th></tr>";
if(empty($ssarray)) {
   echo "<tr><td colspan=2>No data in the hosts table to display</td></tr>";
} else {
   foreach($ssarray as $ssdata) {
      $scount = $ssdata['count'];
      $sstate = (!empty($ssdata['scanstate'])) ? $ssdata['scanstate'] : "Blank";
      $tothosts += $scount;
      if($sstate == "Scan Out of Date") {
         $sstate = "Scan Out of Date (>$maxScanAge days)";
      }
      echo "<tr><td>$sstate</td><td>$scount</td></tr>";
   }
}
echo "</table>";
if($tothosts == 1) { 
   $text = "is 1 active IP"; 
} else {
   $text = "are $tothosts active IPs";
}
echo "<br>";
echo "There " . $text . " in the database.";


?>
