<?php
//
// $Id: editExceptions.php,v 1.00 2008/05/10 16:52:01 kkline Exp $
//
/***********************************************************/
/*                    Inprotect                            */
/* --------------------------------------------------------*/
/* Copyright (C) 2006 Inprotect                            */
/*                                                         */
/* This program is free software; you can redistribute it  */
/* and/or modify it under the terms of version 2 of the    */
/* GNU General Public License as published by the Free     */
/* Software Foundation.                                    */
/* This program is distributed in the hope that it will be */
/* useful, but WITHOUT ANY WARRANTY; without even the      */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE. See the GNU General Public License  */
/* for more details.                                       */
/*                                                         */
/* You should have received a copy of the GNU General      */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 59 Temple Place, */
/* Suite 330, Boston, MA 02111-1307 USA                    */
/*                                                         */
/* Contact Information:                                    */
/* inprotect-devel@lists.sourceforge.net                   */
/* http://inprotect.sourceforge.net/                       */
/***********************************************************/
/* See the README.txt and/or help files for more           */
/* information on how to use & config.                     */
/* See the LICENSE.txt file for more information on the    */
/* License this software is distributed under.             */
/*                                                         */
/* This program is intended for use in an authorized       */
/* manner only, and the author can not be held liable for  */
/* anything done with this program, code, or items         */
/* discovered with this program's use.                     */
/***********************************************************/
$pageTitle = "Exceptions";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');
//require_once('permissions.inc.php');

$typeOptions = array('False Positive', 
                     'Ambiguous Vulnerability', 
                     'True Positive',
                     'Waiver' );

$perPage = 25;

if(!$uroles['eview'] && !$uroles['admin'] && !$uroles['esubmit'] && 
   !$uroles['eapprove']) {
   echo "Insufficient rights to view this page.";
   require_once('footer.php');
   die();
}

$getParams = array ( "disp", "op", "eid", "prevPage", "offset" , "view", "sortby", "sortdir",
                     "host_id", "incident_id", "save" );
$postParams = array( "disp", "op", "submit", "eid", "justification", "type",
                     "status", "os", "comments", "justification", "hostname",
                     "secRqmts", "hostip", "plugin", "save", "approve", "port",
                     "prevPage", "host_id", "incident_id", "submitDate" );

switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach($getParams as $gp) {
      if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else { 
         $$gp=""; 
      }
   }
   break;
case "POST" :
   foreach($postParams as $pp) {
      if (isset($_POST[$pp])) { 
         $$pp=htmlspecialchars(mysql_real_escape_string(trim($_POST[$pp])), ENT_QUOTES); 
      } else { 
         $$pp=""; 
      }
   }
   break;
}

if(isset($offset)) {
   if(!is_numeric($offset)) {
      $offset=0;
   }
} else {
   $offset=0;
}

// for links back to whence you came
$prevPage = htmlentities($_SERVER['REQUEST_URI']);
//$prevPage = htmlspecialchars((trim($_SERVER['REQUEST_URI'])), ENT_QUOTES);

function create_exception( $eid, $incident_id, $hostip, $hostname, $type, $os, $comments, $justification, 
	$secRqmts, $plugin, $port, $submitDate ) {
   global $prevPage, $uroles, $username, $dbconn;

   if(!isset($eid) || !isset($hostip) || !isset($plugin) || !isset($type)) {
      echo "Invalid request: Missing required information."; 
      require_once("footer.php");
      die();
   }

   if ( isset($port) ){ $port = "'$port'"; }

   $status = "Pending";
   $closeDate = "NULL";
   $approver= "";
   
   $lastModified = date("Y-m-d H:i:s");
   if($submitDate == "") { $submitDate = $lastModified; } 

   if($port == "") { $port = "NULL"; }
   $create = "INSERT INTO exceptions (eid, hostip, hostname, type, os, status,
      comments, justification, secRqmts, submitDate, closeDate, approver, 
      plugin, port, lastModified, submitter, lastEditor) VALUES (
      '$eid', '$hostip', '$hostname', '$type', '$os', '$status', 
      '$comments','$justification', '$secRqmts', '$submitDate', $closeDate,  '$approver', 
      '$plugin', $port, '$lastModified', '$username', '$username')";

   if (! $dbconn->execute($create) === false ) {
      if ( isset($incident_id) && $incident_id > 0 ) {
         $query = "UPDATE I3_Incidents SET exception_id='$eid' WHERE id='$incident_id' LIMIT 1;";
         $dbconn->execute($query);
         echo "query=$query<br>";
      }
      echo "Exception $eid saved.";
      echo "<p>Return to <a href='$prevPage'>Exceptions</a> list.</p>";
      echo "<p>Add another <a href='exceptions.php?disp=new'>New Exception</a>.</p>";

   } else {
      echo "There was a problem saving the exception: <br>";
      echo "sql=[$create]<br>";
      echo $dbconn->ErrorMsg();
   }
}

function delete_exception( $eid ){
   global $prevPage, $uroles, $username, $dbconn;

   if(!isset($eid)) {
      echo "Invalid request:  Exception ID missing from request.";
      require_once("footer.php");
      die();
   }
   $del="delete from exceptions
         where eid = '$eid'";
   if (! $dbconn->execute($del) === false ) {
      echo "<font color='#666666' size='2'>Exception $eid has been deleted.
            <BR></font>";
      echo "<p>Return to <a href='exceptions.php'>Exceptions</a> list.</p>";

   } else {
      echo "There was a problem deleting the exception: <br>";
      echo $dbconn->ErrorMsg();
   }
}

function edit_exception ( $eid ) {
   global  $prevPage, $hostip, $hostname, $os, $port, $justification, $comments, $secRqmts, $type, $save, 
   		$uroles, $username, $dbconn;

   $statPull= "";
   $typePull= "";
   // set a flag for use in painting tables
   if( !($uroles['eapprove'] || $uroles['esubmit']) ) {
      echo "Insuffient rights to edit an exception.";
      require_once('footer.php');
      die();
   }

   $query="SELECT e.submitDate, e.closeDate, e.approver, e.status, e.plugin,
                  e.type, e.application, e.os, e.justification, e.port,
                  e.comments, e.secRqmts, e.hostip, e.hostname, e.eid,
                  e.submitter, e.lastModified, e.lastEditor
           FROM exceptions as e 
           WHERE e.eid = '$eid'";

   $result=$dbconn->execute($query);
   $data = $result->fields;


   echo "<H3>Edit Exception</H3>";
   // build a link to the plugin info
   $pluginLink = "<a class='legend' href='lookup.php?id=$data[plugin]'
      onClick=\"return popup('lookup.php?id=$data[plugin]',
      'PluginLookup');\">
      <img src='images/info.png' alt='Info' border=0></a>";
   // build the status pulldown
   $statOptions = array( "Pending", "Rejected", "Approved" );
   foreach ($statOptions as $so) {
      if ($so == $data['status']) {
         $statPull .= "<option selected value=\"$so\">$so</option>";
      } else {
         $statPull .= "<option value=\"$so\">$so</option>";
      }
   }
   // build the type pulldown
   $typeOptions = array('False Positive', 
      'Ambiguous Vulnerability', 
      'True Positive', 
      'Waiver');
   foreach ($typeOptions as $to) {
      if ($to == $data['type']) {
         $typePull .= "<option selected value=\"$to\">$to</option>";
      } else {
         $typePull .= "<option value=\"$to\">$to</option>";
      }
   }

   echo "<p><a href='$prevPage'>Back to Exception List</a></p>";
   // fields are editable only if the exception is pending
   if($data['status'] == "Approved" || $data['status'] == "Rejected") {
      echo "<p>This exception must be Unapproved to be edited.</p>";
      $fhostip = $data['hostip'];
      $fos = $data['os'];
      $ft = $data['type'];
      $fj = $data['justification'];
      $fc = $data['comments'];
      $fr = $data['secRqmts'];
      $fp = $data['port'];
   } else {
      $fhostip = "<input name='hostip' value='$data[hostip]'></input>";
      $fp = "<input name='port' value='$data[port]'></input>";
      $fos = "<input name='os' value='$data[os]' size='32'>";
      $ft = "<select name='type'>$typePull</select>";
      $fj = "<textarea name='justification' rows='4' cols='50'>$data[justification]</textarea>";
      $fc = "<textarea name='comments' rows='4' cols='50'>$data[comments]</textarea>";
      $fr = "<textarea name='secRqmts' rows='4' cols='50'>$data[secRqmts]</textarea>";
#      $fj = "<textarea name='justification' rows='4' cols='50' onkeyup='this.value = this.value.slice(0,65000)'>$data[justification]</textarea>";
#      $fc = "<textarea name='comments' rows='4' cols='50' onkeyup='this.value=this.value.slice(0,65000)'>$data[comments]</textarea>";
#      $fr = "<textarea name='secRqmts' rows='4' cols='50' onkeyup='this.value=this.value.slice(0,65000)'>$data[secRqmts]</textarea>";
   }

   echo <<<EOT
<form action="exceptions.php" method="post">
<table summary="Edit Exception" border=1 cellspacing="0" cellpadding="2">
<tr>
   <th>Exception ID</th>
   <td>$eid</td></tr>
<tr>
   <th>Hostname</th>
   <td>$data[hostname]</td></tr>
<tr>
   <th>hostip</th>
   <td>$fhostip</td></tr>
<tr>
   <th>Port</th>
   <td>$fp (leave blank for any port)</td></tr>
<tr>
   <th>Plugin</th>
   <td>$data[plugin] $pluginLink</td></tr>
<tr>
   <th>O/S</th>
   <td>$fos</td></tr>
<tr>
   <th>Status</th>
<!--  <td><select name="status">$statPull</select></td></tr>-->
  <td>$data[status]</td></tr>
<tr>
   <th>Type</th>
   <td>$ft</td></tr>
<tr>
   <th>Justification</th>
   <td>$fj</td></tr>
<tr>
   <th>Comments</th>
   <td>$fc</td></tr>
<tr>
   <th>Security Requirements</th>
   <td>$fr</td></tr>
<tr>
   <th>Submitted By</th>
   <td>$data[submitter]</td></tr>
<tr>
   <th>Submit Date</th>
   <td>$data[submitDate]</td></tr>
<tr>
   <th>Last Modified By</th>
   <td>$data[lastEditor]</td></tr>
<tr>
   <th>Last Modified</th>
   <td>$data[lastModified]</td></tr>
<tr>
   <th>Closed By</th>
   <td>$data[approver]</td></tr>
<tr>
   <th>Close Date</th>
   <td>$data[closeDate]</td></tr>
</table>
<input type="hidden" name="disp" value="update">
<input type="hidden" name="lastPage" value="$prevPage">
<input type="hidden" name="eid" value="$eid">
EOT;
   switch ($data['status']) {
      case "Approved":
      case "Rejected":
         echo "<input type='submit' name='save' value='Unapprove'>";
         break;
      case "Pending":
         echo "<input type='submit' name='save' value='Update'>";
         // can't approve an exception you submit
         if($username != $data['submitter']) {
            echo "<input type='submit' name='save' value='Approve'>";
         }
         echo "<input type='submit' name='save' value='Reject'>";
         break;
      default:
         break;
   }
   echo "</form>";

}

function new_exception ( $host_id, $incident_id ) {
   global $prevPage, $typeOptions, $uroles, $username, $dbconn;

   echo "<H3>New Exception</H3>";

   $statPull = "Pending";
   $typePull = "<select name='type'>";
   foreach ($typeOptions as $to) {
      $typePull .= "<option value=\"$to\">$to</option>";
   }
   $typePull .= "</select>";

   if ( !empty($host_id) && !empty($incident_id)) {
      $query = "SELECT t2.hostname, t2.hostip, t1.scriptid, t1.service as port, t2.os
        FROM I3_Incidents t1
          LEFT JOIN hosts t2 on t1.host_id = t2.id 
        WHERE t1. host_id = '$host_id' AND t1.id = '$incident_id'
         ORDER by t1.risk";

      if ( $uroles['debug'] ) {
         echo "sql=[$query]<br>";
      }

      $result = $dbconn->execute($query);
      #list($hostname, $hostip, $plugVal, $service, $osVal ) = $result->fields;   
      $newData = $result->fields;
      $osVal = $newData['os'];
      $plugVal = "<input name='plugin' value='$newData[scriptid]'></input>";


   }  else { 
      $getParams = array("auto","hostname", "hostip", "os", "plugin", "sid", 
                         "rid", "port");
      foreach ($getParams as $inData) {
         if(isset($_GET[$inData])) {
            $newData[$inData]=htmlspecialchars(mysql_real_escape_string(trim($_GET[$inData])), ENT_QUOTES); 
         }
      }

      // see if we have this host in the hosts table
      $hquery = "SELECT os
                 FROM hosts ";
      if(isset($hostip)) {
         $hquery .= "WHERE hostip='$hostip'";
      } elseif(isset($hostname)) {
         $hquery .= "WHERE hostname='$hostname'";
      }
      $newData['os'] = $dbconn->GetOne($hquery);


      // create the pull-downs for the plugin and O/S fields if this wasn't
      // sent in the GET call and doesn't exist in the hosts table
      if(!isset($newData['os'])) {
         $query = "SELECT DISTINCT(os) 
                   FROM hosts
                   ORDER BY os ASC";
         $results = $dbconn->execute($query);
         $osVal = $results->GetMenu('os');
         //$osVal = "<select name='os'>";
         //foreach ($results->GetArray() as $osOpt) {
         //   $osVal .= "<option value=\"$osOpt\">$osOpt</option>\n";
         //}
         //$osVal .= "</select>";
      } else {
         $osVal = "<input name='os' value='$newData[os]'></input>";
      }
      if(!isset($newData['plugin'])) {
         $query = "SELECT id FROM plugins ORDER BY id ASC";
         $results = $dbconn->execute($query);
         $plugVal = $results->GetMenu('plugin');
         //$plugVal = "<select name='plugin'>";
         //foreach ($results->GetArray() as $p=>$d) {
         //   $plugVal .= "<option value=\"$p\">$d</option>\n";
         //}
         //$plugVal .= "</select>";
      } else {
         $plugVal = "<input name='plugin' value='$newData[plugin]'></input>";
      }
   }
      // create the exception ID
      $eid = substr($username,0,4) . "-" . time();
      // set the submitDate to the current time
      $submitDate = date("Y-m-d H:i:s");

      echo <<<EOT
<form action="exceptions.php" method="post">
<table summary="New Exception" border=1 cellspacing="0" cellpadding="2">
<tr>
   <th>Exception ID</th>
   <td>$eid</td></tr>
<tr>
   <th>Hostname</th>
   <td><input name="hostname" value="$newData[hostname]"></input> (use ANY for all hosts)</td></tr>
<tr>
   <th>hostip</th>
   <td><input name="hostip" value="$newData[hostip]"></input> (use ALL for all hosts)</td></tr>
<tr>
   <th>Port</th>
   <td><input name="port" value="$newData[port]"></input> (leave blank for any port)</td></tr>
<tr>
   <th>Plugin</th>
   <td>$plugVal</td></tr>
<tr>
   <th>O/S</th>
   <td>$osVal</td></tr>
<tr>
   <th>Status</th>
   <td>$statPull</td></tr>
<tr>
   <th>Type</th>
   <td>$typePull</td></tr>
<tr>
   <th>Justification</th>
<!--   <td><textarea name='justification' rows='4' cols='50' onkeyup='this.value=this.value.slice(0,65000)'></textarea></td></tr> -->
   <td><textarea name='justification' rows='4' cols='50'></textarea></td></tr>
<tr>
   <th>Comments</th>
<!--   <td><textarea name='comments' rows='4' cols='50' onkeyup='this.value=this.value.slice(0,65000)'></textarea></td></tr> -->
   <td><textarea name='comments' rows='4' cols='50'></textarea></td></tr>
<tr>
   <th>Security Requirements</th>
<!--   <td><textarea name='secRqmts' rows='4' cols='50' onkeyup='this.value=this.value.slice(0,65000)'></textarea></td></tr> -->
   <td><textarea name='secRqmts' rows='4' cols='50'></textarea></td></tr>
<tr>
   <th>Submit Date</th>
   <td>$submitDate</td></tr>
</table>
<input type="hidden" name="disp" value="create">
<!--<input type="hidden" name="submitDate" value="$submitDate">-->
<input type="hidden" name="prevPage" value="$prevPage">
<input type="hidden" name="eid" value="$eid">
<input type="hidden" name="incident_id" value="$incident_id">
<input type="submit" name="submit" value="Create">
EOT;
      //if(!$eapprove) { 
      //   echo "<input type='hidden' name='status' value='Pending'>";
      //}
      echo "</form>";

}

function list_exceptions ( $view ) {
   global $sortby, $sortdir, $prevPage, $perPage, $offset, $uroles, $username, $dbconn;

   $query="SELECT count(*) from exceptions";
   $result=$dbconn->execute($query);
   $count=$result->fields[0];
   if($count == 1) {
      $text = "is $count exception";
   } else { 
      $text = "are $count exceptions";
   }

   echo <<<EOT
There $text in the database.
<p>
<a href='exceptions.php?disp=new'>Add New Exception</a> | 
<a href="exportExceptions.php">Export Exceptions to Excel</a>
<p>
EOT;

   // build the pager
   $pager = "";
   if ($count > $perPage) {
      $previous = $offset - $perPage;
      if ($previous < 0) {
         $previous = 0;
      }
      $last = $count - $perPage;
      $next = $offset + $perPage;
      if ($next > $last) {
         $next = $last;
      }

      $pager = "<p><a href='exceptions.php?offset=0' class='pager'>&lt&lt First </a> | ";
      if($previous > 0) {
         $pager .= "<a href='exceptions.php?offset=$previous' class='pager'>&lt Previous </a> | ";
      }
      $pageEnd = $offset + $perPage;
      $pager .= " [$offset - $pageEnd of $count] | ";
      if($next < $last) {
         $pager .= "<a href='exceptions.php?offset=$next' class='pager'>| Next &gt;</a> | ";
      }
      $pager .= "<a href='exceptions.php?offset=$last' class='pager'> Last &gt;&gt;</a></p>";
   }

   echo $pager;

   $obc = "";
   // set the correct order, default is by status and submitDate
   switch($sortby) {
      case "submitDate":
         $obc = "ORDER BY submitDate $sortdir";
         break;
      case "eid":
         $obc = "ORDER BY eid $sortdir";
         break;
      case "port":
         $obc = "ORDER BY port $sortdir";
         break;
      case "approver":
         $obc = "ORDER BY approver $sortdir";
         break;
      case "closeDate":
         $obc = "ORDER BY closeDate $sortdir";
         break;
      case "type":
         $obc = "ORDER BY type $sortdir";
         break;
      case "status":
         $obc = "ORDER BY status $sortdir";
         break;
      case "plink":
         $obc = "ORDER BY plugin $sortdir";
         break;
      case "hlink":
         $obc = "ORDER BY hostname $sortdir";
         break;
      case "ilink":
         $obc = "ORDER BY hostip $sortdir";
         break;
      default:
         $obc = "ORDER BY status ASC, submitDate DESC";
         break;
   }


   if($view == "pending") {
      $whereclause = "WHERE status = 'Pending' ";
   } else {
      $whereclause = "";
   }

   $limit = "LIMIT $offset, $perPage";

   $query = "SELECT eid, submitDate, status, plugin, type, hostip, 
                 closeDate, approver, hostname, port
          FROM exceptions 
          $whereclause
          $obc
          $limit";

   $result=$dbconn->GetArray($query);

   $tdata = array();
   foreach($result as $data) {
      if($data['hostname'] == "ANY" || $data['hostip'] == "ALL") {
         $data['hlink'] = $data['hostname'];
         $data['ilink'] = $data['hostip'];
      } else {
         $data['hlink'] = hostLink($data['hostname'],$data['hostip'],"name",FALSE);
         $data['ilink'] = hostLink($data['hostname'],$data['hostip'],"hostip",FALSE);
      }
      $data['plink'] = "<a href='lookup.php?id=" . $data['plugin'] . 
                    "' target='_blank'>" .
                     $data['plugin'] . "</A>";
      $tdata[] = $data;
   }

   $elinks = array( "View" => array(
                      'url' => "exceptions.php?disp=view&eid=%param%",
                      'param' => 'eid',
                      'icon' => 'images/zoom.png')) ;
   if($uroles['eapprove'] || ($uroles['esubmit'] && 
      ($data['status'] == "Pending"))) {
      $elinks2 = array( "Edit" => array(
                         'url' => "exceptions.php?disp=edit&eid=%param%",
                         'param' => 'eid',
                         'icon' => 'images/pencil.png'),
                     "Delete" => array(
                         'url' => "exceptions.php?disp=del&eid=%param%",
                         'param' => 'eid',
                         'onclick' => 'return confirmDelete();',
                         'icon' => "images/cross.png"));
   }
   $elinks = array_merge($elinks,$elinks2);

   if($sortdir == "ASC") { $sortdir = "DESC"; } else { $sortdir = "ASC"; }
   $baseURL = $_SERVER['PHP_SELF'] . "?view=$view&sortby=%var%&sortdir=$sortdir";
   $tableFieldMap = array( "Submit Date" => array( 'var' => "submitDate",
                                                'link' => $baseURL ),
                        "Exception ID" => array( 'var' => "eid",
                                                 'link' => $baseURL ),
                        "Hostname" => array( 'var' => "hlink",
                                             'link' => $baseURL ),
                        "hostip" => array( 'var' => "ilink",
                                       'link' => $baseURL ),
                        "Port" => array( 'var' => "port",
                                         'link' => $baseURL ),
                        "Plugin ID" => array( 'var' => "plink",
                                              'link' => $baseURL ),
                        "Status" => array( 'var' => "status",
                                           'link' => $baseURL ),
                        "Type" => array( 'var' => "type",
                                         'link' => $baseURL ),
                        "Close Date" => array( 'var' => "closeDate",
                                               'link' => $baseURL ),
                        "Approver" => array( 'var' => "approver",
                                             'link' => $baseURL ),
                        "Links" => $elinks );

   drawTable($tableFieldMap, $tdata, "Exceptions");

   echo $pager;

   echo <<<EOT
<p>
<a href='exceptions.php?disp=new'>Add New Exception</a> | 
<a href="exportExceptions.php">Export Exceptions to Excel</a>
<p>
EOT;

}

function update_exception( $eid, $save, $port, $os, $hostname, $hostip, $justification, $comments, $secRqmts, $type ){
   global $prevPage, $uroles, $username, $dbconn;
  
   if($uroles['esubmit'] || $uroles['eapprove']) {
      $now = date("Y-m-d H:i:s");
      $update = "UPDATE exceptions SET ";
      $notSubmitter = "";
      switch ($save) {
      case "Approve":
         if(!$uroles['eapprove']) {
            echo "Error - insufficient rights to approve exception request.";
            require_once('footer.php');
            die();
         } else {
            $sets[] = "status = 'Approved'"; 
            $sets[] = "closeDate = '$now'"; 
            $sets[] = "approver = '$username'"; 
            $logMsg = "Exception $eid Approved";
         }
         // add to the where clause to prevent the submitter from approving
         // an exception
         $notSubmitter = " AND submitter <> '$username'";
         break;
      case "Unapprove":
         $sets[] = "status = 'Pending'"; 
         $sets[] = "closeDate = NULL"; 
         $sets[] = "approver = NULL"; 
         $logMsg = "Exception $eid marked Pending";
         break;
      case "Rejected":
         $sets[] = "status = 'Rejected'"; 
         $sets[] = "closeDate = '$now'"; 
         $sets[] = "approver = '$username'"; 
         $logMsg = "Exception $eid Rejected";
         break;
      case "Update":
         if($port == "") { 
            $sets[] = "port = NULL"; 
         } else {
            $sets[] = "port = $port";
         }
         $sets[] = "os = '$os'";
         $sets[] = "hostip = '$hostip'";
         //$sets[] = "hostname = '$hostname'";
         $sets[] = "justification = '$justification'";
         $sets[] = "comments = '$comments'";
         $sets[] = "secRqmts = '$secRqmts'";
         $sets[] = "type = '$type'"; 
         $logMsg = "Exception $eid Updated";
         break;
      }
      $sets[] = "lastEditor = '$username'";
      $sets[] = "lastModified = '$now'";
      $update .= implode(",", $sets) . " WHERE eid = '$eid'";
      $update .= $notSubmitter;
      if (! $dbconn->execute($update) === false ) {
         echo $logMsg;
         echo "<p>Return to <a href='$prevPage'>Exceptions</a> list.</p>";

      } else {
         echo "There was a problem updating the exception:<br>";
         echo $dbconn->ErrorMsg();
      }
   }

}

function view_exception ( $eid ) {
   global $prevPage, $uroles, $username, $dbconn;

   $query="SELECT e.submitDate, e.closeDate, e.approver, e.status, e.plugin,
                  e.type, e.application, e.os, e.justification, e.port,
                  e.comments, e.secRqmts, e.hostip, e.hostname, e.eid,
                  e.submitter, e.lastModified, e.lastEditor
           FROM exceptions as e 
           WHERE e.eid = '$eid'";

   $result=$dbconn->execute($query);
   $data = $result->fields;

   echo "<H3>View Exception</H3>";
   echo "<p><a href='exceptions.php'>Back to Exception List</a>";
   if( $uroles['esubmit'] || $uroles['eapprove'] ) {
      echo " |  <a href='exceptions.php?disp=edit&eid=$eid'>Edit This Exception</a>";
   }
   echo "</p>";
   echo <<<EOT
<table summary="View Exception" border=1 cellspacing="0" cellpadding="2">
<tr>
   <th>Exception ID</th>
   <td>$eid</td></tr>
<tr>
   <th>Hostname</th>
   <td>$data[hostname]</td></tr>
<tr>
   <th>IP</th>
   <td>$data[hostip]</td></tr>
<tr>
   <th>Port</th>
   <td>$data[port]</td></tr>
<tr>
   <th>Plugin</th>
   <td>$data[plugin]</td></tr>
<tr>
   <th>O/S</th>
   <td>$data[os]</td></tr>
<tr>
   <th>Status</th>
   <td>$data[status]</td></tr>
<tr>
   <th>Type</th>
   <td>$data[type]</td></tr>
<tr>
   <th>Justification</th>
   <td>$data[justification]</td></tr>
<tr>
   <th>Comments</th>
   <td>$data[comments]</td></tr>
<tr>
   <th>Security Requirements</th>
   <td>$data[secRqmts]</td></tr>
<tr>
   <th>Submitted By</th>
   <td>$data[submitter]</td></tr>
<tr>
   <th>Submit Date</th>
   <td>$data[submitDate]</td></tr>
<tr>
   <th>Last Modified By</th>
   <td>$data[lastEditor]</td></tr>
<tr>
   <th>Last Modifed</th>
   <td>$data[lastModified]</td></tr>
<tr>
   <th>Closed By</th>
   <td>$data[approver]</td></tr>
<tr>
   <th>Close Date</th>
   <td>$data[closeDate]</td></tr>
</table>
EOT;

}

switch($disp) {

   case "create":
      create_exception( $eid, $incident_id, $hostip, $hostname, $type, $os, $comments, $justification, 
      	 $secRqmts, $plugin, $port, $submitDate );
      break;

   case "new":
      new_exception( $host_id, $incident_id );
      break;

   case "edit":
      edit_exception ( $eid );
      break;

   case "del":
      delete_exception( $eid );
      break;

   case "update":
      update_exception( $eid, $save, $port, $os, $hostname, $hostip, $justification, $comments, $secRqmts, $type );
      break;

   case "view":
      view_exception ( $eid );
      break;

   default:
      list_exceptions ( $view );
      break;
}



require_once('footer.php');
?>
