<?php
//
// $Id: respdf.php,v 1.11 2006/09/19 04:57:00 airwofl Exp $
//

/***********************************************************/
/*                    Inprotect                            */
/* --------------------------------------------------------*/
/* Copyright (C) 2006 Inprotect                            */
/*                                                         */
/* This program is free software; you can redistribute it  */
/* and/or modify it under the terms of version 2 of the    */
/* GNU General Public License as published by the Free     */
/* Software Foundation.                                    */
/* This program is distributed in the hope that it will be */
/* useful, but WITHOUT ANY WARRANTY; without even the      */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE. See the GNU General Public License  */
/* for more details.                                       */
/*                                                         */
/* You should have received a copy of the GNU General      */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 59 Temple Place, */
/* Suite 330, Boston, MA 02111-1307 USA                    */
/*                                                         */
/* Contact Information:                                    */
/* inprotect-devel@lists.sourceforge.net                   */
/* http://inprotect.sourceforge.net/                       */
/***********************************************************/
/* See the README.txt and/or help files for more           */
/* information on how to use & config.                     */
/* See the LICENSE.txt file for more information on the    */
/* License this software is distributed under.             */
/*                                                         */
/* This program is intended for use in an authorized       */
/* manner only, and the author can not be held liable for  */
/* anything done with this program, code, or items         */
/* discovered with this program's use.                     */
/***********************************************************/
#error_reporting(E_ALL);

define('FPDF_FONTPATH','inc/font/');
require('inc/InproTable.php');

require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
//include ('permissions.inc.php');


//php4 version of htmlspecialchars_decode which is only available in php5 upwards
if (!function_exists('htmlspecialchars_decode'))
{
   function htmlspecialchars_decode($str)
   {
      $str = preg_replace("/&gt;/",">",$str);
      $str = preg_replace("/&lt;/","<",$str);
      $str = preg_replace("/&quot;/","\"",$str);
      $str = preg_replace("/&#039;/","'",$str);
      $str = preg_replace("/&amp;/","&",$str);

      return $str;
   }
}

logAccess( "GENERATED EXECUTIVE SUMMARY" );


ini_set("max_execution_time","360");
ini_set("memory_limit","128M");

//Generated date
$gendate = gen_strtotime("now", "");

//here you can set the preference for the table colors
$sec_fill_color = array(0,0,0);
$sec_text_color = 255;
$head_fill_color = array(255,255,255);
$head_text_color = 0;

$fill_color = array(255,255,255);
$text_color = 0;
$line_color = array(0,0,0);
$boarder_type = 1; #doesn't work yet, there's always a full boarder for now

//row height for the table
$row_height = 5;

set_time_limit(300);
//start pdf file, add page, set font
$pdf = new PDF();
$pdf->AddPage();
$pdf->SetFont('Helvetica', 'B', 15);
$pdf->Cell(0, 9, "$company Vulnerability Executive Summary", 1, 1, 'C', 0);

$pdf->SetFont('Helvetica', '', 10);
$pdf->Cell(0, 6, "Project Name: $company Vulnerability Assessment", 1, 1, 'C', 0);
$pdf->Cell(95,6,"Audit: Safe (Non Destructive)",1,0,'C');
$pdf->Cell(95,6,"Generated: $gendate",1,1,'C');

#$pdf->Ln();

$pdf->SetFont('Helvetica', '', 10);

//get current possition so we can put the pie chart to the side
$valX = $pdf->GetX();
$valY = $pdf->GetY();
$riskarray = array(); //array of risks for pie chart
$colorarray=array(); //array of colors for pie chart

$query = "SELECT count(distinct t4.hostIP)
   FROM I3_subnets t1 
      LEFT JOIN I3_jobs t2 ON t1.CIDR = t2.fk_name AND 
         ( t2.scan_SUBMIT >= t1.dtLastScanned OR t1.report_id = t2.report_id )
      LEFT JOIN nessus_reports t3 on t1.report_id=t3.report_id
      LEFT JOIN nessus_results t4 on t3.report_id = t4.report_id
   WHERE t1.status != 'available' and t1.serial_flag='N'";

$result=$dbconn->execute($query);
list ( $syscount ) = $result->fields;


$query = "SELECT sum( t3.vSerious ) as vSerious, sum( t3.vHigh ) as vHigh, sum( t3.vMed ) as vMed, 
   sum( t3.vLow ) as vLow
   FROM I3_subnets t1 
      LEFT JOIN I3_jobs t2 ON t1.CIDR = t2.fk_name AND 
         ( t2.scan_SUBMIT >= t1.dtLastScanned OR t1.report_id = t2.report_id )
      LEFT JOIN nessus_report_stats t3 on t2.report_id = t3.report_id
   WHERE t1.status != 'available' and t1.serial_flag='N'";

$result=$dbconn->execute($query);

while ($row = $result->fields) {
   $arrTotals = array( 1=>$row['vSerious'], 2=>$row['vHigh'], 3=>$row['vMed'], 6=>$row['vLow'] );
   $result->MoveNext();
}


 $pdf->SetFont('Helvetica', 'B', 10);
 $pdf->Cell(0, 6, "Total number of vulnerabilities identified on $syscount  system(s)",0,1,'C');
 $pdf->Rect(10,31,190,60);
 $pdf->Ln();
 $pdf->SetFont('Helvetica', '', 10);
   #$pdf->Rect(100, 200, 130, 140, DF);

 $index = 0;

 foreach($arrTotals as $key=>$value) {
    if ( $value > 0 ) {
       $pdf->MultiCell(70, 6, "".getrisk($key)." : $value" ,0,0,'C');
       $riskArray [getrisk($key)] = $value;
       $colorarray[$index] = getriskcolor($key);
       $index++;
   }
  }


//make pie chart and put current possition below

$pdf->Ln();


$pdf->SetXY(85, 38); #$valY);
$pdf->PieChart(140, 40, $riskArray, '%l', $colorarray);
$pdf->SetXY($valX, $valY + 40);


//Host-Vulnerability Summary
$pdf->Ln();
$pdf->Ln();
$pdf->Ln();
$pdf->Ln();
$pdf->Ln();

#CODE TO SHOW THE OVERVIEW OF THE SITES
$pdf->SetFillColor(0,0,0);
$pdf->SetTextColor(255,255,255);
$pdf->SetFont('Helvetica', 'B', 12);
$pdf->Cell(50, 6, 'Breakdown by Site', 1, 0, 'L',1);
$pdf->SetFont('Helvetica', '', 8);   
$pdf->Cell(0, 6, 'Site, Location is based on data provided from the NNOC',1,1, 'L', 1);

$pdf->SetFont('Helvetica', '', 9);      
//Vulnerability table configs
$cols = array('Site','Host Count','Serious','High', 'Medium', 'Low');

//widths for columns
$width_array=array(50,36,26,26,26,26);


$query = "SELECT t1.ORG, sum(t3.iHostCnt) as HostCount, sum(t3.vSerious) as Serious, sum(t3.vHigh) as High, sum(t3.vMed) as Med, sum(t3.vLow) as Low
   FROM I3_subnets t1
      LEFT JOIN I3_jobs t2 ON t1.CIDR = t2.fk_name AND 
         ( t2.scan_SUBMIT >= t1.dtLastScanned OR t1.report_id = t2.report_id )
      LEFT JOIN nessus_report_stats t3 on t2.report_id = t3.report_id 
   WHERE t1.status != 'available' and t1.serial_flag='N' GROUP by t1.ORG";

$result=$dbconn->execute($query);

while ($row = $result->fields) {
   $all_results[] = $row;
   $result->MoveNext();
}

//build table
$pdf->InprotectTable($cols, $all_results, $width_array, $head_fill_color, $head_text_color, 
      $fill_color, $text_color, $line_color, $boarder_type, $row_height);

unset( $all_results);

$pdf->Ln();

$pdf->AddPage();
$pdf->SetFillColor(0,0,0);
$pdf->SetTextColor(255,255,255);
$pdf->SetFont('Helvetica', 'B', 12);
$pdf->Cell(0, 6, 'Top 10 Vulnerabilities (By Risk)', 1, 0, 'L',1);

$pdf->SetFillColor(255,255,255);
$pdf->SetTextColor(0,0,0);
$pdf->Ln();


#$query = "SELECT distinct risk 
#   FROM nessus_results
#   WHERE risk < 7
#   ORDER BY risk";

$arrRisks = array("1", "2", "3", "6");
   #AND username='$username' 
#$result=$dbconn->execute($query);

#while($row = $result->fields($result)) {
foreach ( $arrRisks as $riskval ) {

   $pdf->SetFont('Helvetica', 'B', 10);
   $pdf->Cell(0, 6, getrisk($riskval), 1, 1, 'L',1);

   unset ($arrVulns);

    $query_risks="SELECT t4.Name, count( t3.scriptid ) AS vcount
   FROM I3_subnets t1
      LEFT JOIN I3_jobs t2 ON t1.CIDR = t2.fk_name AND 
         ( t2.scan_SUBMIT >= t1.dtLastScanned OR t1.report_id = t2.report_id )
      LEFT JOIN nessus_results t3 ON t2.report_id = t3.report_id
      LEFT JOIN plugins AS t4 ON t4.id = t3.scriptid
      WHERE $sql_component_filter t1.status != 'available' and t1.serial_flag='N' AND 
         t3.risk = $riskval AND t3.scriptid <> '' AND t3.falsepositive <> 'Y'
         AND t3.scriptid <>10180
      GROUP BY t3.scriptid
      ORDER BY vcount DESC 
      LIMIT 0 , 10";

    $result_risks = $dbconn->execute($query_risks);

   while( $row = $result_risks->fields ) {
   	  $row[0] = substr($row[0], 0, 90);
      $arrVulns[] = $row;
      $result_risks->MoveNext();
   }

   $cols = array('Name','Count');

   //widths for columns
   $width_array=array(150,40);

   $pdf->SetFont('Helvetica', '', 7);

   //build table
   $pdf->InprotectTable($cols, $arrVulns, $width_array, $head_fill_color, $head_text_color, 
         $fill_color, $text_color, $line_color, $boarder_type, $row_height - 1 );

   $pdf->Ln();


} //Endo fo While



$pdf->Ln();
#$pdf->Cell(0,6, 'TNS2 - A product of Clutch-Inc',0, 1, 'C', 0);

$today = date("Ym");
//header("Content-disposition:  attachment; filename=scanresults-$uid-$scantime.pdf");
$pdf->Output("Executive_Summary_$today.pdf","I");

header('Content-Type: application/pdf');

//matches risks number with colors
function getriskcolor($risk)
{
switch ($risk)
{
case 1:
$risk=array(255,0,0);
break;
case 2:
$risk=array(255,127,0);
break;
case 3:
$risk=array(255,255,0);
break;
case 4:
$risk=array(255,255,0);
break;
case 5:
$risk=array(255,255,0);
break;
case 6:
$risk=array(0,139,69);
break;
case 7:
$risk=array(100,149,237);
break;
}
return $risk;
}

?>

