<?php
/*
 * Common functions that can be used by any PHP page.
 * It keeps the code cleaner
 */

// sanitize the form input
function sanitize($input) {
   $output = $tmp = "";
   if(get_magic_quotes_gpc()) {
      $tmp = stripslashes(trim($input));
   } else {
      $tmp = $input;
   }
   $output = mysql_real_escape_string($tmp);
   $output = htmlspecialchars( $output , ENT_QUOTES);
   return $output;
}

function dispSQLError($err, $errNum) {
   echo "<table class='error'>
         <tr><th> $errNum SQL Errors<th></tr>\n";
   foreach($err as $e) {
      echo "<tr><td>$e</td></tr>\n";
   }
   echo "</table>\n";
}

function logAccess( $action ) {
    global $logh, $username, $dbconn;

    $protocol = $_SERVER['HTTPS'] == 'on' ? 'https' : 'http';
    /*** return the full address ***/
    $url = $protocol.'://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
    #$logh->log("$username : $url : Page accessed", PEAR_LOG_DEBUG);

    $query_log="insert into log (ip, username, url, action) values('$_SERVER[REMOTE_ADDR]','$username', '$url', '$action' )";
    $result_log=$dbconn->execute($query_log);

}

function getAddress() {
    /*** check for https ***/
    $protocol = $_SERVER['HTTPS'] == 'on' ? 'https' : 'http';
    /*** return the full address ***/
    return $protocol.'://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
 }

function online() {
  global $username, $dbconn;
  
  $uname="";
  
  $ip = $_SERVER['REMOTE_ADDR'];
  $guest = 0;
  
  if (isset($username)) {
    $uname = $username;
  }
  if ( $uname == "" ) {
    $uname = $ip;
    $guest = 1;
  }
  
  $past = time()-3600;
  $query = "DELETE FROM sessions WHERE time < '$past'";
  $dbconn->execute($query);

  $query = "SELECT time FROM sessions WHERE uname='$uname'";
  $result = $dbconn->execute($query);
  $ctime = time();
  if (!empty($uname)) {
    $uname = substr($uname, 0,25);
   list ( $match ) = $result->fields;
    if ( $match ) {
	 $dbconn->execute("UPDATE sessions SET uname='$uname', time='$ctime', host_addr='$ip', 
	 	guest='$guest' WHERE uname='$uname'");
    } else {
	 $dbconn->execute("INSERT INTO sessions (uname, time, host_addr, guest
	 	) VALUES ('$uname', '$ctime', '$ip', '$guest')");
    }
  }
}

function getUserRoles ($user) {
   global $dbconn;
   $finalroles = array();
   // get users roles, used for access control decisions
   //  user roles are a union of the users individually assigned roles
   //  and any roles assigned based on user group membership
   // get the roles from group memebership for the user
   $query = "SELECT r.roleName
             FROM users as u
             LEFT JOIN user_groups as ug ON u.pn_uname = ug.pn_uname
             LEFT JOIN group_roles as gr ON ug.gid = gr.gid
             LEFT JOIN roles as r ON gr.roleID = r.roleID
             WHERE u.pn_uname = '$user'";
   $groles = $dbconn->GetArray($query);
   if($groles === false) {
      $errMsg[] = "SQL Error getting user groups: " . $dbconn->ErrorMsg();
      $error = 1;
   } else {
      foreach($groles as $role) {
         $finalroles[$role['roleName']] = TRUE;
      }
   }

   // now get any directly assigned roles
   $query = "SELECT r.roleName
             FROM users as u
             LEFT JOIN user_roles as ur ON u.pn_uname = ur.pn_uname
             LEFT JOIN roles as r ON ur.roleID = r.roleID
             WHERE u.pn_uname = '$user'";
   $uroles = $dbconn->GetArray($query);
   if($uroles === false) {
      $errMsg[] = "SQL Error getting users roles: " . $dbconn->ErrorMsg();
      $error++;
   } else {
      foreach($uroles as $role) {
         $finalroles[$role['roleName']] = TRUE;
      }
   }
   
   // now set the other roles to FALSE in the array
   $query = "SELECT roleName
             FROM roles";
   $roles = $dbconn->GetArray($query);
   if($roles === false) {
   }  else {
      foreach($roles as $role) {
         $finalroles[$role['roleName']] = (isset($finalroles[$role['roleName']])) ? TRUE : FALSE;
      }
   }
   return $finalroles;
}

function getSiteCodes ($user) {
   global $dbconn;
   $finalsites = array();
   // get users associated sites, used for access control decisions
   //  user sites are a union of the users individually assigned site_access
   //  and any sites assigned based on user group membership
   // get the roles from group memebership for the user
   // allowing tasks such as report admin / self service / scanning / etc
   // for the associated address space

   $query = "SELECT t1.site_code as siteName
          FROM I3_sites t1
               LEFT JOIN I3_org_sites t2 on t1.id = t2.siteID
               LEFT JOIN I3_org_users t3 on t2.orgID = t3.orgID
          WHERE t3.pn_uname = '$user'";

   
   
   $usites = $dbconn->GetArray($query);
   if($usites === false) {
      $errMsg[] = "SQL Error getting users sites: " . $dbconn->ErrorMsg();
      $error++;
   } else {
      foreach( $usites as $site ) {
         $finalsites[$site['siteName']] = TRUE;
      }
   }
   
   return $finalsites;
}

function getUserSystems ($user) {
   global $dbconn;
   $finalsystems = array();
   // get users associated sites, used for access control decisions
   //  user sites are a union of the users individually assigned site_access
   //  and any sites assigned based on user group membership
   // get the roles from group memebership for the user
   // allowing tasks such as report admin / self service / scanning / etc
   // for the associated address space

   $query = "SELECT t1.acronym
          FROM I3_systems t1
               LEFT JOIN I3_system_users t2 on t1.id = t2.sysID
          WHERE t2.pn_uname = '$user'";

   
   
   $usystems = $dbconn->GetArray($query);
   if($usystems === false) {
      $errMsg[] = "SQL Error getting users sytems: " . $dbconn->ErrorMsg();
      $error++;
   } else {
      foreach( $usystems as $system ) {
         $finalsystems[$system['acronym']] = TRUE;
      }
   }
   
   return $finalsystems;
}


function getUserOrg ($user) {
   global $dbconn;

   // get users associated org, used for access control decisions
   //  user sites are a union of the users individually assigned site_access
   //  and any sites assigned based on user group membership
   // get the roles from group memebership for the user
   // allowing tasks such as report admin / self service / scanning / etc
   // for the associated address space

   $query = "SELECT t1.org_code
          FROM I3_orgs t1
               LEFT JOIN I3_org_users t2 on t1.id = t2.orgID
          WHERE t2.pn_uname = '$user'";

   $result=$dbconn->execute($query);

   list ( $org_code ) = $result->fields;

   return "$org_code";

}

function getProfileName ($sid) {
   global $dbconn;

   $query = "SELECT name, description FROM nessus_settings 
      WHERE id='$sid' LIMIT 1";

   $result=$dbconn->execute($query);

   list ( $pname, $pdesc ) = $result->fields;

   return "$pname - $pdesc";

}

function inArray ($tmpItem, $tmpArray) {
   $found=0;

   for ($i=0; $i<count($tmpArray); $i++) {
      if ($tmpItem==$tmpArray[$i]) {
         $found=1;
         break;
      }
   }

   if ($found) { return 1; }
   else { return 0; }
}

function checkPass($pass) {
   global $minLength, $maxLength, $minAlpha, $minLower, $minUpper, $minSpecial, $minNumber;

   $lAlpha = '#[a-z]#'; //"abcdefghijklmnopqrstuvwxyz";
   $uAlpha = '#[A-Z]#'; //"ABCDEFGHIJKLMNOPQRSTUVWXYZ";
   $numbers = '#[0-9]#'; //'0123456789';
   $specials = '/[�!"�$%^&*()`{}\[\]:@~;\'#<>?,.\/\\-=_+\|]/';
   // moved to config.php
//   $minLength = 8;
//   $maxLength = 64;
//   $minAlpha = 1;
//   $minLower = 1;
//   $minUpper = 1;
//   $minSpecial = 1;
//   $minNumber = 1;

   $isValid = true;
   if($minLength > 0) {
      if(strlen($pass) < $minLength) { return "fail minLength"; }
      //echo "passed minLength\n";
   }
   if($maxLength > 0) {
      if(strlen($pass) > $maxLength) { return "fail maxLength"; }
      //echo "passed maxLength\n";
   }
   if($minAlpha > 0) {
      preg_match_all('#[a-z]#',$pass,$lmatches);
      preg_match_all('#[A-Z]#',$pass,$umatches);
      if((count($lmatches[0]) + count($umatches[0])) < $minAlpha) { return "fail minAlpha"; }
      //echo "passed minAlpha\n";
      //if(strspn($pass,$lAlpha.$uAlpha) < $minAlpha) { return false; }
   }
   if($minSpecial > 0) {
      preg_match_all($specials,$pass,$matches);
      if(count($matches[0]) < $minSpecial) { return "fail minSpecial"; }
      //echo "passed minSpecial\n";
      //if(strspn($pass,$specials) < $minSpecial) { return false; }
   }
   if($minNumber > 0) {
      preg_match_all('#[0-9]#',$pass,$matches);
      if(count($matches[0]) < $minNumber) { return "fail minNumber"; }
      //echo "passed minNumber\n";
      //if(strspn($pass,$numbers) < $minNumber) { return false; }
   }
   if($minUpper > 0) {
      preg_match_all('#[A-Z]#',$pass,$matches);
      if(count($matches[0]) < $minUpper) { return "fail minUpper"; }
      //echo "passed minUpper\n";
      //if(strspn($pass,$lAlpha) < $minUpper) { return false; }
   }
   if($minLower > 0) {
      preg_match_all('#[a-z]#',$pass,$matches);
      if(count($matches[0]) < $minLower) { return "fail minLower"; }
      //echo "passed minLower\n";
      //if(strspn($pass,$uAlpha) < $minLower) { return false; }
   }

   return "pass"; 
}

function getrisk($risk) {

    switch ($risk) {
    case 1:
            $risk="Serious";
        break;
    case 2:
        $risk="High";
        break;
    case 3:
        $risk="Medium";
        break;
    case 4:
        $risk="Medium/Low";
        break;
    case 5:
        $risk="Low/Medium";
        break;
    case 6:
        $risk="Low";
        break;
    case 7:
        $risk="Info";
        break;
    }

    return $risk;
}

function getcrisk($risk) {

    switch ($risk) {
    case 2:
        $risk="Failed";
        break;
    case 3:
        $risk="Error";
        break;
    case 6:
        $risk="Passed";
        break;
    }

    return $risk;
}

// Activate Hyperlinks in Msg to New Windows
function activateHyperlink($text) {
 // match protocol://address/path/file.extension?some=variable&another=asf%
 $text = preg_replace("/([a-zA-Z]+:\/\/[a-z0-9\_\.\-]+".
"[a-z]{2,6}[a-zA-Z0-9\/\*\-\?\&\%\=\,\.\_]+)/",
" <a href=\"$1\" target=\"_blank\">$1</a>", $text);
 // match www.something.domain/path/file.extension?some=variable&another=asf%
 $text = preg_replace("/[^a-z]+[^:\/\/](www\.".
"[^\.]+[\w][\.|\/][a-zA-Z0-9\/\*\-\?\&\%\=\,\.]+)/",
" <a href=\"http://$1\" target=\"_blank\">$1</a>", $text);
 // match name@address + ?subject etc...
$text = preg_replace(
 "/([\s|\,\>])([a-zA-Z][a-zA-Z0-9\_\.\-]*[a-z" .
 "A-Z]*\@[a-zA-Z][a-zA-Z0-9\_\.\-]*[a-zA-Z]{2,6})" .
 "([A-Za-z0-9\!\?\@\#\$\%\^\&\*\(\)\_\-\=\+]*)" .
 "([\s|\.|\,\<])/i",
 "$1<a href=\"mailto:$2$3\">$2</a>$4",
 $text);

 	return $text;
}

function hostLink($host, $ip, $type = "name", $edit = FALSE) {

   if($edit) {
      $edit = "disp=edit_host";
   } else {
      $edit = "disp=view";
   }
   
   // special case for unknown hostnames
   if(strstr($host,"unknown")) {
      $ip = substr($host,8);
      $url = "<a href='hosts.php?disp=add&hostip=$ip&disp=add' onClick=\"popup('hosts.php?hostip=$ip','Add Host');return false;\" title='Add host'>Unknown</a>";
      return $url;
   }

   // blank hostname and ip
   if($host == "" && $ip == "") {
      $url = "<a href='hosts.php?$edit' onClick=\"popup('hosts.php?$edit','Lookup Host');return false;\" title='Lookup host'>All</a>";
      return $url;
   }

   if($type == "name") {
      $url = "<a href='hosts.php?$edit&hostname=$host&hostip=$ip' onClick=\"popup('hosts.php?$edit&hostname=$host&hostip=$ip','Lookup Host');return false;\" title='Lookup host'>$host</a>";
   } else { // IP address
      // do special check for multiple IP addresses, comma separated
      $ips = explode(",",$ip);
      foreach($ips as $v) {
         $url[] = "<a href='hosts.php?$edit&hostname=$host&hostip=$v' onClick=\"popup('hosts.php?$edit&hostname=$host&hostip=$v','Lookup IP');return false;\" title='Lookup IP'>$v</a> ";
      }
      $url = implode($url,",");
   }
   return $url;
}

function validateip($ip) {
    $retip=0;

    if (ereg('^([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])$',$ip,$r)) {
        $ip1=intval($r[1])*16777216+intval($r[2])*65536+intval($r[3])*256+intval($r[4]);
        if ($ip1<>0) {
            $retip=1;
        }
    } elseif (ereg('^([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])-([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])$',$ip,$r)) {

        $ip1=intval($r[1])*16777216+intval($r[2])*65536+intval($r[3])*256+intval($r[4]);
        $ip2=intval($r[5])*16777216+intval($r[6])*65536+intval($r[7])*256+intval($r[8]);

        if ($ip2>$ip1 and $ip1<>0) {
            $retip=1;
        }
    }
    return($retip);
}

// function to check if the submitted IP address is in an allowed Network Zone
// that the user has rights to scan.
function inrange($ip, $dbconn) {
    $check=0;
    // check for single IP address, and split it into the octets
    if (ereg('^([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])$',$ip,$r)) {

        $ip1=intval($r[1])*16777216+intval($r[2])*65536+intval($r[3])*256+intval($r[4]);
        $ip2=0;

        if ($ip1<>0) {
            $check=1;
        }
    // check for range of IP address, and split them into the two sets of
    // octets (for ip1 and ip2)
    } elseif (ereg('^([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])-([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])\.([0-9]{1,2}|[01][0-9]{2,3}|2[0-4][0-9]|25[0-5])$',$ip,$r)) {

        $ip1=intval($r[1])*16777216+intval($r[2])*65536+intval($r[3])*256+intval($r[4]);
        $ip2=intval($r[5])*16777216+intval($r[6])*65536+intval($r[7])*256+intval($r[8]);

        if ($ip2>$ip1 and $ip1<>0) {
            $check=1;
        }
    }

    if ($check==1) {
        // get the username
        $uname=htmlspecialchars(mysql_escape_string(trim($_SESSION['user'])), ENT_QUOTES);
        $found=0;

        // get the ranges for all the Network Zones that the user has
        // access to so we can check to see if the IP(s) are in one of them.
        $query="SELECT range_start, range_end 
                FROM nessus_zone_ranges 
                INNER JOIN nessus_user_zones 
                   ON nessus_user_zones.zid=nessus_zone_ranges.zoneid 
                WHERE nessus_user_zones.username='$uname'";

        $result=$dbconn->execute($query);

        while(!$result->EOF) {

            list($range_start, $range_end)=$result->fields;

            $rip1=0;
            $rip2=0;

            // single IP, range that is a single IP as well
            if ($ip2==0 and $range_start==$range_end) {
                $rip1=$range_start;

                if ($rip1==$ip1) {
                    $found=1;
                    break;
                }
            }

            // if this is a valid range (start is before end)
            if ($range_start<$range_end) {

                $rip1=$range_start;
                $rip2=$range_end;

                // for a single IP, see if it's between the start and the end
                // (inclusive)
                // or for a range, the starting IP and ending IP have to both
                // be between the start and end (inclusive)
                if (($ip1>=$rip1 and $ip1<=$rip2 and $ip2==0) 
                     or ($ip1>=$rip1 and $ip2<=$rip2 and $ip2<>0)) {
                    $found=1;
                    break;
                }
            }
            $result->MoveNext();
        }
        return($found);
    } else {
        return(0);
    }
}

function range2List ( $istart, $iend ) {
     
     // generate ip addrs
     $arry1 = explode(".",$istart);
     $arry2 = explode(".",$iend);

     $a1 = $arry1[0]; $b1 = $arry1[1]; $c1 = $arry1[2]; $d1 = $arry1[3];
     $a2 = $arry2[0]; $b2 = $arry2[1]; $c2 = $arry2[2]; $d2 = $arry2[3];

     $result = array();     
     while( $d2 >= $d1 || $c2 > $c1 || $b2 > $b1 || $a2 > $a1){
          if($d1 > 255){
               $d1 = 1;
               $c1 ++;
          }

          if($c1 > 255){
               $c1 = 1;
               $b1 ++;
          } 

          if($b1 > 255){
               $b1 = 1;
               $a1 ++;
          } 

          #echo "$a1 $b1 $c1 $d1 <br>";
          array_push($result, $a1. "." .$b1. "." .$c1. "." .$d1 );
          $d1 ++;
     }
     
     return $result;
}

function gen_strtotime($value, $newformat) {

	if ( !defined( $value ) || $value == "now" ) {
      #NOW
      $arrTime = localtime(time(), true);
      $year = 1900 + $arrTime["tm_year"];
      $mon = 1 + $arrTime["tm_mon"];
      $mday =  $arrTime["tm_mday"];
      $hour = $arrTime["tm_hour"];
      $min = $arrTime["tm_min"];
      $sec = $arrTime["tm_sec"];	
   } else { # A VALUE WAS PASSED
       if (strlen($value) != 14) {
          return $value;
        }
        $year=substr($value,0,4);
        $mon=substr($value,4,2);
        $mday=substr($value,6,2);
        $hour=substr($value,8,2);
        $min=substr($value,10,2);
        $sec=substr($value,12,2);
   }

   if ( $newformat == "asdate" ) {
      $value2 = sprintf("%02d/%02d/%04d %02d:%02d:%02d", $mon, $mday, $year, $hour, $min, $sec);
   } else {	#SQL FORMAT
      $value2 = sprintf("%04d-%02d-%02d %02d:%02d:%02d",$year, $mon, $mday, $hour, $min, $sec);
   }
   return $value2;

}

function gen_timeasstr() {
	
	$arrTime = localtime(time(), true);
	
	$year = 1900 + $arrTime["tm_year"];
	$mon = 1 + $arrTime["tm_mon"];
	$mday =  $arrTime["tm_mday"];
	$hour = $arrTime["tm_hour"];
	$min = $arrTime["tm_min"];
	$sec = $arrTime["tm_sec"];
	
	
	$ltime = sprintf("%04d%02d%02d%02d%02d%02d",$year, $mon, $mday, $hour, $min, $sec);
	
	return $ltime;
}

function datediff($interval, $date1, $date2)
{

   //convert the dates into timestamps
  $date1 = strtotime($date1);
  $date2 = strtotime($date2);
  $seconds = $date2 - $date1;

   if ($seconds < 0)
   {
           $tmp = $date1;
           $date1 = $date2;
           $date2 = $tmp;
           $seconds = 0-$seconds;
   }

   //reconvert the timestamps into dates
   if ($interval =='y' || $interval=='m') {
       $date1 = date("Y-m-d h:i:s", $date1);
       $date2=  date("Y-m-d h:i:s", $date2);
   }

   switch($interval) {
       case "y":
           list($year1, $month1, $day1) = split('-', $date1);
           list($year2, $month2, $day2) = split('-', $date2);
           $time1 = (date('H',$date1)*3600) + (date('i',$date1)*60) + (date('s',$date1)
);
           $time2 = (date('H',$date2)*3600) + (date('i',$date2)*60) + (date('s',$date2)
);
           $diff = $year2 - $year1;

           if($month1 > $month2) {
               $diff -= 1;
           } elseif($month1 == $month2) {
               if($day1 > $day2) {
                   $diff -= 1;
               } elseif($day1 == $day2) {
                   if($time1 > $time2) {
                       $diff -= 1;
                   }
               }
           }
           break;
       case "m":
           list($year1, $month1, $day1) = split('-', $date1);
           list($year2, $month2, $day2) = split('-',$date2);
           $time1 = (date('H',$date1)*3600) + (date('i',$date1)*60) + (date('s',$date1)
);
           $time2 = (date('H',$date2)*3600) + (date('i',$date2)*60) + (date('s',$date2)
);
           $diff = ($year2 * 12 + $month2) - ($year1 * 12 + $month1);
           if($day1 > $day2) {
               $diff -= 1;
           } elseif($day1 == $day2) {
               if($time1 > $time2) {
                   $diff -= 1;
               }
           }
           break;
       case "w":
           // Only simple seconds calculation needed from here on
           $diff = floor($seconds / 604800);
           break;
       case "d":
           $diff = floor($seconds / 86400);
           break;
       case "h":
           $diff = floor($seconds / 3600);
           break;
       case "n":
           $diff = floor($seconds / 60);
           break;
       case "s":
           $diff = $seconds;
           break;
   }

   return $diff;
} 

function addException($hostip,$res,$plugin,$schedid,$hostname) {
   return "<br><a href='exceptions.php?disp=new&hostip=$hostip&sid=$schedid&plugin=$plugin&hostname=$hostname&rid=$res' target='_blank'>Add Exception</a>";
}

function printException($hostip, $plugin, $dbconn, $excel = FALSE, $hostname = "",
                        $port = "", $sid ) {
   //$esubmit = ( strpos($_SESSION['roles'],"esubmit") ) === false ? FALSE : TRUE;
   $esubmit = $_SESSION['roles']['esubmit'];
   if ($hostip == "") {
      return "No IP specified to locate exceptions.";
   }
   // modified to look for exceptions that include the specific IP as
   //  well as any that are tagged for "ALL" hosts, not "Rejected" 
   //  exceptions, though.
   $equery="select eid, status, hostip, submitDate
            from exceptions
            where ( hostip LIKE '%$hostip%' OR hostip = 'ALL' )
               and plugin = '$plugin'
               and status <> 'Rejected'";
   if (is_numeric($port)) {
      $equery .= " and ( port = " . intval($port) . " OR port IS NULL )"; 
   }
   $eresult=$dbconn->execute($equery);
   if(!$eresult) { 
      return $dbconn->ErrorMsg(); 
   } else {
      $resArray = $eresult->GetArray();
      if (count($resArray) > 0) {
         foreach($resArray as $num=>$resData) {
            if($excel) {
               $foo .= "$resData[eid] - $resData[submitDate] - $resData[status]\n";
            } else {
               $foo .= "<a href='exceptions.php?disp=view&eid=$resData[eid]' title='View Exception' onClick=\"popup('exceptions.php?disp=view&eid=$resData[eid]','ViewException');return false;\">";
               $foo .= "$resData[eid]</a> - $resData[submitDate] - $resData[status]<br>\n";
            }
         }
      } else {
         $foo = "No Exceptions on file.";
         if($esubmit && !$excel) {
            $foo .= "<br><a href='exceptions.php?disp=new&hostip=$hostip&sid=$sid&plugin=$plugin&hostname=$hostname&port=$port' target='_blank'>Add Exception</a>";
         }
      }
      return $foo;
   }
}

function arrPortResultsCompare ($arrA, $arrB)
{
   if ($arrA[1]==$arrB[1]) { return 0; }
   return $arrA[1]>$arrB[1] ? 1 : -1;
}

function arrScanResultsCompare ($arrA, $arrB)
{
   global $sortby;

   if ($sortby==1) {
# Sort by port (tcp first, then udp) followed by risk (highest first)
      if (($arrA[1]==$arrB[1]) && ($arrA[2]==$arrB[2])) {
         if ($arrA[4]==$arrB[4]) { return 0; }
         if ($arrA[4]<$arrB[4]) { return -1; }
         if ($arrA[4]>$arrB[4]) { return 1; }
      }
      if (($arrA[1]==$arrB[1]) && ($arrA[2]>$arrB[2])) { return 1; }
      if (($arrA[1]==$arrB[1]) && ($arrA[2]<$arrB[2])) { return -1; }
      return $arrA[1]>$arrB[1] ? 1 : -1;
   } else {
# Sort by risk (highest first) followed by port (tcp first, then udp)
      if ($arrA[4]==$arrB[4]) {
         if (($arrA[1]==$arrB[1]) && ($arrA[2]==$arrB[2])) { return 0; }
         if (($arrA[1]==$arrB[1]) && ($arrA[2]>$arrB[2])) { return 1; }
         if (($arrA[1]==$arrB[1]) && ($arrA[2]<$arrB[2])) { return -1; }
         if ($arrA[1]>$arrB[1]) { return 1; }
         if ($arrA[1]<$arrB[1]) { return -1; }
      }
      return $arrA[4]>$arrB[4] ? 1 : -1;
   }
}

function make_link ($type,$data) {
   switch ($type) {
   case 'exception':
      return "<a href='editException.php?op=view&eid=$data'>$data</a>";
      break;
   default:
      break;
   }
}

function drawForm($data, $action, $method = "POST") {
   $size = "";
   $maxsize = "";
   $cols = "";
   $rows = "";
   $onsubmit = "";

   if ( !empty($data) ) {
      if ( ! empty( $data['onsubmit'])) {
         $onsubmit = "onSubmit=\"$data[onsubmit]\"";

      }
      echo "<form action=\"$action\" method=\"$method\" $onsubmit>\n";
      echo "<table summary='$data[summary]'>\n";
      foreach ($data['fields'] as $name=>$fd) {
         echo "<tr><th>$name</th>\n";
         if(is_array($fd)) {
            switch($fd['type']) {
            case 'input':
               if(! empty( $fd['size'])) { $size = " size=".$fd['size']; } else { $size = ""; }
               if(! empty($fd['maxsize'])) { $mazsize = " maxsize=".$fd['maxsize']; }
               echo "<td><input name='$fd[name]' $size $maxsize value='".$fd['value']."'></input>\n";
               break;
            case 'select':
               // for a select, the "value" element of the array is an
               // array itself
               if(! empty($fd['multiple'])) {
                  echo "<td><select name='".$fd['name']."' multiple size=".$fd['multiple'].">\n";
               } else {
                  echo "<td><select name='".$fd['name']."'>\n";
               }
               if (! empty($fd['value'] )) {
                  foreach ($fd['value'] as $name=>$val) {
                     // if this is a one dimensional array, make the name = val
                     if($fd['nameIndex'] == 0) { $name = $val; }
                     // if we have a "selected" element in the array
                     if(is_array($fd['selected'])) {
                        if(in_array($name,$fd['selected'])) {
                           echo "<option value='$name' selected>$val</option>\n";
                        } else {
                           echo "<option value='$name'>$val</option>\n";
                        }
                     } elseif($name == $fd[selected]) {
                        echo "<option value='$name' selected>$val</option>\n";
                     } else {
                        echo "<option value='$name'>$val</option>\n";
                     }
                  }
               }
               echo "</select>\n";
               break;
            case 'twobox': // two-box select, you move the selected items
                           // between box A and box B to add/remove them
               // the "value" element of the array is an
               // array itself
               if($fd['id'] <> "") {
                  $fdid1 = "id='all_$fd[id]'";
                  $fdid2 = "id='$fd[id]'";
               }
               $tablehead = <<<EOT
<td>
<table summary='UserSelection'>
<tr>
<th>Available</th>
<th></th>
<th>Assigned</th></tr>
<tr><td>
EOT;
               $sel1 = "<select name='all_$fd[name]' $fdid1 multiple size=".$fd['multiple'].">\n";
               $sel2 = "<select name='".$fd['name']."' $fdid2 multiple size=".$fd['multiple'].">\n";
               // loop through all the entries in $fd[value] and populate
               // the select boxes
               foreach ($fd['value'] as $name=>$val) {
                  // if this is a one dimensional array, make the name = val
                  if($fd['nameIndex'] == 0) { $name = $val; }
                  // if we have a "selected" element in the array
                  if(is_array($fd['selected'])) {
                     // if it's in the "selected" array, do put it in the
                     // all_* select box
                     if(in_array($name,$fd['selected'])) {
                        $sel2 .= "<option value='$name'>$val</option>\n";
                     } else {
                        $sel1 .= "<option value='$name'>$val</option>\n";
                     }
                  } elseif($name == $fd['selected']) {
                     $sel2 .= "<option value='$name'>$val</option>\n";
                  } else {
                     $sel1 .= "<option value='$name'>$val</option>\n";
                  }
               }
               $sel1 .= "</select>\n";
               $sel2 .= "</select>\n";
               // draw the two move buttons
               $btns = "<input type='button' value='Add >>' onclick=\"move2(this.form.all_$fd[id],this.form.$fd[id])\">";
               $btns .= "<br/>";
               $btns .= "<input type='button' value='<< Remove' onclick=\"move2(this.form.$fd[id],this.form.all_$fd[id])\">";
               // output it all
               echo $tablehead;
               echo $sel1;
               echo "</td><td>";
               echo $btns;
               echo "</td><td>";
               echo $sel2;
               echo "</td></tr></table>";
               break;
            case 'textarea':
               if(! empty( $fd['cols'] )) { $cols = " cols=$fd[cols]"; }
               if(! empty( $fd['rows'] )) { $rows = " rows=$fd[rows]"; }
               echo "<td><textarea name='$fd[name]' $cols $rows>$fd[value]</textarea>\n";
               break;
            case 'timeinput':
               // timeinput is a special input class
               // we want to print out select boxes for the month, day and year
               // and have a text box for the hour:min
               //  see if we have been given a starting value and set the
               //  initial values accordingly
               if(isset($fd['value'])) {
                  list($dmy,$hms) = explode(" ",$fd['value']);
                  list($year,$mon,$day) = explode("-",$dmy);
                  list($hr,$min,$sec) = explode(":",$hms);
               }
               echo "<td>";
               echo "<select name='year'>\n";
               for($y=2007;$y<=2010;$y++){
                  if($y == $year) {
                     echo "<option value='$y' selected>$y</option>\n";
                  } else {
                     echo "<option value='$y'>$y</option>\n";
                  }
               }
               echo "</select>\n";
               echo "<select name='month'>\n";
               for($m=1;$m<=12;$m++) {
                  if($m == $mon) {
                     echo "<option value='$m' selected>$m</option>\n";
                  } else {
                     echo "<option value='$m'>$m</option>\n";
                  }
               }
               echo "</select>\n";
               echo "<select name='day'>\n";
               for($d=1;$d<=31;$d++) {
                  if($d == $day) {
                     echo "<option value='$d' selected>$d</option>\n";
                  } else {
                     echo "<option value='$d'>$d</option>\n";
                  }
               }
               echo "</select>\n";
               $time = ($time == "") ? "18:30" : "$hr:$min";
               echo "<input name='time' value='$time'></input>\n";
            }
            if(!empty($fd['comment'])) {
               echo "&nbsp;&nbsp;$fd[comment]";
            }
            echo "</td>\n";
         } else {
            echo "<td>$fd</td>\n"; 
         }
         echo "</tr>\n";
      }
      echo "</table>\n";
      // now draw the form buttons
      if ( ! empty( $data['buttons'])) {
         foreach($data['buttons'] as $name=>$fb) {
            switch ($fb['type']) {
               case 'submit':
                  echo "<input type='submit' name='$fb[name]' value='$fb[value]'></input>\n";
                  break;
            }
         }
      }
      // last, tack on any hidden fields
      if ( ! empty( $data['hidden'])) {
         foreach($data['hidden'] as $name=>$val) {
            echo "<input type='hidden' name='$name' value='$val'></input>\n";
         }
      }
      echo "</form>\n";
   }
}

function drawTable($map, $data, $summary = "") {
   echo "<table summary='$summary' width='100%'>";
   echo "<tr>";
   if ( !empty($map)) {
      foreach ($map as $fieldName=>$fieldValue) {
         if($fieldName != "Links") {
            // see if we need to create sorting links in the table headers
            if(is_array($fieldValue)) {
               $link = str_replace("%var%", $fieldValue['var'], $fieldValue['link']);
               echo "<th><a href='$link' text='Sort by $fieldName'>$fieldName</a></th>";
            } else {
               echo "<th>$fieldName</th>";
            }
         } else {
            echo "<th></th>";
         }
      }
   }
   echo "</tr>";
   if ( !empty($data)){
      foreach($data as $entry) {
         echo "<tr>";
         if ( !empty($map)){
            foreach($map as $fieldName=>$fieldValue) {
               if($fieldName != "Links") {
                  // some extra processing to allow custom links
                  if(is_array($fieldValue)) {
                     echo "<td>" . $entry[$fieldValue['var']] . "</td>";
                  } else {
                     echo "<td>$entry[$fieldValue]</td>";
                  }
               } else {
                  echo "<td>";
                  foreach($fieldValue as $linkName=>$linkData) {
                     $onclick = "";
                     if ( !empty ( $linkData['onclick'] )) { $onclick = "onclick='".$linkData['onclick']."'"; }
                     if ( !empty ( $linkData['target'] )) { $target = "target='".$linkData['target']."'"; }
                     $link = str_replace("%param%", $entry[$linkData['param']], $linkData['url']);
                     echo "<a href='" . $link . 
                        "' alt='" . $linkName . "' title='" . $linkName . 
                        "'><img src='" .  $linkData['icon'] . "' alt='" . 
                        $linkName . "' $onclick $target></img></a>&nbsp;";
                  }
                  echo "</td>";
               }
            }
         }
         echo "</tr>\n";
      }
   }
   echo "</table>";
}

?>
