<?php

$pageTitle = "Hosts";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');
//require_once('permissions.inc.php');
//require_once('adodb/tohtml.inc.php');

// number of hosts to show per page with viewing all
$pageSize = 50;

// check role to make sure user can view this page
/*
$admin = (strpos($_SESSION['roles'],"admin") === false) ? FALSE : TRUE;
$reports = (strpos($_SESSION['roles'],"reports") === false) ? FALSE : TRUE;
$esubmit = (strpos($_SESSION['roles'],"esubmit") === false) ? FALSE : TRUE;
$eapprove = (strpos($_SESSION['roles'],"eapprove") === false) ? FALSE : TRUE;
$eview = (strpos($_SESSION['roles'],"eview") === false) ? FALSE : TRUE;
*/

if (!($uroles['admin'] || $uroles['eview'] || $uroles['esubmit'] 
      || $uroles['eapprove'] || $uroles['reports'])) {
  // oops, shouldn't be here
  echo "Insufficient rights to view this page.";
  require_once('footer.php');
  // should do this better, but it'll work for now.
  die();
}

$getParams = array( "disp", "mac" , "hostname", "hostip", "op", "offset", "type", "os", "status",
                    "value", "scanstate", "ref", "sortby", "sortdir");
$postParams = array( "disp", "op", "mac" , "hostname", "hostip", "status", "contact", "os",
                     "description", "id", "scanstate");

$post = FALSE;

switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach($getParams as $gp) {
	   if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else {
         $$gp = "";
      }
   }
	break;
case "POST" :
   $post = TRUE;
   foreach($postParams as $pp) {
      if (isset($_POST[$pp])) {
        $$pp=htmlspecialchars(mysql_real_escape_string(trim($_POST[$pp])), ENT_QUOTES);
      } else {
        $$pp = "";
      }
   }
	break;
}

if(isset($offset)) {
   if(!is_numeric($offset)) {
      $offset=0;
   }
} else {
   $offset=0;
}

// add a new entry
function save_new ( $mac, $hostname, $hostip, $status, $os, $contact, $description ) {
   global $dbconn;

   $now = gen_strtotime("now", "");

   $insert = "insert into hosts ( hostip, hostname, status, os, contact, description, scanstate, createdate 
      ) values ( 
        '$hostip', '$hostname', '$status', '$os', '$contact', '$description', 'Pending Scan', '$now' );";

   if (! $dbconn->execute($insert) === false ) {
     if ( $mac ) { 
        $query = "SELECT id FROM hosts Where hostip='$hostip' AND hostname='$hostname' LIMIT 1;";
        $result = $dbconn->execute($query);
        list($hostid) = $result->fields;

        $query = "INSERT INTO host_macs ( host_id, mac_address, hostip, createdate ) VALUES (
           '$hostid', '$mac', '$hostip', '$now' );";
        #$result = $dbconn->execute($query);

     }
     echo "New host added.<br>";
     logAccess( ": Added new host record ($hostip)" );
   } else { // need error handling here
     echo "There was an error creating the new record.<br>";
     echo $dbconn->ErrorMsg();
   }
   //echo "<p>Return to the <a href='" . $_SERVER['PHP_SELF'] . 
   //     "'>hosts table</a>.";
   if($ref <> "") {
      echo "Return to the <a href='$ref'>calling page</a>.";
   }

   list_hosts (  );

}

function save_existing ( $hostip, $hostname, $status, $os, $contact, $description ) {
   global $dbconn;


   $update = "update hosts set hostip = '$hostip', hostname = '$hostname',
                status = '$status', os = '$os', description = '$description',
                contact = '$contact' ";
   // only admin or eapprove can change to Passed state.
   // admin and eapprove can change to any state 
   if ($uroles['admin']) {
      $update .=", scanstate = '$scanstate' ";
   // esubmit can change to any state except Pending Exceptions or Passed
   } elseif ($scanstate != "Passed" && $scanstate != "Pending Exceptions") {
      $update .= ", scanstate = '$scanstate' ";
   }
   $update .= "where id = '$id'";
//echo "<PRE>$update</PRE>";
   if($dbconn->execute($update) === false ) {
      $errMsg[] =  "There was an error updating the record: " . 
                   $dbconn->ErrorMsg();
      dispSQLError($errMsg,1);
   } else {
      echo "<p>Record updated successfully.</p>";
      $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                  ": Updated host record ($id)", PEAR_LOG_DEBUG);
   }
   echo "<p>Return to the <a href='" . $_SERVER['PHP_SELF'] . 
        "'>hosts table</a>.</p>";
}

function add_host (  ) {
   global $serverStateArray, $dbconn;

   echo "<H3>Hosts</H3>";

   $formFields = array ( "Mac Address" => array( "name" => "mac",
                                              "type" => "input",
                                              "size" => 20,
                                              "value" => $mac),
                         "Hostname" => array( "name" => "hostname",
                                              "type" => "input",
                                              "size" => 32,
                                              "value" => $hostname),
                         "IP Address" => array( "name" => "hostip",
                                                "type" => "input",
                                                "size" => 32,
                                                "value" => $hostip),
                         "O/S" => array( "name" => "os",
                                                "type" => "input",
                                                "size" => 32,
                                                "value" => $os),
                         "Status" => array( "name" => "status",
                                                "type" => "select",
                                                "nameIndex" => 0,
                                                "value" => $serverStateArray,
                                                "selected" => $status),
                         "Description" => array( "name" => "description",
                                                "type" => "input",
                                                "size" => 60,
                                                "maxsize" => 255,
                                                "value" => ""),
                         "Contact" => array( "name" => "contact",
                                                "type" => "input",
                                                "size" => 50,
                                                "value" => ""),
                         "Scan State" => "Pending Scan");

      $formButtons = array( "Submit" => array( "name" => "submit",
                                               "type" => "submit",
                                               "value" => "Save"));
      $formHidden = array( "disp" => "save_new",
                           "ref" => $ref );
      $formData = array( "summary" => "Create Host Entry",
                         "fields" => $formFields,
                         "hidden" => $formHidden,
                         "buttons" => $formButtons);
      drawForm($formData,$_SERVER['PHP_SELF']);
}

function edit_host ( $hostname, $hostip  ) {
   global $hostScanStateArray, $uroles, $dbconn;

   if( $op == "edit" && ( isset($hostname) || isset($hostip) ) &&
         ($uroles['admin'] || $uroles['esubmit'] || $uroles['eapprove']) ) {
      $query="SELECT hostip, hostname, os, status, description, 
         contact, id, acrSystem, subSystem, scanstate
         from hosts";
      if(isset($hostname) && isset($hostip)) {
         $host = strtolower($hostname);
         $query .= " where hostname = '$hostname' AND hostip = '$hostip' order by hostname";
      } elseif (isset($hostip)) {
         $query .= " where hostip = '$hostip' order by INET_ATON(hostip) ASC ";
      } elseif (isset($hostname)) {
         $query .= " where hostname = '$hostname' order by hostname ";
      }
      $result=$dbconn->execute($query);
      echo "query=$query<br>";
      $data = $result->fields;
      echo <<<EOT
<form action="hosts.php" method="post">
<table summary="Edit Host" width="75%" border=1 cellspacing="0" cellpadding="2">
<tr>
   <th>Hostname</th>
   <td><input name='hostname' value='$data[hostname]'></td></tr>
<tr>
   <th>IP</th>
   <td><input name='hostip' value='$data[hostip]'></td></tr>
<tr>
   <th>O/S</th>
   <td><input name='os' value='$data[os]' size='32'></td></tr>
<tr>
   <th>Status</th>
   <td><input name='status' value='$data[status]' size='32'></td></tr>
<tr>
   <th>Description</th>
   <td><input name='description' value='$data[description]' size='100' maxlength='255'></td></tr>
<tr>
   <th>Contact</th>
   <td><input name='contact' value='$data[contact]' size='32'></td></tr>
<tr>
   <th>System</th>
EOT;

      $query = "SELECT acronym FROM I3_systems Where Active='1' AND parent='SELF'";
      $result = $dbconn->execute($query);

      if($uroles['admin'] ) {
         echo "<td><select name='acronym'><option value='' SELECTED>No Assoc System</option>";
         while(list($acro) = $result->fields ) {
      	    if ( $acro == "??" ) { $acro = "None"; }
            if( $data['acrSystem'] == $acro ) {
               echo "<option value='$acro' SELECTED>$acro</option>";
            } else {
               echo "<option value='$acro'>$acro</option>";
            }
            $result->MoveNext();
         }
         echo "</td></tr>";
      } else {
         echo "<td>".$data['acrSystem']."</td></tr>";
      }

      echo <<<EOT
   <th>Scan State</th>
EOT;

      if($uroles['admin'] || $uroles['esubmit'] || $uroles['eapprove']) {
         echo "<td><select name='scanstate'>";
         foreach ($hostScanStateArray as $ss) {
            if($data['scanstate'] == $ss) {
               echo "<option value='$ss' SELECTED>$ss</option>";
            } else {
               // only admin or exception approver can change state to Passed
               if($ss == "Passed" && ($uroles['admin'] || $uroles['eapprove'])) {
                  echo "<option value='$ss'>$ss</option>";
               } elseif ($ss != "Passed") {
                 echo "<option value='$ss'>$ss</option>";
               }
            }
         }
         echo "</td></tr>";
      } else {
         echo "<td>".$data['scanstate']."</td></tr>";
      }
      echo <<<EOT
</table>
<input type="hidden" name="disp" value="save_edit">
<input type="hidden" name="id" value="$data[id]">
<input type="submit" name="submit" value="Save">
</form>
EOT;
   }

}

function list_hosts ( $type, $value, $scanstate, $sortby, $sortdir ) {
   global $offset, $pageSize, $hostScanStateArray, $dbconn;

   if ($sortby == "" ) { $sortby = "hostname"; }
   if ($sortdir == "" ) { $sortdir = "ASC"; }
   
   echo "<H3>Hosts</H3>";

   $viewAll = FALSE;
   $querys="SELECT hostip, hostname, os, status, description,
              contact, id, scanstate, lastscandate
           from hosts";
   // set up the SQL query based on the search form input (if any)
   switch($type) {
   case "hostip":
      $q = $value;
      $queryw = " where hostip LIKE '%$q%' order by INET_ATON(hostip) $sortdir";
      $stext =  "Search for hostip = '*$q*'";
      break;
   case "hostname":
      $q = strtolower($value);
      $queryw = " where hostname LIKE '%$q%' order by $sortby $sortdir";
      $stext =  "Search for name = '*$q*'";
      break;
   case "contact":
      $q = strtolower($value);
      $queryw = " where contact LIKE '%$q%' order by $sortby $sortdir";
      $stext = "Search for contact = '*$q*'";
      break;
   case "os":
      $q = strtolower($value);
      $queryw = " where os LIKE '%$q%' order by $sortby $sortdir";
      $stext = "Search for Operating System = '*$q*'";
      break;
   case "status":
      $q = strtolower($value);
      $queryw = " where status LIKE '%$q%' order by $sortby $sortdir";
      $stext = "Search for status = '*$q*'";
      break;
   case "scanstate":
      $queryw = " where scanstate = '$scanstate' order by $sortby $sortdir";
      $stext = "Search for scanstate = '$scanstate'";
      break;
   default:
      $viewAll = TRUE;
      $queryw = " order by $sortby $sortdir";
      // add the limit for the paging
      $queryw .= " limit $offset,$pageSize"; 
      $stext = "Viewing all Hosts";
      break;
   }

   // put link to add new host
   echo "<p>";
   echo $stext;
   echo " | <a href='hosts.php?disp=add' alt='Add New Host'>Add New Host</a>";
   echo "</p>";
   // echo the search criteria used

   // set up the pager and search fields if viewing all hosts
   $hostCount = 0;
   if($viewAll) {
      $hostCount = $dbconn->GetOne("SELECT count(hostip) FROM hosts");
      $previous = $offset - $pageSize;
      if ($previous < 0) {
         $previous = 0;
      }
      $last = $hostCount - $pageSize;
      if ( $last < 0 ) { $last = 0; }
      $next = $offset + $pageSize;
      if ($next > $last) {
         $next = $last;
      }
      $pageEnd = $offset + $pageSize;
      echo "<p>There are $hostCount hosts defined in the system.";
      // output the search form
      echo <<<EOT
<!--<form name="hostSearch" onSubmit="return OnSubmitForm();">-->
<form name="hostSearch" action="hosts.php" method="GET">
<input type="text" length="25" name="value">
<input type="radio" name="type" value="hostip">IP
<input type="radio" name="type" value="name" checked>Name
<input type="radio" name="type" value="os">OS
<input type="radio" name="type" value="status">Status
<input type="radio" name="type" value="contact">Contact
<input type="radio" name="type" value="scanstate">Scan State
<select name="scanstate">
EOT;
      foreach ($hostScanStateArray as $ss) {
         echo "<option value='$ss'>$ss</option>";
      }
      echo <<<EOT
</select>
<input type="hidden" name="sortby" value="$sortby">
<input type="hidden" name="sortdir" value="$sortdir">
<input type="hidden" name="op" value="search">
<input type="submit" name="submit" value="Find">
</form>
</p>
EOT;
      // output the pager
      echo "<p align=center><a href='hosts.php?offset=0' class='pager'>&lt&lt First</a> | ";
      if($offset != 0) {
         echo "<a href='hosts.php?offset=$previous' class='pager'>&lt Previous </a> | ";
      }
      if($pageEnd >= $hostCount) { $pageEnd = $hostCount; }
      echo "[ $offset - $pageEnd of $hostCount ] | ";
      if($next < $last) {
         echo "<a href='hosts.php?offset=$next' class='pager'>| Next &gt;</a> | ";
      }
      echo "<a href='hosts.php?offset=$last' class='pager'> Last &gt;&gt;</a></p>";
   } else {
      // get the search result count
      $queryc = "SELECT count(id)
                 FROM hosts ";
      $scount=$dbconn->GetOne($queryc.$queryw);
      echo "<p>$scount host";
      if($scount != 1) {
         echo "s";
      } else {
      }
      echo " found matching search criteria | "; 
      echo " <a href='hosts.php' alt='View All Hosts'>View All Hosts</a></p>";
   }

   // get the hosts to display
   $result=$dbconn->GetArray($querys.$queryw);
   if($result === false) {
      $errMsg[] = "Error getting hosts: " . $dbconn->ErrorMsg();
      $error++;
      dispSQLError($errMsg,$error);
   } else {
      $tdata = array();
      foreach($result as $data) {
         $data['hlink'] = hostLink($data['hostname'],$data['hostip'],'name',true);
         $data['ilink'] = hostLink($data['hostname'],$data['hostip'],'hostip',true);
         $tdata[] = $data;
      }
      if($sortdir == "ASC") { $sortdir = "DESC"; } else { $sortdir = "ASC"; }
      $url = $_SERVER['PHP_SELF'] . "?offset=$offset&sortby=%var%&sortdir=$sortdir";
      $fieldMap = array( "Hostname" => array( 'var' => 'hostname',
                                              'link' => $url ),
                         "IP" => array( 'var' => 'hostip',
                                        'link' => $url ),
                         "O/S" => array( 'var' => 'os',
                                         'link' => $url ),
                         "Status" => array( 'var' => 'status',
                                            'link' => $url ),
                         "Description" => array( 'var' => 'description',
                                                 'link' => $url ),
                         "Contact" => array( 'var' => 'contact',
                                             'link' => $url ),
                         "Scan State" => array( 'var' => 'scanstate',
                                                'link' => $url ),
                         "Last Scan Date" => array( 'var' => 'lastscandate',
                                                     'link' => $url ),
                         "Links" => array( "Search for Results" => array(
                                                'url' => 'search.php?submit=Search&hostname=%param%&search_by_name=1&showInfo=1&showLatestOnly=1',
                                                'param' => 'hostname',
                                                'icon' => 'images/zoom.png')));
      drawTable($fieldMap, $tdata, "Hosts");

   }

   // draw the pager again, if viewing all hosts
   if($viewAll) {
      echo <<<EOT
<p align=center>
<a href="hosts.php?offset=0" class="pager">&lt&lt First</a>
<a href="hosts.php?offset=$previous" class="pager">&lt Previous </a>
<a href="hosts.php?offset=$next" class="pager">| Next &gt;</a>
<a href="hosts.php?offset=$last" class="pager"> Last &gt;&gt;</a>
</p>
EOT;
   }
}

switch($disp) {

   case "add":
      add_host( );
      break;

   case "edit_host":
      edit_host($hid);
      break;

   case "save_new":
      save_new ( $mac, $hostname, $hostip, $status, $os, $contact, $description );
      break;

   default:
      list_hosts( $type, $value, $scanstate, $sortby, $sortdir );
      break;

}


require_once('footer.php');
?>
