<?php
//
// $Id: login.php,v 1.7 2006/09/19 04:57:00 airwofl Exp $
//

require_once('config.php');
require_once('functions.inc');

$wrongpasswd=0;
$locked=0;
$post_user="";
$referer="";
$errMsg = "";

#NEW CODE TO HANDLE LOCKOUT THRESHHOLDS
if ( $lockout_threshold > 5 ) { $lockout_threshold = 3; }
if ( $lockout_duration < 5 ) { $lockout_duration = 30; }


switch ($_SERVER['REQUEST_METHOD'])
{
   case "POST" :
      if (isset($_POST['user'])) { 
         $post_user=htmlspecialchars(mysql_real_escape_string(trim($_POST['user'])), ENT_QUOTES); 
         // convert to lowercase
         //$post_user = strtolower($post_user)
      }
      if (isset($_POST['referer'])) { 
         $referer=htmlspecialchars((trim($_POST['referer'])), ENT_QUOTES); 
      } else { 
         unset($referer);
      }
      // make a md5 checksum of the password.
      if (isset($_POST['pass'])) { 
         $post_pass = md5($_POST['pass']); 
      }
      if(isset($post_pass) && isset($post_user)) {
         $loginUser = TRUE;
      } else {
         $loginUser = FALSE;
         $errMsg = "Missing username and/or password";
      }
      $ldapAuthFailed = FALSE;
      $ldapFailed = FALSE;
      break;
   case "GET" :
//      if (isset($_SERVER['HTTP_REFERER'])) {
//         $referer = $_SERVER['HTTP_REFERER'];
//      } else
      if (isset($_GET['url'])) {
         $referer = htmlentities($_GET['url']);
      } else {
         unset($referer);
      }
      $loginUser = FALSE;
      break;
}
//$referer = $_SERVER['HTTP_REFERER'];

// should never get here, web server is handling the redirection to HTTPS
if ($enablessl==1 and $_SERVER['HTTPS'] != "on") {
    header ('Location: https://'.$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI']);
    die ("Non SSL mode is not supported");
};


// called with a POST, so we try and authenticate the user
if ($loginUser && empty($errMsg)) {

   $today=date("Ymd");

   if($authLDAP && empty($errMsg)) { // auth using LDAP
      $auth = FALSE;
      //$ds = ldap_connect($authLDAP_host, $authLDAP_port);
      $ds = ldap_connect($authLDAP_host);
      ldap_set_option($ds, LDAP_OPT_PROTOCOL_VERSION, 3);
      if($ds) {
         $r = ldap_bind($ds); // anonymous bind
         if(!$r) { // failed to bind
            $ldapFailed = TRUE;
         } else {
            // search for the user
            $lsf = "$authLDAP_searchAttr=$post_user";
            $asb = $authLDAP_searchBase . "," . $authLDAP_baseDN;
            $asr = explode(",",$authLDAP_searchResults);
            $lsr = ldap_search( $ds, $asb, $lsf, $asr); 
	    if($lsr == false) {
               $ldapFailed = TRUE;
               $errMsg = "Username not found in LDAP Directory";
	    } else {
               $le = ldap_first_entry($ds, $lsr);
	       if($le != false) {
                  $userDN = ldap_get_dn($ds, $le);
                  if (!empty($userDN)) { // found a result
                     $auth = ldap_bind($ds, $userDN, $_POST['pass']);
                     if($auth) {
                     } else {
                        $ldapAuthFailed = TRUE;
                        $errMsg = "LDAP BIND failed";
                     }
                  } else {
                     $ldapFailed = TRUE;
                     $errMsg = "Username not found in LDAP Directory (ldap_get_dn)";
                  }
	       } else {
                  $ldapFailed = TRUE;
                  $errMsg = "Username not found in LDAP Directory (ldap_first_entry)";

               }
	    }
         }
      } else {
         $ldapFailed = TRUE;
         $errMsg = "Unable to connect to LDAP Directory with anonymous bind";
      }
      ldap_unbind($ds);
   }

   // if not using LDAP or connect/search fails and configured for fall through
   if(!$authLDAP || ($ldapFailed && $authFailLocal)) {
      if($authFailLocal) { $errMsg .= " - falling through to local auth";}
      $query = "SELECT count(*) 
                FROM users 
                WHERE pn_pass='$post_pass' 
                   AND pn_uname='$post_user' 
                   AND ( locked < $lockout_threshold OR lockout_reset < now() )
                   and ( expire IS NULL OR 
                         expire='' OR
                         expire > '$today' )";
      $result=$dbconn->Execute($query);
   } elseif ($auth) { // authLDAP worked, need to do local authorization
      $query = "SELECT count(*) 
                FROM users 
                WHERE pn_uname = '$post_user' 
                   AND ( locked < $lockout_threshold OR lockout_reset < now() )
                   AND ( expire = '' OR 
                         expire > '$today')";
      $result=$dbconn->Execute($query);
   } else { // oops, this means we failed LDAP auth
      //echo $errMsg;
   }

   // login or authorization failed
   if ($result === false || ($authFailLocal && $ldapAuthFailed)) {
       logAccess( $post_user . " : " . $_SERVER['PHP_SELF'] . " : Incorrect username, expired, or locked account" );
       $errMsg = "Incorrect username or password.";
   }
   list($num) = $result->fields;

   if (!$num) {
      if ($post_user<>"") {
         logAccess($post_user ." : " . $_SERVER['PHP_SELF'] . " : Invalid password attempt" );

         $query="update users 
                 set locked=locked+1 
                 where pn_uname='$post_user'";
         $result=$dbconn->execute($query);

         $query="select locked, pn_email 
                 from users 
                 where pn_uname='$post_user'";
         $result=$dbconn->execute($query);
         list ($locked, $lemail)=$result->fields;

         // locked account
         if ($locked>=$lockout_threshold) {
            logAccess($post_user ." : " . $_SERVER['PHP_SELF'] . " : Attempted login to locked account" );

            $query="update users set lockout_reset= now() + INTERVAL $lockout_duration MINUTE
                 where pn_uname='$post_user'";
            $result=$dbconn->execute($query);

            $msg="InProtect account has been locked due to a number 
                  of bad login attempts, please urgently contact your system 
                  or security administrator.";
            $subject="ATTENTION: InProtect account locked";
            mail($lemail, $subject, $msg);
   
            // get the email address for admin notifications
            $query = "SELECT settingValue FROM inprotect_settings WHERE settingName = 'admin_notifications'";
            $notify_email= $dbconn->GetOne($query);
   
            $msg="InProtect account for $post_user ($lemail) has 
                  been locked due to a number of bad login attempts, it may 
                  indicate a possible brute force attempt on this account.
   
                  As an administrator you can unlock the account using 
                  InProtect User Management page. You may also wait for the lockout 
                  duration counter to reset.";
            $subject="ATTENTION: InProtect account locked";
   
            mail($notify_email, $subject, $msg);
   
         }
         $wrongpasswd=1;
         // check for wrong passord condition
         if ($wrongpasswd && $locked<$lockout_threshold) { 
            $errMsg = "Incorrect username / password - please try again.";
         }
         // oops, the user locked their account
         if ($locked>=$lockout_threshold) {
            $errMsg = "Your account is locked. Please contact an administrator."; 
         }
      }
   } else {
      $errMsg = "";
   }
}

if (!empty($errMsg) || !$loginUser) {
   if ( !$siteLogo ) { $siteLogo = "images/logo-blue.png"; }
   // display the login form
   echo <<<EOT
<html>
<head>
<TITLE>InProtect - Login Page</Title>
<link rel="stylesheet" type="text/css" href="./css/inprotect.css" />
</head>

<script type="text/javascript" language="javascript">
function focuslogin()
{
   if (document.frm.user.focus) { document.frm.user.focus(); }
}
</script>
<body bgcolor="#FFFFFF" onload="focuslogin();">
<center>
<img src="$siteLogo" alt="Logo"><br>
<font size="1"><br><br>
<form action='$_SERVER[PHP_SELF]' method='post' name="frm">
<table summary="Enter login details">
<tr>
   <td> Username: </td>
   <td><input type="text" name="user" default></td>
</tr>
<tr>
   <td>Password:</td>
   <td><input type="password" name="pass"></td>
</tr>
</table>
<br>
EOT;

   if(isset($referer)) {
      echo '<input type="hidden" name="referer" value="'.$referer.'">';
   }


   if(!empty($errMsg)) {
      echo "<FONT COLOR='#FF0000'><B>$errMsg</B></FONT><br><br>"; 
   }

   echo <<<EOT
<input type='submit' value='User Login'>
</form>
<br>
<br>
<br>
<br>
<table border="0">
<tr>
<td align="center"><font size="3">Host Checkup</font></td></tr>
<tr><td align="center">
<a href="checkup.php"><img src="images/checkup.jpg"><a/>
</td></tr>
<td align="center"><i><b>What is host checkup?</b> This is a new feature to provide<br> scan results for your current IP by hostname lookup<br>through means of reverse dns (IP to name).</i></td></tr>
</table>
</center>
</body>
</html>
EOT;

} else {

   // Start the login session
   session_start();

   // We've already added slashes and MD5'd the password
   $_SESSION['user'] = $post_user;
   $_SESSION['pass'] = $post_pass;
    
   // get the users roles and stick them in the session
   // get users roles, used for access control decisions
   //  user roles are a union of the users individually assigned roles
   //  and any roles assigned based on user group membership
   // get the group membership for the user
   /*
   $query = "SELECT groups
             FROM users
             WHERE pn_uname = '$post_user'
             LIMIT 1";
   $ugroups = $dbconn->GetOne($query);
   if($ugroupss === false) {
      echo "SQL Error getting user groups: " . $dbconn->ErrorMsg();
   } else {
      // now get the roles for the groups
      $query = "SELECT groupRoles
                FROM groups
                WHERE gid = ?";
      $stmt = $dbconn->Prepare($query);
      foreach(explode(",",$ugroups) as $group) {
         $groles = $dbconn->GetOne($stmt, array("$group"));
         if(!($groles === false)) {
            array_merge($uroles, explode(",",$groles));
         }
      }
   }
   $query = "SELECT role 
             FROM roles 
             WHERE pn_uname = '$post_user'";
   $results = $dbconn->GetArray($query);
   if($results === false) {
      echo "SQL Error getting users roles: " . $dbconn->ErrorMsg();
   } else {
      foreach($results as $role) {
         $uroles[] = $role[role];
      }
   }
   */
   //$uroles = getUserRoles($post_user, $dbconn);
   //$_SESSION['roles'] = implode('|',$uroles);
   //$_SESSION['roles'] = getUserRoles($post_user, $dbconn);
   $_SESSION['roles'] = getUserRoles($post_user);

   $query="update users set lastaccessed=now(), locked=0, lockout_reset=Null
               where pn_uname='$post_user'";
   $result=$dbconn->execute($query);

   // get users email and stick it in the session
   $query = "SELECT pn_email FROM users WHERE pn_uname='$post_user'";
   $result = $dbconn->execute($query);
   list($useremail) = $results->fields;
   $_SESSION['useremail'] = $useremail;

   logAccess($post_user ." : " . $_SERVER['PHP_SELF'] . " : SUCCESSFUL ACCOUNT LOGIN" );

   // All output text below this line will be displayed
   // to the users that are authenticated.

   // check if we have a referer, if so, redirect back to there
//   echo $referer;
   if(isset($referer)) {
     header('Location: ' . html_entity_decode($referer));
   } else {
     header('Location: index.php');
   }
}

?>
