<?php

$pageTitle = "Hosts";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');

//require_once('permissions.inc.php');
//require_once('adodb/tohtml.inc.php');

// number of hosts to show per page with viewing all
$pageSize = 50;

$isReportAdmin = ($uroles['admin'] || $uroles['reports']) ? TRUE : FALSE;

if ( $output != "printable" ) {
	require_once('header2.php');
}

$getParams = array( "disp", "op", "output", "scantime", "scantype", "reporttype", "key", 
   "sortby", "sortdir", "allres", "fp","nfp", "wh", "bg", "filterip", "critical", "increment" );
$postParams = array( "disp", "op", "output", "scantime", "type", "value",
    "scantype", "fp","nfp", "filterip", "critical", "increment"
              );

$post = FALSE;

switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach($getParams as $gp) {
	   if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else {
         $$gp = "";
      }
   }
	break;
case "POST" :
   $post = TRUE;
   foreach($postParams as $pp) {
      if (isset($_POST[$pp])) {
        $$pp=htmlspecialchars(mysql_real_escape_string(trim($_POST[$pp])), ENT_QUOTES);
      } else {
        $$pp = "";
      }
   }
	break;
}

if(isset($offset)) {
   if(!is_numeric($offset)) {
      $offset=0;
   }
} else {
   $offset=0;
}


function delete_results( $scantime, $scantype, $reporttype, $key, $sortby, $allres, $fp, $nfp, $op, $output, $wh, $bg ){
   global $enableDelProtect, $uroles, $sitename, $username, $dbconn;

   #POTENTIALLY ALL ORG MEMBERS DELETE SHARED REPORTS IN THE FUTURE
   if ( ! $uroles[admin] ) { $sql_filter = " AND username='$username'";  }
   $query = "SELECT report_id FROM nessus_reports where scantime='$scantime' AND scantype='$scantype' AND report_key='$key' $sql_filter";
   $result=$dbconn->execute($query);
   list( $report_id ) = $result->fields;
   echo "report_id=$report_id<br>";
   if ( ! $report_id ) {
      logAccess( "FAILED ATTEMPT TO DELETE REPORT [ $report_id ]" );
      die("Cannot access this page - unable to find report or possible error in the URL."); 
   } else {
      if ( $enableDelProtect ) {
         logAccess( "MAKR DELETED - REPORT [ $report_id ]" );
         $query = "UPDATE nessus_reports SET deleted= '1' WHERE report_id='$report_id' LIMIT 1";
         $result=$dbconn->execute($query);
      } else {
         logAccess( "DELETED - REPORT [ $report_id ]" );
         $query = "DELETE FROM nessus_results WHERE report_id='$report_id'";
         $result=$dbconn->execute($query);
         $query = "DELETE FROM nessus_report_stats WHERE report_id='$report_id'";
         $result=$dbconn->execute($query);
         $query = "DELETE FROM I3_jobs WHERE report_id='$report_id'";
         $result=$dbconn->execute($query);
         #CLEAR MOST RECENT SCAN FLAGS (QUESTIONABLY SHORE REMAIN)
         $query = "UPDATE I3_systems SET report_id='0' WHERE report_id='$report_id'";
         $result=$dbconn->execute($query);
         $query = "UPDATE I3_systems SET creport_id='0' WHERE creport_id='$report_id'";
         $result=$dbconn->execute($query);
         $query = "UPDATE I3_subnets SET report_id='0' WHERE report_id='$report_id'";
         $result=$dbconn->execute($query);
         $query = "UPDATE I3_subnets SET creport_id='0' WHERE creport_id='$report_id'";
         $result=$dbconn->execute($query);
         $query = "UPDATE hosts SET report_id='0' WHERE report_id='$report_id'";
         $result=$dbconn->execute($query);
         $query = "UPDATE hosts SET creport_id='0' WHERE creport_id='$report_id'";
         $result=$dbconn->execute($query);
         $query = "DELETE FROM host_stats WHERE report_id='$report_id'";
         $result=$dbconn->execute($query);

         $query = "DELETE FROM nessus_reports WHERE report_id='$report_id'";
         $result=$dbconn->execute($query);

      }
      echo "<font face=\"Verdana\" color=\"#666666\" size=\"2\">Vulnerability test results have been deleted.<BR></font>";
      echo "<br>";
      scans( $scantime, $scantype, $reporttype, $key, $sortby, $allres, $fp, $nfp, $op, $output, $wh, $bg );
   }
}


function list_results ( $type, $value, $scanstate, $sortby, $sortdir ) {
   global $isReportAdmin , $allres, $offset, $pageSize, $username, $dbconn;

   $filteredView = FALSE;

   $selRadio = array( "","","","");

   $query_onlyuser="";
   $url_filter="";

   if (!$isReportAdmin || (!$allres)) { $query_onlyuser=" AND t1.username='$username' "; }   

   if ($sortby == "" ) { $sortby = "scantime"; }
   if ($sortdir == "" ) { $sortdir = "DESC"; }

   echo "<H3>Reports</H3>";

   $queryw="";
   $queryl="";

   $querys="SELECT distinct t1.report_id, t1.name as jobname, t1.fk_name, t1.scantime,
      t1.username, t1.scantype, t1.report_key, t1.report_type, t3.name as profile, t4.id as jobid, t4.meth_SCHED,
      t5.vSerious, t5.vHigh, t5.vMed, t5.vLow, t5.vInfo
         FROM nessus_reports t1
      LEFT JOIN I3_subnets t2 on t1.fk_name = t2.CIDR 
      LEFT JOIN nessus_settings t3 ON t1.sid=t3.id
      LEFT JOIN I3_jobs t4 on t1.report_id = t4.report_id
      LEFT JOIN nessus_report_stats t5 on t1.report_id = t5.report_id
         WHERE t1.deleted = '0' ";

   // set up the SQL query based on the search form input (if any)
   switch($type) {
   case "scantime":
      $selRadio[0] = "CHECKED";
      $q = $value;
      $queryw = " AND t1.scantime LIKE '%$q%' $query_onlyuser order by $sortby $sortdir";
      $stext =  "Search for Date/Time = '*$q*'";
      $url_filter="&type=$type&value=$value";
      break;
   case "jobname":
      $selRadio[1] = "CHECKED";
      $q = strtolower($value);
      $queryw = " AND t1.name LIKE '%$q%' $query_onlyuser order by $sortby $sortdir";
      $stext =  "Search for Job Name = '*$q*'";
      $url_filter="&type=$type&value=$value";
      break;
   case "fk_name":
      $selRadio[2] = "CHECKED";
      $q = strtolower($value);
      $queryw = " AND t1.fk_name LIKE '%$q%' $query_onlyuser order by $sortby $sortdir";
      $stext = "Search for Subnet/CIDR = '*$q*'";
      $url_filter="&type=$type&value=$value";
      break;
   case "username":
      $selRadio[3] = "CHECKED";
      $q = strtolower($value);
      $queryw = " AND t1.username LIKE '%$q%' order by $sortby $sortdir";
      $stext = "Search for user = '*$q*'";
      $url_filter="&type=$type&value=$value";
      break;

   default:
      $selRadio[1] = "CHECKED";
      $viewAll = FALSE;
      $queryw = "$query_onlyuser order by $sortby $sortdir";
      $queryl = " limit $offset,$pageSize"; 
      $stext = "";
      break;
   }

   // put link to add new host

   if ($isReportAdmin) {
      $url_allres="&allres=";
      if ($allres=="" || !is_numeric($allres) || (!$allres)) {
         $allres=0;
         echo "<a href='results.php?offset=$next".$url_allres."1'>Show all results</a><br>";
      } else {
         $allres=1;
         echo "<a href='results.php?offset=$next".$url_allres."0'>Display only my Results</a><br>";
      }
      $url_allres .="$allres";
   }

   // echo the search criteria used

   // set up the pager and search fields if viewing all hosts
   $reportCount = 0;
   if(!$filteredView) {
      $queryc = "SELECT count(report_id) FROM nessus_reports t1 WHERE t1.deleted = '0' ";
      $reportCount = $dbconn->GetOne($queryc.$queryw);
      $previous = $offset - $pageSize;
      if ($previous < 0) {
         $previous = 0;
      }
      $last = $reportCount - $pageSize;
      if ( $last < 0 ) { $last = 0; }
      $next = $offset + $pageSize;
      if ($next > $last) {
         $next = $last;
      }
      $pageEnd = $offset + $pageSize;
      echo "<p>There are $reportCount scans defined in the system.";
      // output the search form
      echo <<<EOT
<!--<form name="hostSearch" onSubmit="return OnSubmitForm();">-->
<form name="hostSearch" action="results.php" method="GET">
<input type="text" length="25" name="value" value="$value">
EOT;
echo "
<input type=\"radio\" name=\"type\" value=\"scantime\" $selRadio[0]>Date/Time
<input type=\"radio\" name=\"type\" value=\"jobname\" $selRadio[1]>Job Name
<input type=\"radio\" name=\"type\" value=\"fk_name\" $selRadio[2]>Subnet Name
<input type=\"radio\" name=\"type\" value=\"username\" $selRadio[3]>Username
";
     echo <<<EOT
<input type="hidden" name="sortby" value="$sortby">
<input type="hidden" name="allres" value="$allres">
<input type="hidden" name="op" value="search">
<input type="submit" name="submit" value="Find">
</form>
</p>
EOT;
      // output the pager
      echo "<p align=center><a href='results.php?offset=0".$url_allres.$url_filter."' class='pager'>&lt&lt First</a> | ";
      if($offset != 0) {
         echo "<a href='results.php?offset=$previous".$url_allres.$url_filter."' class='pager'>&lt Previous </a> | ";
      }
      if($pageEnd >= $reportCount) { $pageEnd = $reportCount; }
      echo "[ $offset - $pageEnd of $reportCount ] | ";
      if($next < $last) {
         echo "<a href='results.php?offset=$next".$url_allres.$url_filter."' class='pager'>| Next &gt;</a> | ";
      }
      echo "<a href='results.php?offset=$last".$url_allres.$url_filter."' class='pager'> Last &gt;&gt;</a></p>";
   } else {
      // get the search result count
      $queryc = "SELECT count( report_id ) FROM nessus_reports WHERE t1.deleted = '0' ";
      $scount=$dbconn->GetOne($queryc.$queryw);
      echo "<p>$scount report";
      if($scount != 1) {
         echo "s";
      } else {
      }
      echo " found matching search criteria | "; 
      echo " <a href='results.php' alt='View All Reports'>View All Reports</a></p>";
   }

   echo "<p>";
   echo $stext;
   echo "</p>";
   
   // get the hosts to display
   $result=$dbconn->GetArray($querys.$queryw.$queryl);
   if($result === false) {
      $errMsg[] = "Error getting results: " . $dbconn->ErrorMsg();
      $error++;
      dispSQLError($errMsg,$error);
   } else {
      $tdata = array();
      foreach($result as $data) {
         $data['clink'] = "respdfc.php?scantime=".$data['scantime']."&scantype=".$data['scantype']."&key=".$data['report_key'];
         $data['hlink'] = "reshtml.php?disp=html&amp;output=full"
                ."&scantime=".$data['scantime']."&scantype=".$data['scantype'];
         $data['plink'] = "respdf.php?scantime=".$data['scantime']."&scantype=".$data['scantype']."&key=".$data['report_key'];
         $data['rerun'] = "sched.php?disp=rerun&job_id=".$data['jobid'];
         $data['xlink'] = "restext.php?scantime=".$data['scantime']."&scantype=".$data['scantype']."&key=".$data['report_key'];
         $tdata[] = $data;

      }

      if($sortdir == "ASC") { $sortdir = "DESC"; } else { $sortdir = "ASC"; }
      $url = $_SERVER['PHP_SELF'] . "?offset=$offset&sortby=%var%&sortdir=$sortdir".$url_allres.$url_filter;
      $fieldMap = array(
         "Links" => array( 
            "HTML Results" => array(
                     'url' => '%param%',
                   'param' => 'hlink',
                    'icon' => 'images/html.png'),
             "PDF Results" => array(
                     'url' => '%param%',
                   'param' => 'plink',
                    'icon' => 'images/pdf.png'),
           "EXCEL Results" => array(
                     'url' => '%param%',
                   'param' => 'xlink',
                    'icon' => 'images/page_white_excel.png'),
      "Compliance Results" => array(
                     'url' => '%param%',
                   'param' => 'clink',
                    'icon' => 'images/blue_pdf.png'),
              "Rerun Scan" => array(
                     'url' => '%param%',
                   'param' => 'rerun',
                    'icon' => 'images/repeat.png')),
               "Date/Time" => array( 'var' => 'scantime', 'link' => $url ),
               "Job Name"  => array( 'var' => 'jobname',  'link' => $url ),
      "System/Subnet Name" => array( 'var' => 'fk_name',  'link' => $url ),
                 "Profile" => array( 'var' => 'profile',  'link' => $url ),
                 "Serious" => array( 'var' => 'vSerious', 'link' => $url ),
                    "High" => array( 'var' => 'vHigh',    'link' => $url ),
                  "Medium" => array( 'var' => 'vMed',     'link' => $url ),
                     "Low" => array( 'var' => 'vLow',     'link' => $url ),
                    "Info" => array( 'var' => 'vInfo',    'link' => $url ));

      drawTable($fieldMap, $tdata, "Hosts");

   }

   // draw the pager again, if viewing all hosts
   if(!$filteredView) {
      echo "
<p align=center>
<a href=\"results.php?offset=0".$url_allres.$url_filter."\" class=\"pager\">&lt&lt First</a>
<a href=\"results.php?offset=$previous".$url_allres.$url_filter."\" class=\"pager\">&lt Previous </a>
<a href=\"results.php?offset=$next".$url_allres.$url_filter."\" class=\"pager\">| Next &gt;</a>
<a href=\"results.php?offset=$last".$url_allres.$url_filter."\" class=\"pager\"> Last &gt;&gt;</a>
</p>";
   }
}

switch($disp) {

   case "delete":
      delete_results( $scantime, $scantype, $reporttype, $key, $sortby, $allres, $fp, $nfp, $op, $output, $wh, $bg );
      break;
      
   default:
      list_results( $type, $value, $scanstate, $sortby, $sortdir );
      break;

}


require_once('footer.php');
?>
