<?php
//
// $Id: respdf.php,v 1.11 2006/09/19 04:57:00 airwofl Exp $
//

/***********************************************************/
/*                    Inprotect                            */
/* --------------------------------------------------------*/
/* Copyright (C) 2006 Inprotect                            */
/*                                                         */
/* This program is free software; you can redistribute it  */
/* and/or modify it under the terms of version 2 of the    */
/* GNU General Public License as published by the Free     */
/* Software Foundation.                                    */
/* This program is distributed in the hope that it will be */
/* useful, but WITHOUT ANY WARRANTY; without even the      */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE. See the GNU General Public License  */
/* for more details.                                       */
/*                                                         */
/* You should have received a copy of the GNU General      */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 59 Temple Place, */
/* Suite 330, Boston, MA 02111-1307 USA                    */
/*                                                         */
/* Contact Information:                                    */
/* inprotect-devel@lists.sourceforge.net                   */
/* http://inprotect.sourceforge.net/                       */
/***********************************************************/
/* See the README.txt and/or help files for more           */
/* information on how to use & config.                     */
/* See the LICENSE.txt file for more information on the    */
/* License this software is distributed under.             */
/*                                                         */
/* This program is intended for use in an authorized       */
/* manner only, and the author can not be held liable for  */
/* anything done with this program, code, or items         */
/* discovered with this program's use.                     */
/***********************************************************/
#error_reporting(E_ALL);

define('FPDF_FONTPATH','inc/font/');
require('inc/InproTable.php');

require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
//include ('permissions.inc.php');


//php4 version of htmlspecialchars_decode which is only available in php5 upwards
if (!function_exists('htmlspecialchars_decode'))
{
   function htmlspecialchars_decode($str)
   {
      $str = preg_replace("/&gt;/",">",$str);
      $str = preg_replace("/&lt;/","<",$str);
      $str = preg_replace("/&quot;/","\"",$str);
      $str = preg_replace("/&#039;/","'",$str);
      $str = preg_replace("/&amp;/","&",$str);

      return $str;
   }
}

switch ($_SERVER['REQUEST_METHOD']) {
   case "GET" :
      if (isset($_GET['site_code'])) { 
         $site_code=htmlspecialchars(mysql_escape_string(trim($_GET['site_code'])), ENT_QUOTES); 
      } else { $site_code=""; }
      break;
}

logAccess( "GENERATED SITE OVERVIEW REPORT FOR SITE [$site_code]" );

ini_set("max_execution_time","360");
ini_set("memory_limit","128M");

$query = "SELECT name, site_code FROM I3_sites WHERE site_code ='$site_code'";
$result = $dbconn->execute($query);
list( $vsite, $vsite_abbr ) = $result->fields;

if ( $vsite != "" ) {
   $vsite_sql = "t1.site_code = '$vsite_abbr' AND ";
} else {
   $vsite_sql = "";
   $vsite = "Entire LAN";
}
//Generated date
$gendate = gen_strtotime("now", "");

//here you can set the preference for the table colors
$sec_fill_color = array(0,0,0);
$sec_text_color = 255;
$head_fill_color = array(255,255,255);
$head_text_color = 0;

$fill_color = array(255,255,255);
$text_color = 0;
$line_color = array(0,0,0);
$boarder_type = 1; #doesn't work yet, there's always a full boarder for now

//row height for the table
$row_height = 5;

set_time_limit(300);
//start pdf file, add page, set font

$pdf = new PDF();
$pdf->AddPage();
$pdf->SetFont('Helvetica', 'B', 15);
if ( $vsite != "" ) {
   $pdf->Cell(0, 9, "$company_name Vulnerability [ $vsite ] Summary", 1, 1, 'C', 0);
   
} else {
   $pdf->Cell(0, 9, "$company_name  Vulnerability Summary by Site", 1, 1, 'C', 0);
}

$pdf->SetFont('Helvetica', '', 10);
$pdf->Cell(0, 6, "Project Name: $company_name  Vulnerability Assessment", 1, 1, 'C', 0);
$pdf->Cell(95,6,"Audit: Safe (Non Destructive)",1,0,'C');
$pdf->Cell(95,6,"Generated: $gendate",1,1,'C');

#$pdf->Ln();

$pdf->SetFont('Helvetica', '', 10);

//get current possition so we can put the pie chart to the side
$valX = $pdf->GetX();
$valY = $pdf->GetY();
$riskarray = array(); //array of risks for pie chart
$colorarray=array(); //array of colors for pie chart


$query = "SELECT count(distinct t4.hostIP)
   FROM I3_subnets t1 
      LEFT JOIN I3_jobs t2 ON t1.CIDR = t2.fk_name AND 
         ( t2.scan_SUBMIT >= t1.dtLastScanned OR t1.report_id = t2.report_id )
      LEFT JOIN nessus_reports t3 on t1.report_id=t3.report_id
      LEFT JOIN nessus_results t4 on t3.report_id = t4.report_id
   WHERE $vsite_sql t1.status != 'available' and t1.serial_flag='N'";
$result = $dbconn->execute($query);

list ( $syscount ) = $result->fields; 


if ( $syscount == 0 ) {
   #die ("Error 0 sys count");
   $pdf->SetFont('Helvetica', 'B', 10);
   $pdf->Cell(0, 6, "No system identified at $vsite_abbr",0,1,'C');
   $pdf->Ln();
   $pdf->Cell(0, 6, "PLEASE CONTACT $company Regarding THIS REPORT!",0,1,'C');
   $pdf->Ln();
   $pdf->Cell(0, 6, "Problem likely due to discrepencies in SITE / ORG & associated subnets.",0,1,'C');
   $pdf->Ln();
   $pdf->Cell(0, 6, "IF DR (JFO/DFO), maybe site is likely closed or newly stood up?",0,1,'C');
   $pdf->Rect(10,31,190,60);
   $pdf->Ln();

   $pdf->Output();
   exit;
}

$query = "SELECT sum( t3.vSerious ) as vSerious, sum( t3.vHigh ) as vHigh, sum( t3.vMed ) as vMed, sum( t3.vLow ) as vLow
   FROM I3_subnets t1 
      LEFT JOIN I3_jobs t2 ON t1.CIDR = t2.fk_name AND 
         ( t2.scan_SUBMIT >= t1.dtLastScanned OR t1.report_id = t2.report_id )
      LEFT JOIN nessus_report_stats t3 on t2.report_id = t3.report_id
   WHERE $vsite_sql t1.status != 'available' and t1.serial_flag='N'";
$result = $dbconn->execute($query);

while($row = $result->fields) {
   $arrTotals = array( 1=>$row['vSerious'], 2=>$row['vHigh'], 3=>$row['vMed'], 6=>$row['vLow'] );
   $result->MoveNext();
}


$pdf->SetFont('Helvetica', 'B', 10);
$pdf->Cell(0, 6, "Total number of vulnerabilities identified on $syscount  system(s)",0,1,'C');
$pdf->Rect(10,31,190,60);
$pdf->Ln();
$pdf->SetFont('Helvetica', '', 10);
   #$pdf->Rect(100, 200, 130, 140, DF);

$index = 0;

foreach($arrTotals as $key=>$value) {
   if ( $value > 0 ) {
      $pdf->MultiCell(70, 6, "".getrisk($key)." : $value" ,0,0,'C');
      $riskArray [getrisk($key)] = $value;
      $colorarray[$index] = getriskcolor($key);
      $index++;
   }
}


//make pie chart and put current possition below

$pdf->Ln();


$pdf->SetXY(85, 38); #$valY);
$pdf->PieChart(140, 40, $riskArray, '%l', $colorarray);
$pdf->SetXY($valX, $valY + 40);

//Host-Vulnerability Summary
$pdf->Ln();
$pdf->Ln();
$pdf->Ln();
$pdf->Ln();
$pdf->Ln();

#CODE TO SHOW THE OVERVIEW OF THE SITES
$pdf->SetFillColor(0,0,0);
$pdf->SetTextColor(255,255,255);
$pdf->SetFont('Helvetica', 'B', 12);
$pdf->Cell(50, 6, 'Breakdown by Subnet', 1, 0, 'L',1);
$pdf->SetFont('Helvetica', '', 8);   
$pdf->Cell(0, 6, 'Site, Location is based on data provided from the NNOC and/or AD - accuracy likely 90%',1,1, 'L', 1);
$pdf->Cell(0, 6, 'Data is presented starting with the highest risks down to least',1,1, 'L', 1);
$pdf->SetFont('Helvetica', '', 9);      
//Vulnerability table configs
$cols = array('Site', 'Location', 'Subnet Name','Host','Last Scanned','Time', 'Ser','High', 'Med', 'Low' );

//widths for columns
$width_array=array(25, 35, 34, 12,34,10,10,10,10,10 );

$query = "SELECT t1.site_code, SUBSTRING(t1.location,1, 12), t1.CIDR, t5.iHostCnt,
        t4.scantime, t5.iScantime, t5.vSerious, t5.vHigh, t5.vMed, t5.vLow
        FROM I3_subnets t1
           LEFT JOIN ( SELECT id, fk_name, scan_SUBMIT, report_id, max( scan_END )
                FROM I3_jobs WHERE job_TYPE = 'C' GROUP BY fk_name )t2 ON t1.CIDR = t2.fk_name AND (
                     t2.scan_SUBMIT >= t1.dtLastScanned OR t2.report_id = t1.report_id )
             LEFT JOIN I3_jobs t3 ON t3.id = t2.id
             LEFT JOIN nessus_reports t4 ON t1.report_id = t4.report_id
             LEFT JOIN nessus_report_stats t5 ON t4.report_id = t5.report_id
        WHERE $vsite_sql t1.status != 'available' and t1.serial_flag='N'
   ORDER BY (t5.vSerious * 2 + t5.vHigh) DESC";

$result = $dbconn->execute($query);

while($row = $result->fields) {
   $row[4] = gen_strtotime($row[4], "");
   $all_results[] = $row;
   $result->MoveNext();
}

if ( sizeof($all_results) > 0 ) {

   //build table
   $pdf->InprotectTable($cols, $all_results, $width_array, $head_fill_color, $head_text_color, 
         $fill_color, $text_color, $line_color, $boarder_type, $row_height);

   unset( $all_results);

   $pdf->Ln();
}


#TOP 10 OVERVIEW

if ( $vsite_abbr ) {
   $pdf->AddPage();
   $pdf->SetFillColor(0,0,0);
   $pdf->SetTextColor(255,255,255);
   $pdf->SetFont('Helvetica', 'B', 12);
   $pdf->Cell(0, 6, 'Top 10 Vulnerabilities (By Risk)', 1, 0, 'L',1);

   $pdf->SetFillColor(255,255,255);
   $pdf->SetTextColor(0,0,0);
   $pdf->Ln();



   $arrRisks = array("1", "2", "3", "6");
   #AND username='$username' 
   #$result = $dbconn->execute($query);

   #while($row = $result->fields) {
   foreach ( $arrRisks as $riskval ) {

      $pdf->SetFont('Helvetica', 'B', 10);

      $pdf->Cell(0, 6, getrisk($riskval), 1, 1, 'L',1);

      unset ($arrVulns);

      $query_risks="SELECT SUBSTRING(t4.name,1, 90), count( t3.scriptid ) AS vcount
        FROM I3_subnets t1
          LEFT JOIN I3_jobs t2 ON t1.CIDR = t2.fk_name AND 
           ( t2.scan_SUBMIT >= t1.dtLastScanned OR t1.report_id = t2.report_id )
	      LEFT JOIN nessus_results t3 ON t2.report_id = t3.report_id
    	  LEFT JOIN plugins AS t4 ON t4.id = t3.scriptid
      	WHERE $vsite_sql t1.status != 'available' and t1.serial_flag='N' AND 
          t3.risk = $riskval AND t3.scriptid <> '' AND t3.falsepositive <> 'Y'
          AND t3.scriptid <>10180
      GROUP BY t3.scriptid
      ORDER BY vcount DESC 
      LIMIT 0 , 10";


      $result_risks = $dbconn->execute($query_risks);

      while( $row = $result_risks->fields ) {
         $arrVulns[] = $row;
         $result_risks->MoveNext();
      }

      if ( sizeof($arrVulns) > 0 ) {
         $cols = array('Name','Count');

         //widths for columns
         $width_array=array(150,40);

         $pdf->SetFont('Helvetica', '', 7);

         //build table
         $pdf->InprotectTable($cols, $arrVulns, $width_array, $head_fill_color, $head_text_color, 
               $fill_color, $text_color, $line_color, $boarder_type, $row_height - 1 );

      }
      $pdf->Ln();
   } //Endo fo While

   $pdf->Ln();   
   
   #TOP 25 Vulnerable hosts
   
   $pdf->AddPage();
   $pdf->SetFillColor(0,0,0);
   $pdf->SetTextColor(255,255,255);
   $pdf->SetFont('Helvetica', 'B', 12);
   $pdf->Cell(0, 6, 'Top 25 Vulnerabile Hosts', 1, 0, 'L',1);

   $pdf->SetFillColor(255,255,255);
   $pdf->SetTextColor(0,0,0);
   $pdf->Ln();
         #AND t1.ORG = '$siteabbr'

      $query = "SELECT t4.hostIP, t4.hostname, count( t4.scriptid ) AS vcount
   FROM I3_subnets t1 
      LEFT JOIN I3_jobs t2 ON t1.CIDR = t2.fk_name AND 
         ( t2.scan_SUBMIT >= t1.dtLastScanned OR t1.report_id = t2.report_id )
      LEFT JOIN nessus_reports t3 on t1.report_id=t3.report_id
      LEFT JOIN nessus_results t4 on t3.report_id = t4.report_id
      	WHERE $vsite_sql t2.status = 'C'
AND t4.risk <= 2
GROUP BY hostIP
ORDER BY vcount DESC 
LIMIT 0 , 25";

   $result = $dbconn->execute($query );

   while($row = $result->fields) {
      $arrhosts[] = $row;
      $result->MoveNext();
   }

   if ( sizeof($arrhosts) > 0 ) {
      $cols = array('Host IP','Hostname', 'Count' );

      //widths for columns
      $width_array=array(50,50, 90);

      $pdf->SetFont('Helvetica', '', 7);

      //build table
      $pdf->InprotectTable($cols, $arrhosts, $width_array, $head_fill_color, $head_text_color, 
            $fill_color, $text_color, $line_color, $boarder_type, $row_height - 1 );

      $pdf->Ln();
   }

}


//output the pdf, now we're done$pdf-
#header('Content-Type: application/pdf');
if ( $mail_report )  {

   $repdate = date("Ym");
   $rep_nice_date = date("M Y");
   $report_name = $vsite_abbr ."_" . $repdate . ".pdf";   

   $pdfcontent = $pdf->Output($report_name, "S");

   require_once('Mail.php');
   require_once('Mail/mime.php');   

   $query = "SELECT t1.poc, t3.poc FROM I3_sites t1
      LEFT JOIN I3_org_sites t2 on t1.id = t2.siteID
      LEFT JOIN I3_orgs t3 on t2.orgID = t3.id
    WHERE t1.site_code='$vsite_abbr'";

   $result = $dbconn->execute($query);

   list( $site_poc, $org_poc ) = $result->fields;

   // email address of the recipient
   $to_list = "";

   if ( $site_poc ) {
      $to_list .= "$site_poc, ";
      logAccess( "MAILED SITE OVERVIEW REPORT FOR SITE [$site_code] TO [$site_poc]" );
   }
   if ( $org_poc ) {
      $pos = strrpos($to_list, $org_poc);
      if ($pos === false) { // note: three equal signs
         // not found...
         $to_list .= "$org_poc, ";
         logAccess( "MAILED SITE OVERVIEW REPORT FOR SITE [$site_code] TO [$org_poc]" );
      }
   }

   if ( $to_list == "" ) {
      $pos = strrpos($to_list, $adminmail);
      if ($pos === false) { // note: three equal signs
         // not found...
         $to_list .= "$adminmail, ";
      }
   }

   $pos = strrpos($to_list, $mailfrom);
   if ($pos === false) { // note: three equal signs
      // not found...
      $to_list .= "$mailfrom";
   }

   // subject of the email 
   $subject = "$rep_nice_date [ $vsite_abbr ] SITE OVERVIEW PREPARED BY FEMA-SOC"; 

   // email header format complies the PEAR's Mail class
   // this header includes sender's email and subject
   $headers = array('From' => $mailfrom, 
      'Subject' => $subject); 

   // We will send this email as HTML format
   // which is well presented and nicer than plain text
   // using the heredoc syntax
   // REMEMBER: there should not be any space after PDFMAIL keyword

   if ( $syscount == 0 ) {   
      echo "Nothing to report";

   } else {
   $htmlMessage = <<<PDFMAIL
   <html>
<body bgcolor="#ffffff"> 
<p align="center"> 
Attached is the $rep_nice_date [ $vsite_abbr ] Site Report.  Please address all Serious/High risks.
</p>
<p>&nbsp;</p><p>&nbsp;</p><p></p><p></p>
<p align="center"> 
WARNING: This document is FOR OFFICIAL USE ONLY (FOUO). It is to be controlled, stored, handled, transmitted, distributed, and disposed of in accordance with $company policy relating to FOUO information. This information shall not be distributed beyond the original addressees without prior authorization of the originator.
</p> 

</body> 
</html> 
PDFMAIL;

   // create a new instance of the Mail_Mime class
   $mime = new Mail_Mime(); 

   // set HTML content
   $mime->setHtmlBody($htmlMessage); 

   // IMPORTANT: add pdf content as attachment
   $mime->addAttachment($pdfcontent, 'application/pdf', $report_name, false, 'base64');

   // build email message and save it in $body
   $body = $mime->get(); 

   // build header
   $hdrs = $mime->headers($headers); 

   // create Mail instance that will be used to send email later
   $mail = &Mail::factory('mail'); 
   // Sending the email, according to the address in $to,
   // the email headers in $hdrs,
   // and the message body in $body.
   $mail->send($to_list, $hdrs, $body); 

   echo "Distributed Site report [ $vsite] to the following individuals: <p>$to_list</p>";

   $dbconn->execute( "UPDATE I3_sites SET report_sent='1' WHERE site_code='$vsite_abbr'");

   #$dbconn->execute("INSERT INTO TNS_log ( ip, username, action)
     #   VALUES ( '$ip', '$username', 'USER ACCESSED SITE REPORT [$vsite_abbr]' )");

   }

} else {
   $pdf->Output();

   $dbconn->execute("INSERT INTO TNS_log ( ip, username, action)
        VALUES ( '$ip', '$username', 'USER ACCESSED SITE REPORT [$vsite_abbr]' )");

}


//matches risks number with colors
function getriskcolor($risk)
{
switch ($risk)
{
case 1:
$risk=array(255,0,0);
break;
case 2:
$risk=array(255,127,0);
break;
case 3:
$risk=array(255,255,0);
break;
case 4:
$risk=array(255,255,0);
break;
case 5:
$risk=array(255,255,0);
break;
case 6:
$risk=array(0,139,69);
break;
case 7:
$risk=array(100,149,237);
break;
}
return $risk;
}

?>

