<?php

$pageTitle = "Top 10 Hosts";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');

// set up the user restrictions based on rights
$whereclause_user = " and t2.username = '$username'";
if($uroles['admin'] || $uroles['reports']) {
   $whereclause_user = "";
}

// array of possible date ranges
$allRanges = array( "all" => "All Time",
                    "7" => "Last 7 Days",
                    "14" => "Last 14 Days",
                    "30" => "Last 30 Days",
                    "60" => "Last 60 Days",
                    "90" => "Last 90 Days",
                    "180" => "Last 180 Days",
                    "365" => "Last Year"
                  );

$getParams = array( "disp", "daterange" );
$postParams = array( "disp", "likefilter", "limit", "printable", "site_code" );

switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach($getParams as $gp) {
       if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else {
         $$gp = "";
      }
   }
    break;
case "POST" :
   $post = TRUE;
   foreach($postParams as $pp) {
      if (isset($_POST[$pp])) {
        $$pp=htmlspecialchars(mysql_real_escape_string(trim($_POST[$pp])), ENT_QUOTES);
      } else {
        $$pp = "";
      }
   }
    break;
}

   
global $username, $uroles, $user_sites, $site_code;

$user_sites = getSiteCodes ($username);

function navbar ( ) {
     global $uroles, $user_sites, $likefilter, $site_code, $sortby, $dbconn;

     echo "<center><h3>TOP 100 Vulnerable Hosts</h3></center>";

     $txtselected = "";
     
     if ( $uroles['reports'] ||  $uroles['admin'] ) {
          echo <<<EOT
<table class="forumline" cellSpacing="1" cellPadding="3" border="0" width='100%'>
<form method="post" action="top10h.php">
<tr><td align="Right" width="25%">Filter by Sitename:  </td>
<TD align=LEFT><SELECT NAME="site_code">
<OPTION VALUE="" $txtselected ></OPTION>
EOT;
          $query = "SELECT name, site_code from I3_sites order by name";
          $result=$dbconn->Execute($query);

          while ( !$result->EOF ) {
               list($nname, $nsite )  = $result->fields;
               if ( $site_code == $nsite ) {
                    $txtselected = "SELECTED";
               } else {
                    $txtselected ="";
               }
               echo "<OPTION VALUE=\"$nsite\" $txtselected >$nname</OPTION>\n";
               $result->MoveNext();
          }
          echo <<<EOT
</SELECT></td></tr>
<tr><td align="Right" width="25%">Filter by Subnet (Whole/Partial):  </td>
<TD align=LEFT><input type="text" name="likefilter" value="$likefilter">
</td></tr>
<tr><td></td><td>
<input type="submit" name="submit" value="Filter" class="mainoption"></TD>
</form></tr>
</table><br>
EOT;

     } elseif ( count( $user_sites ) > 1 ) {

          echo <<<EOT
<table class="forumline" cellSpacing="1" cellPadding="3" border="0" width="100%">
<tr><td align="Right" width="25%">Associated Sites:  </td>
<form method="post" action="top10h.php">
<TD align=LEFT><SELECT NAME="site_code">
EOT;

         $keys_sites = array_keys($user_sites);

          foreach($keys_sites as $value) {
               if ( $site_code == "" ) {
                         $site_code = $value;
                    }
               if ( $site_code == $value ) {
                    $txtselected = "SELECTED";
               } else {
                    $txtselected ="";
               }
               echo "<OPTION VALUE=\"$value\" $txtselected >$value</OPTION>\n";

          }

          echo <<<EOT
          <tr><td></td><td>
          <input type="submit" name="submit" value="Filter" class="mainoption"></TD>
          </form></tr>
          </table><br>
EOT;
     } elseif ( count( $user_sites ) == 1 ) {

          $keys_sites = array_keys($user_sites);

          foreach($keys_sites as $value) {
               $site_code = $value;
          }

     }

     echo "</center>";
}

function top100_query($limit, $printable, $site_code ) {
   global $sitename, $username, $site_code, $user_sites, $uroles, $dbconn;

   navbar ();

   $query_filter = "";

   if ( $site_code ) { $query_filter = "t1.ORG = '$site_code' AND "; }
   $txt_Site = " \"$site_code\"";

   if ( ! $limit ) { $limit = 100; }

   echo "count=" . count ( $user_sites ) ."<br>";
   echo <<<EOT
<h2><i>Top $limit Vulnerable HOSTS</i></h2>
Most Vulnerable Host #<br>
EOT;

      $query = "SELECT t4.hostIP, t4.hostname, count( t4.scriptid ) AS vcount
   FROM I3_subnets t1 
      LEFT JOIN I3_jobs t2 ON t1.CIDR = t2.fk_name AND 
         ( t2.scan_SUBMIT >= t1.dtLastScanned OR t1.report_id = t2.report_id )
      LEFT JOIN nessus_reports t3 on t1.report_id=t3.report_id
      LEFT JOIN nessus_results t4 on t3.report_id = t4.report_id
          WHERE $query_filter t2.status = 'C'
AND t4.risk <= 2
GROUP BY hostIP
ORDER BY vcount DESC 
LIMIT 0 , $limit";

   $result = $dbconn->execute($query);

   echo <<<EOT
<table width="100%" border="0">
<tr>
   <td width="20">&nbsp;</td>
   <td width="10">Status</td>
   <td width="200">Name</td>
   <td width="200">HOSTNAME</td>
   <td width="300">Critical/High Vulnerability Count</td>
</tr>
EOT;
    $i = 0;
    while(!$result->EOF) {
        list ($vname, $vhostname, $vcount )=$result->fields;
        $i = $i + 1;

        if ( strpos($vhostname, ".") > 1 ) { $pname = $vhostname; } else { $pname = $vname; }
        $str=exec("ping -c 1 -w 1 $pname",$a,$a1);
        if(strlen($str)>1){
            $present_status = "<td bgcolor='#fff000'>present</td>";
        }else{
            $present_status= "<td bgcolor='#000000'>Not present</td>";
        }
        if ( $printable ) {
            $hostname_data = "$vhostname";
        } else {
            $hostname_data =  "<a href=\"nessus_host.php?likefilter=$vhostname\" target=\"_blank\">$vhostname</a>";
        }
        echo <<<EOT
<tr>
<td width="20" align="right">$i</td>
$present_status
<td>$vname</td>
<td align="left">$hostname_data</td>
<td align="left">$vcount</td>
</tr>
EOT;
        $result->MoveNext();
    }
    echo "</table>";

}

switch($disp) {

    default:
       top100_query($limit, $printable, $site_code);
       break;
}

require_once('footer.php');

?>
