<?php
//
// $Id: livestats_table.php,v 1.9 2006/08/10 17:19:32 airwofl Exp $
//

require_once('config.php');
require_once('functions.inc');
require_once('auth.php');

$url_sortby="<a href=\"livestats.php?";
if( $req_refresh<>"" ) {
   $url_sortby.="refresh=".$req_refresh;
}
$url_sortby.="&amp;sortby=";
$sql_order="order by ";
$sql_order2="nessus_schedule.name, inet_aton(nessus_live_stats.host)";

if ($sortby=="" || !is_numeric($sortby)) { $sortby=0; }
if ($sortby==0) { // Do nothing as the required sql gets appended at the end of this IF block
} elseif ($sortby==1) {
   $sql_order2="nessus_schedule.name DESC, inet_aton(nessus_live_stats.host)"; 
} elseif ($sortby==2) { 
   // Can't sort by scanner id currently as this is not retrieved until
   //  the while loop when printing the results.
   // Would need to rewrite the whole PHP script to get this working - 
   //  sorry, don't have time.
   //
   // This is only here to maintain order on the sortby IDs used in the 
   //  links and also to make sure nothing breaks.
} elseif ($sortby==3) { 
   // Same comment as above.
} elseif ($sortby==4) { $sql_order2="inet_aton(nessus_live_stats.host), nessus_schedule.name"; }
elseif ($sortby==5) { $sql_order2="inet_aton(nessus_live_stats.host) DESC, nessus_schedule.name"; }
elseif ($sortby==6) { $sql_order.="nessus_live_stats.action, "; }
elseif ($sortby==7) { $sql_order.="nessus_live_stats.action DESC, "; }
elseif ($sortby==8) { $sql_order.="nessus_live_stats.percent, "; }
elseif ($sortby==9) { $sql_order.="nessus_live_stats.percent DESC, "; }
elseif ($sortby==10) { $sql_order.="nessus_live_stats.username, "; }
elseif ($sortby==11) { $sql_order.="nessus_live_stats.username DESC, "; }

$sql_order.=$sql_order2;

$query="select nessus_live_stats.host, nessus_live_stats.action, 
               nessus_live_stats.percent, nessus_schedule.name, 
               nessus_live_stats.username, nessus_schedule.id 
        from nessus_live_stats
        left join nessus_schedule on nessus_live_stats.sid=nessus_schedule.id 
        where nessus_schedule.status='R' " . $sql_order;
$result=$dbconn->execute($query);

$query3="select count(*) 
         from nessus_scan 
         where server_id='0'";
$result3=$dbconn->execute($query3);
list($numstill2btested)=$result3->fields;

$query4="select count(*) 
         from nessus_scan 
         where server_id>0 and status='R'";
$result4=$dbconn->execute($query4);
list($numtesting)=$result4->fields;

$now = strftime('%R:%S');
print <<<EOT
<p>Last updated: $now</p>
<table>
<tr>
<th>Number of hosts currently being tested:</th>
<td>$numtesting</td>
</tr>
<tr>
<th>Number of hosts still to be tested:</th>
<td>$numstill2btested</td>
</tr>
</table>
EOT;

$stats_table_head = " 
<table summary='Scans'>
<tr>
<th>$url_sortby
";

if ($sortby==0) { $stats_table_head .= "1"; } else { $stats_table_head .= "0"; }
$stats_table_head .= "\">Schedule</a></th><th>$url_sortby";
if ($sortby==2) { $stats_table_head .= "3"; } else { $stats_table_head .= "2"; }
$stats_table_head .= "\">Scanner</a></th><th>$url_sortby";
if ($sortby==4) { $stats_table_head .= "5"; } else { $stats_table_head .= "4"; }
$stats_table_head .= "\">Host</a></th><th>$url_sortby";
if ($sortby==6) { $stats_table_head .= "7"; } else { $stats_table_head .= "6"; }
$stats_table_head .= "\">Scan Phase</a></th><th>$url_sortby";
if ($sortby==8) { $stats_table_head .= "9"; } else { $stats_table_head .= "8"; }
$stats_table_head .= "\">Status (%)</a></th><th>$url_sortby";
if ($sortby==10) { $stats_table_head .= "11"; } else { $stats_table_head .= "10"; }
$stats_table_head .= "\">Owner</a></th><th>Action</th></tr>";

$lc = 0; # loop counter, controls printing of the table header
while (!$result->EOF)
{
   if($lc == 0) {
      echo $stats_table_head;
   }
   $lc++;
   list($host, $action, $percent, $name, $db_username, $schedid)=$result->fields;

   $query1="select t1.name 
            from nessus_servers as t1, nessus_scan as t2, 
            nessus_live_stats as t3 
            where t1.id=t2.server_id and t2.host=t3.host 
               and t2.host='$host' and t2.status='R';";
   $result1=$dbconn->execute($query1);
   list($scannerhost_name)=$result1->fields;

   $complete = round($percent,0);
   echo <<<EOF
<tr>
<td><font face="Verdana" color="#666666" size="2">$name</font></td>
<td><font face="Verdana" color="#666666" size="2">$scannerhost_name</font></td>
<td><font face="Verdana" color="#666666" size="2">$host</font></td>
<td><font face="Verdana" color="#666666" size="2">$action</font></td>
<td><font face="Verdana" color="#666666" size="2">$complete%</font></td>
<td>$db_username</td>
<td>
EOF;
   $query2="select count(id) 
            from nessus_schedule 
            where username='$username' and id=$schedid";
   $result2=$dbconn->execute($query2);

   list($allowaccess2)=$result2->fields;
   if (($op=="stop") && ($host==$stophost) && ($schedid==$stopschedid)) {
      echo "Stopping";
   } elseif ($allowaccess2==1) {
      echo "<a href=\"livestats.php?op=stop&amp;schedid=$schedid&amp;host=$host&amp;sortby=$sortby";
      if( $req_refresh<>"" ) {
         echo "&amp;refresh=".$req_refresh;
      }
      echo "\">Stop</a>";
   }
   echo "</td></tr>";
   $result->MoveNext();
}

echo "</table>";

?>
