<?php
//
// $Id: admin.php,v 1.10 2006/09/19 04:57:01 airwofl Exp $
//
/***********************************************************/
/*                    Inprotect                            */
/* --------------------------------------------------------*/
/* Copyright (C) 2006 Inprotect                            */
/*                                                         */
/* This program is free software; you can redistribute it  */
/* and/or modify it under the terms of version 2 of the    */
/* GNU General Public License as published by the Free     */
/* Software Foundation.                                    */
/* This program is distributed in the hope that it will be */
/* useful, but WITHOUT ANY WARRANTY; without even the      */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE. See the GNU General Public License  */
/* for more details.                                       */
/*                                                         */
/* You should have received a copy of the GNU General      */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 59 Temple Place, */
/* Suite 330, Boston, MA 02111-1307 USA                    */
/*                                                         */
/* Contact Information:                                    */
/* inprotect-devel@lists.sourceforge.net                   */
/* http://inprotect.sourceforge.net/                       */
/***********************************************************/
/* See the README.txt and/or help files for more           */
/* information on how to use & config.                     */
/* See the LICENSE.txt file for more information on the    */
/* License this software is distributed under.             */
/*                                                         */
/* This program is intended for use in an authorized       */
/* manner only, and the author can not be held liable for  */
/* anything done with this program, code, or items         */
/* discovered with this program's use.                     */
/***********************************************************/

$pageTitle = "User Management";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');
//require_once('permissions.inc.php');

$getParams = array( "disp", "auname", "sortby" );
$postParams = array( "disp", "auname", "aemail", "locked", "expire", 
                     "pass1", "pass2" );

// get all available roles and put in hash
$query = "SELECT roleID, roleName, roleDesc
          FROM roles
          ORDER BY roleName ASC";
$result = $dbconn->GetArray($query);
if($result === false) {
   echo "SQL Error: " . $dbconn->ErrorMsg();
} else {
   foreach($result as $role) {
      $allRoles[$role['roleID']] = array( 'roleName' => $role['roleName'],
                                          'roleDesc' => $role['roleDesc'] );
   }
}

// get all available groups and put in hash
$query = "SELECT id, name, acronym FROM I3_systems";
$result = $dbconn->GetArray($query);
if($result === false) {
   echo "SQL Error: " . $dbconn->ErrorMsg();
} else {
   foreach($result as $system) {
      $allSystems[$system['id']] = array( 'systemACRO' => $group['acronym'],
                                         'systemName' => $group['name'] );
   }
}


// get all available groups and put in hash
$query = "SELECT gid, groupName, groupDesc
          FROM groups";
$result = $dbconn->GetArray($query);
if($result === false) {
   echo "SQL Error: " . $dbconn->ErrorMsg();
} else {
   foreach($result as $group) {
      $allGroups[$group['gid']] = array( 'groupName' => $group['groupName'],
                                         'groupDesc' => $group['groupDesc'] );
   }
}

// additional variable setup based on how we were called
switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach($getParams as $gp) {
      if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else { 
         $$gp=""; 
      }
   }
   break;
case "POST" :
   foreach($postParams as $pp) {
      if (isset($_POST[$pp])) { 
         $$pp=htmlspecialchars(mysql_real_escape_string(trim($_POST[$pp])), ENT_QUOTES); 
      } else { 
         $$pp=""; 
      }
   }
   //print_r($allRoles);
   // process the roles info
   foreach($allRoles as $roleID=>$rdata) {
      if(isset($_POST[$roleID])) {
         $proles[$roleID] = "Y";
      } else {
         $proles[$roleID] = "N";
      }
   }
   if(isset($_POST['groups'])) {
      foreach($_POST['groups'] as $gid) {
         $gid = htmlspecialchars(mysql_real_escape_string(trim($gid)), ENT_QUOTES); 
         $pgroups[$gid] = 1;
      }
   }
   if(isset($_POST['systems'])) {
      foreach($_POST['systems'] as $sysid) {
         $sysid = htmlspecialchars(mysql_real_escape_string(trim($sysid)), ENT_QUOTES); 
         $psystems[$sysid] = 1;
      }
   }   
   break;
}

// need admin rights, check if user has it
if (!$uroles['admin'] && !$uroles['uadmin']) {
    echo "Insufficient permissions - Access Denied.";
    logAccess( "Insufficient permissions - Access Denied." );
} 

function navbar ( $auname ) {
   global  $selRadio, $type, $value, $sortby, $sortdir, $auname, $dbconn;
   
   echo "<center><h3>User Management</h3>";
   if ( $auname ) {
          $query = "SELECT pn_uname FROM users WHERE pn_uname='$auname'";
          $result=$dbconn->Execute($query);
          list($ad_uname) = $result->fields;

          echo <<<EOT
[ <a href="admin.php">Main</a> ]
 -> Edit Nessus User [ <font color=red>$ad_uname</font> ] ( 
<a href="admin.php?disp=view&auname=$ad_uname">Access</a>
| <a href="admin.php?disp=edit&auname=$ad_uname">EDIT</a>
| <a href="admin.php?disp=chpass&auname=$ad_uname">SET PASSWORD</a> )
</center>
EOT;
   } else {
 	
      echo <<<EOT
</center>      
<!--<form name="userSearch" onSubmit="return OnSubmitForm();">-->
<form name="hostSearch" action="admin.php" method="GET">
<input type="text" length="25" name="value" value="$value">
EOT;
echo "
<input type=\"radio\" name=\"type\" value=\"pn_uname\" $selRadio[0]>Username
<input type=\"radio\" name=\"type\" value=\"pn_email\" $selRadio[1]>Email
<input type=\"radio\" name=\"type\" value=\"locked\" $selRadio[2]>Locked
";
     echo <<<EOT
<input type="hidden" name="sortby" value="$sortby">
<input type="submit" name="submit" value="Find">
</form>
</p>
EOT;
   }
   echo "<br>";

}

function change_password ( $auname ) {

   navbar ( $auname );

   if ($auname<>"") {
            echo <<<EOT
<form method="post" action="admin.php">
<input type="hidden" name="disp" value="setpass">
<input type="hidden" name="auname" value="$auname">
<b>Reset Password:</b><BR>
<table summary="Change password">
<tr><td>Password:</td>
<td><input type="password" name="pass1" value=""></td>
</tr>
<tr>
<td>Confirm Password</td>
<td><input type="password" name="pass2" value=""></td>
</tr>
</table>
<input type="submit" name="submit" value="Reset Password">
</form>
EOT;
   }

}

function create_new_user ( $auname, $aemail, $pass1, $pass2, $locked, $expire, $proles, $pgroups ) {
   global $minLength, $maxLength, $minAlpha, $minLower, $minUpper, $minSpecial, $minNumber, $allRoles, $allGroups, $username,
    $dbconn;

   if ($pass1<>"" and $pass2<>"") {
      $error = 0;
      $checkPass = checkPass($pass1);
      $pass1=md5($pass1);
      $pass2=md5($pass2);
      if ($pass1==$pass2 && $checkPass=="pass") {
         if ($locked<>"Y") {
            $locked="0";
         } else {
            $locked=5;
         }
         // create record in users table
         $query="insert into users (pn_uname, pn_email, pn_pass, expire, locked) values (
            '$auname', '$aemail', '$pass1', '$expire', $locked)";
         if ($dbconn->execute($query) === false) {
            echo "Error creating user: ". $dbconn->ErrorMsg();
            logAccess( "$username : " . $_SERVER['PHP_SELF'] . ": Error creating user " . $auname .
               ":" . $dbconn->ErrorMsg() );
            $error = 1;
         }

         // create records in roles table
         $query="insert into user_roles (pn_uname, roleID) values ";
         $vals = array ();
         foreach($allRoles as $roleID=>$roleData) {
            if ($proles[$roleID]=='Y') {
               // only an "admin" can create another admin
               // or assign the "zones" and "profiles" rights
               if ($uroles['admin']) { 
                  $vals[] = "('$auname', '$roleID')";
               } else if ($roleData['roleName'] != "admin" && 
                  $roleData['roleName'] != "zones" &&
                  $roleData['roleName'] != "profiles") {
                  $vals[] = "('$auname', '$roleID')";
               }
            }
         }
         $query .= implode(",", $vals);
         //echo $query;
         if (!empty($vals)) {
            if($dbconn->execute($query) === false) {
               echo "Error creating user roles: " .$dbconn->ErrorMsg();
               logAccess( "$username : " . $_SERVER['PHP_SELF'] . " : Error creating user roles " . $auname .
                  ":" . $dbconn->ErrorMsg() );
               $error = 1;
            }
         }


        // finally, do any group mods
        $addgroups =  array();
        foreach($allGroups as $gid=>$ag) {
           if(isset($pgroups[$gid])) {
              $addgroups[] = "('$auname', $gid)";
           }
        }

        if(!empty($addgroups)) {
           $iquery = "INSERT INTO user_groups
                       (pn_uname, gid) VALUES " .
                      implode(",",$addgroups);
           $ires = $dbconn->execute($iquery);
           if($ires === false) { 
              $error = 1;
              $errMsg[] = "user_groups add: " . $iquery . "<br>" .
                          $dbconn->ErrorMsg();
           }
        }

         // print success message to screen
         if ($error == 0) {
            echo "<B>User <I>$auname</I> has been added.</B><br>";
            logAccess( "$username : " . $_SERVER['PHP_SELF'] . " : Created user " . $auname );
         }
      } else {
         if($checkPass != "pass") {
            echo <<<EOT
<FONT COLOR="#FF0000"><B>
Cannot add user, provided password doesn't meet 
minimum standards ($checkPass).</B> <br>
<PRE>
(min Length = $minLength, 
 max Length = $maxLength, 
 min Alpha = $minAlpha,
 min Number = $minNumber, 
 min Upper = $minUpper,
 min Lower = $minLower, 
 min Special = $minSpecial)
</PRE>
</FONT><br>
EOT;
         } else {
        echo <<<EOT
<FONT COLOR="#FF0000"><B>Cannot add user, provided
passwords do not match.</B></FONT><br>
EOT;
         }
      }
   } else {
      echo "<FONT COLOR=\"#FF0000\"><B>Cannot add user, 
        password can not be blank.</B></FONT><br>";
      logAccess( "$username : " . $_SERVER['PHP_SELF'] . " : Create user failed - blank password for " . $auname );
   }

   navbar ( $auname );

}

function delete_user ( $auname, $confirm ) {
   global $allRoles, $allGroups, $enableDelProtect, $username, $dbconn;

   navbar ( "" );

      // don't delete the data for the user, just reassign it to
      // the admin account for scan related info.  Only remove
      // personalization or rights related data.



      // new code
      $error = 0; // for capturing errors on the SQL commands

      if ( $enableDelProtect ) {
         #RETAIN REPORTS WITH NAME OF ORIGINAL OWNER
         $query="update nessus_notes 
            set username='admin' 
            where username='$auname'";
         $result=$dbconn->execute($query);
         if($result === false) {
            $error++;
            $errorMsg[] = "nessus_notes: " . $dbconn->ErrorMsg();
         }

         $query="update nessus_reports 
            set username='admin' 
            where username='$auname'";
         $result=$dbconn->execute($query);
         if($result === false) {
            $error++;
            $errorMsg[] = "nessus_results: " . $dbconn->ErrorMsg();
         }

      }

      $query="update I3_job_schedule 
            set username='admin' 
            where username='$auname'";
      $result=$dbconn->execute($query);
      if($result === false) {
         $error++;
         $errorMsg[] = "nessus_schedule: " . $dbconn->ErrorMsg();
      }

      // remove this entry, it's rights data
      $query="delete from nessus_user_zones 
            where username='$auname'";
      $result=$dbconn->execute($query);
      if($result === false) {
         $error++;
         $errorMsg[] = "nessus_user_zones: " . $dbconn->ErrorMsg();
      }

      $query="update portscan 
            set username='admin' 
            where username='$auname'";
      $result=$dbconn->execute($query);
      if($result === false) {
         $error++;
         $errorMsg[] = "portscan: " . $dbconn->ErrorMsg();
      }

      // personalization info, so remove this
      $query="delete from nessus_settings_users 
            where username='$auname'";
      $result=$dbconn->execute($query);
      if($result === false) {
         $error++;
         $errorMsg[] = "nessus_settings_users: " . $dbconn->ErrorMsg();
      }

      // rights data, remove this
      $query="delete from nessus_zones 
            where owner='$auname' and type='P'";
      $result=$dbconn->execute($query);
      if($result === false) {
         $error++;
         $errorMsg[] = "nessus_zones: " . $dbconn->ErrorMsg();
      }
      // end new code

      // clean up the roles table
      $query="delete from user_roles 
            where pn_uname='$auname'";
      $result=$dbconn->execute($query);
      if($result === false) {
         $error++;
         $errorMsg[] = "user_roles: " . $dbconn->ErrorMsg();
      }

      // clean up the user_groups table
      $query="delete from user_groups 
            where pn_uname='$auname'";
      $result=$dbconn->execute($query);
      if($result === false) {
         $error++;
         $errorMsg[] = "user_groups: " . $dbconn->ErrorMsg();
      }

      // clean up the user_dashboard table
      $query="delete from user_dashboards 
            where pn_uname='$auname'";
      $result=$dbconn->execute($query);
      if($result === false) {
         $error++;
         $errorMsg[] = "user_dashboards: " . $dbconn->ErrorMsg();
      }

      // only remove the user account if no previous errors
      if ($error == 0) {
         $query="delete from users 
               where pn_uname='$auname'";
         $result=$dbconn->execute($query);
         if($result === false) {
            $error++;
            $errorMsg .= $dbconn->ErrorMsg();
         }
      }
      
      // check for error in the sql queries and print message accordingly
      if($error != 0) { 
         echo "<table class='error'>";
         echo "<tr><th>Error</th></tr>";
         echo "<tr><td>There was an error in one or more of the SQL queries
             when deleting the user information.</td></tr>";
         echo "<tr><td>The User account has not been deleted</td></tr>";
         echo "<tr><td><pre>" . implode("\n",$errorMsg) . "</pre></td></tr>";
         echo "</table>";
         logAccess( "$username : " . $_SERVER['PHP_SELF'] . " : Errors encountered while deleting user " . $auname . ": " . implode(",",$errorMsg));
      } else {
         echo "<B>User account <I>$auname</I> has been deleted.</B><BR><BR>";
         logAccess( "$username : " . $_SERVER['PHP_SELF'] . " : Deleted user " );
      }

}

function edit_user ( $auname ) {
   global $allRoles, $allGroups, $username, $dbconn;

   logAccess( "Select user for editing $auname" );

   $data = get_user_data($auname);
   $ugroups = get_user_groups($auname);
   $proles = get_user_roles($auname);
   //$usystems = get_user_systems($auname);
   //$uzones = get_user_zones($auname);
   
   navbar ( $auname );
   
   $aemail = $data['pn_email'];
   $expire = $data['expire'];
   $locked = $data['locked'];
   /*
  echo "<pre>"; 
  echo "$auname\n";
  print_r ($proles); 
  print_r ($ugroups); 
  echo "</pre>"; 
  */
   $ghtml = "";
   // create the groups pull-down
   $gquery = "SELECT gid, groupName FROM groups ORDER BY groupName ASC";
   $gresult = $dbconn->GetArray($gquery);
   if($gresult === false) {
      echo "SQL Error:  " . $dbconn->ErrorMsg();
      require_once('footer.php');
      die();
   }
   $ghtml .= "<select name='groups[]' multiple size=5>";
   foreach($gresult as $group) {
      $sel = "";
      if(in_array($group['groupName'],$ugroups)) { $sel = "selected"; }
      $ghtml .= "<option value='$group[gid]' $sel>$group[groupName]</option>";
   }
   $ghtml .= "</select>";
   
   // create HTML for the roles checkboxes (may need to redo as a select)
   $rhtml = "";
   if ( !empty($allRoles)) {
      foreach($allRoles as $roleID=>$roleData) {
         $selected = ($proles[$roleID] == "Y") ? "value='Y' checked" : "value='N'";
         $rhtml .= "<input type='checkbox' name='$roleID' $selected>";
         $rhtml .= $roleData['roleName'] . " - " . $roleData['roleDesc'] .
          "</input><br>\n";
      }
   }
   
   // create the systems pull-down
   $squery = "SELECT id, name FROM I3_systems ORDER BY name ASC";
   $sresult = $dbconn->GetArray($squery);
   if($sresult === false) {
      echo "SQL Error:  " . $dbconn->ErrorMsg();
      require_once('footer.php');
      die();
   }
   $shtml .= "<select name='systems[]' multiple size=5>";
   foreach($sresult as $system) {
      $sel = "";
      if(in_array($system['name'],$usystems)) { $sel = "selected"; }
      $shtml .= "<option value='$system[id]' $sel>$system[name]</option>";
   }
   $shtml .= "</select>";
   
   // create HTML for the roles checkboxes (may need to redo as a select)
   $rhtml = "";
   if ( !empty($allRoles)) {
      foreach($allRoles as $roleID=>$roleData) {
         $selected = ($proles[$roleID] == "Y") ? "value='Y' checked" : "value='N'";
         $rhtml .= "<input type='checkbox' name='$roleID' $selected>";
         $rhtml .= $roleData['roleName'] . " - " . $roleData['roleDesc'] .
          "</input><br>\n";
      }
   }   
   
   echo <<<EOT
<form method="post" action="admin.php">
<input type="hidden" name="disp" value="update">
<input type="hidden" name="auname" value="$auname">
<p></p>
Edit User: <b>$auname</b><br>
<table summary="Edit User Details">
<tr>
<td>Email</td>
<td><input type="text" name="aemail" value="$aemail" size=50></td>
</tr>
<tr>
<td>Groups</td>
<td>$ghtml</td>
</tr>
<tr>
<tr>
<td>Systems</td>
<td>$shtml</td>
</tr>
<tr>
<td>Permissions</td>
<td>$rhtml
</td>
</tr>
<tr>
<td>Account Expiration<br>
YYYYMMDD</td>
<td><input type="text" name="expire" value="$expire">
<input type="checkbox" name="locked" value="Y" 
EOT;
   if ($locked>=5) {echo "checked";}
   echo <<<EOT
>Account Locked
</td></tr>
</table>

<input type="submit" name="submit" value="Update Account">
</form>
EOT;

}


function get_user_data ( $auname ) {
   global $dbconn;    
   $data = array();
   if( $auname <> "" ) {

      // get user group info
      $query="SELECT * FROM users 
         WHERE pn_uname='$auname'";
      $result = $dbconn->GetArray($query);
      if($result === false) {
         echo "SQL Error:  " . $dbconn->ErrorMsg();
         require_once('footer.php');
         die();
      } else {
         $data = $result[0];
      }
   }
   return $data;
}

function get_user_groups ( $auname ) {
    global $dbconn;    
    $ugroups = array();
    // get user groups
    $query = "SELECT groups.gid, groupName
        FROM groups
        LEFT JOIN user_groups
        ON groups.gid = user_groups.gid
        WHERE user_groups.pn_uname = '$auname'";
    $result = $dbconn->GetArray($query);
    if($result === false) {
       echo "SQL Error: " . $dbconn->ErrorMsg();
    } else {
       foreach($result as $group) {
          $ugroups[$group['gid']] = $group['groupName'];
       }
    }
    return $ugroups;
}

function get_user_profiles ( $auname ) {
    global $dbconn;    
    $uprofiles = array();
    // get user system info
    $query = "SELECT t1.id, t1.name
        FROM nessus_settings t1
        LEFT JOIN nessus_settings_users t2
        ON t1.id = t2.sid
        WHERE t2.username = '$auname'";
    $result = $dbconn->GetArray($query);
    if($result === false) {
       echo "SQL Error: " . $dbconn->ErrorMsg();
    } else {
       foreach($result as $profile) {
          $uprofiles[$profile['id']] = $profile['name'];
       }
    }   
    return $uprofiles;
}

function get_user_systems ( $auname ) {
    global $dbconn;    

    $usystems = array();
    // get user profiles info
    $query = "SELECT t1.id, t1.name
        FROM I3_systems t1
        LEFT JOIN I3_system_users t2
        ON t1.id = t2.sysid
        WHERE t2.pn_uname = '$auname'";
    $result = $dbconn->GetArray($query);
    if($result === false) {
       echo "SQL Error: " . $dbconn->ErrorMsg();
    } else {
       foreach($result as $system) {
          $usystems[$system['id']] = $system['name'];
       }
    }
    return $usystems;
}

function get_user_zones ( $auname ) {
    global $dbconn;    
    $uzones = array();
    // get user zones info
    $query = "SELECT t1.id, t1.name
        FROM nessus_zones t1
        LEFT JOIN nessus_user_zones t2
        ON t1.id = t2.zid
        WHERE t2.username = '$auname'";
    $result = $dbconn->GetArray($query);
    if($result === false) {
       echo "SQL Error: " . $dbconn->ErrorMsg();
    } else {
       foreach($result as $zone) {
          $uzones[$zone['id']] = $zone['name'];
       }
    }
    return $uzones;
}

function get_user_roles ( $auname ) {
    global $dbconn;    
    // get user role info
    $proles = array();
    $query = "SELECT r.roleID, r.roleName 
        FROM user_roles as ur
        LEFT JOIN roles as r ON ur.roleID = r.roleID
        WHERE ur.pn_uname = '$auname'";
    $results = $dbconn->GetArray($query);
    if($results === false) {
       echo "SQL Error: " . $dbconn->ErrorMsg();
    } else {
       foreach ($results as $role) {
          $proles[$role['roleID']] = "Y"; //$results->fields[0];
       }
    }
    return $proles;
}


function main ( $type, $value, $sortby, $sortdir ) {
   global $selRadio, $auname, $username, $dbconn;

   $selRadio = array( "","","");
   if ($sortby == "" ) { $sortby = "pn_uname"; }
   if ($sortdir == "" ) { $sortdir = "ASC"; }

   $querys="SELECT pn_uname, pn_email, created, lastaccessed, locked, MD5(pn_uname) as md5user
      FROM users WHERE ";


   // set up the SQL query based on the search form input (if any)
   switch($type) {
   case "pn_uname":
      $selRadio[0] = "CHECKED";
      $q = strtolower($value);
      $queryw = " pn_uname LIKE '%$q%' ORDER BY $sortby $sortdir";
      $stext = "Search for Username = '*$q*'";
      break;     
   case "pn_email":
      $selRadio[1] = "CHECKED";
      $q = strtolower($value);
      $queryw = " pn_email LIKE '%$q%'  ORDER BY $sortby $sortdir";
      $stext =  "Search for Email Address = '*$q*'";
      break;
   case "locked":
      $selRadio[2] = "CHECKED";
      $q = strtolower($value);
      $queryw = " locked >= '$q'  ORDER BY $sortby $sortdir";
      $stext = "Search for Locked Users = '*$q*'";
      break;
      
   default:
      $selRadio[0] = "CHECKED";
      $viewAll = FALSE;
      $queryw .= " 1 order by $sortby $sortdir";
      #$queryw .= " limit $offset,$pageSize"; 
      $stext = "";
      break;
   }

   
   navbar ( $auname );

    $result=$dbconn->GetArray($querys.$queryw);
    if($result === false) {
       // error getting users
       $err = "Error retreiving users: " . $dbconn->ErrorMsg().
       dispSQLError(array($err),1);
    } else {
      // new table code
      $baseURL = $_SERVER['PHP_SELF'] . "?sortby=%var%";
      $tableFieldMap = array( "Login" => "pn_uname",
                            "Login" => array( 'var' => "pn_uname",
                                              'link' => $baseURL ),
                            "Email" => "pn_email",
                            "Created" => array( 'var' => "created",
                                                'link' => $baseURL ),
                            "Last Accessed" => array( 'var' => "lastaccessed",
                                                      'link' => $baseURL ),
                            "Lock<br>Count" => array( 'var' => "locked",
                                                   'link' => $baseURL ),
                            "Links" => array( "Access" => array(
                                                 "url" => "admin.php?disp=view&auname=%param%",
                                                 "param" => "pn_uname",
                                                 "icon" => "images/zoom.png"), 
                               				  "Edit" => array(
                                                 "url" => "admin.php?disp=edit&auname=%param%",
                                                 "param" => "pn_uname",
                                                 "icon" => "images/pencil.png"),
                                              "Delete" => array(
                                                    "url" => "admin.php?disp=delete&auname=%param%",
                                                    "onclick" => "return confirmDelete();",
                                                    "param" => "pn_uname",
                                                    "icon" => "images/delete.png"),
                                              "Switch to User" => array(
                                                 "url" => "admin.php?disp=switch&auname=%param%",
                                                 "param" => "md5user",
                                                 "icon" => "images/arrow_switch.png")));
      drawTable($tableFieldMap, $result, "InProtect Users");
   }
   echo <<<EOT
   <a href="admin.php?disp=add">Add New User<a>
EOT;


}

function new_user ( ) {
   global $allRoles, $allGroups, $username, $dbconn;

   navbar ( $auname );

    // create roles checkbox HTML
     $rhtml = $ghtml =  "";
     foreach ($allRoles as $roleID => $roleData) {
      $rhtml .= "<input type='checkbox' name='$roleID' value='N'>" .
            $roleData['roleName'] . " - " .  $roleData['roleDesc'] .
            "</input><br>";
     }
     // create the groups pull-down
     $gquery = "SELECT groupName
            FROM groups
            ORDER BY groupName ASC";
     $gresult = $dbconn->GetArray($gquery);
     if($gresult === false) {
      echo "SQL Error:  " . $dbconn->ErrorMsg();
      require_once('footer.php');
      die();
     }
     $ghtml .= "<select name='groups[]' multiple size=5>";
     foreach($gresult as $group) {
      $ghtml .= "<option value='$group[groupName]'>$group[groupName]</option>";
     }
     $ghtml .= "</select>";
     echo <<<EOT
<p></p>
<form method="post" action="admin.php">
<input type="hidden" name="disp" value="savenew">
<table summary="New user details">
<tr><td>Username</td>
<td><input type="text" name="auname" value=""></td>
</tr>
<tr>
<td>Email</td>
<td><input type="text" name="aemail" value=""></td>
</tr>
<tr>
<td>Password</td>
<td><input type="password" name="pass1" value=""></td>
</tr>
<tr>
<td>Confirm Password</td>
<td><input type="password" name="pass2" value=""></td>
</tr>
<tr>
<td>Groups</td>
<td>$ghtml</td>
</tr>
<tr>
<td>Permissions</td>
<td>$rhtml
</td>
</tr>
<tr>
<td>Account Expiration<br>
YYYYMMDD</td>
<td><input type="text" name="expire" value="">
<input type="checkbox" name="locked" value="Y">Account Locked
</td></tr>
</table>
<input type="submit" name="submit" value="Add New User">
</form>
EOT;



}

function set_pass ( $auname, $pass1, $pass2 ) {
   global $minLength, $maxLength, $minAlpha, $minLower, $minUpper, $minSpecial, $minNumber, $uroles, $dbconn;

   navbar ( $auname );

        if ($pass1<>"" and $pass2<>"") {
           $goodPass = checkPass($pass1);
           $pass1=md5($pass1);
           $pass2=md5($pass2);
           if ($pass1==$pass2 && $goodPass == "pass") {
              $query="update users set pn_pass='$pass1', pass_lastchanged=now()
                      where pn_uname='$auname'";
              $result=$dbconn->execute($query);
              echo "<B>Password has been reset.</B><br>";
              logAccess( "$username : " . $_SERVER['PHP_SELF']  . 
                         " : Reset password for " . $auname );

              if ($auname==$username) {
                 $_SESSION['pass'] = $pass1;
              }
           } else {
              if($goodPass != "pass") {
                 echo <<<EOT
<FONT COLOR="#FF0000"><B>
Cannot reset password, provided password doesn't meet 
minimum standards ($goodPass).</B> <br>
<PRE>
(min Length = $minLength, 
 max Length = $maxLength, 
 min Alpha = $minAlpha,
 min Number = $minNumber, 
 min Upper = $minUpper,
 min Lower = $minLower, 
 min Special = $minSpecial)
</PRE>
</FONT><br>
EOT;
                 logAccess("Reset password failed - $goodPass - $auname" );
              } else {
                  echo <<<EOT
<FONT COLOR="#FF0000"><B>Could not reset password 
for user <I>$auname</I>. Passwords entered do not 
match.</B></FONT><br>
EOT;
                  logAccess( "Reset password failed - mismatch for $auname" );
              }
           }
        } else {
           echo "<FONT COLOR=\"#FF0000\"><B>Cannot use a blank password.
                 </B></FONT><br>";
           logAccess( "Reset password fail - blank password for $auname" );

        }


}

function switch_user ( $auname ) {
   global $uroles, $dbconn;

   if($uroles[admin]) {
      $query="select pn_uname, pn_pass from users where md5(pn_uname)='$auname'";
      $result=$dbconn->execute($query);

      list($suuser, $supass) = $result->fields;

      // get the users roles and stick them in the session
      $_SESSION['roles'] = getUserRoles($suuser);

      $_SESSION['pass'] = $supass;
      $_SESSION['user'] = $suuser;

      $username=$suuser;

      echo "Successfully switched to user $suuser.<br>";
         logAccess( "Switched to user $suuser" );
         require_once('footer.php');

         die();
      } else {
         echo "Error - Only users with Admin rights can switch users.<br>";
         logAccess( "Error - non-admin attempted to switch user to $suuser");
         require_once('footer.php');

         die();
      }

}

function update_user ( $auname, $aemail, $locked, $expire, $proles, $pgroups, $psystems ) {
   global $allRoles, $allGroups, $allSystems, $username, $dbconn;

   navbar ( $auname );

        // set up error flag
        $error = 0;
        $errMsg = "";
        // update users table
        if($locked == "") {
           $locked = "NULL";
        } else {
           $locked = "5";
        }
        $query="update users 
                set pn_email='$aemail', 
                    locked=$locked, 
                    expire='$expire' 
                where pn_uname='$auname'";
        $result=$dbconn->execute($query);
        if(!$result) { // oops, DB error
           $errMsg[] = "<p>DB Update Error (user update)- " . 
                       $dbconn->ErrorMsg() . "</p>";
           $error = 1;
        } 
        // update roles table
        // first remove all existing roles
        $query="delete from user_roles where pn_uname = '$auname'";
        $result=$dbconn->execute($query);
        if(!$result) { // oops, DB error
           $errMsg[] = "<p>DB Update Error (user_roles delete) - " .
                       $dbconn->ErrorMsg() . "</p>";
           $error = 1;
        } 
        // now add the new roles back
        /*
        print_r($allRoles);
        echo "<bR>";
        print_r($proles);
        echo "<br>";
        */
        foreach($allRoles as $roleID=>$data) {
           //echo "checking $role: ";
           if ($proles[$roleID]=="Y") {
              //echo "adding\n";
              $query="insert into user_roles (pn_uname,roleID) 
                         values ('$auname','$roleID')";
              $result=$dbconn->execute($query);
              if(!$result) { // oops, DB error
                 $errMsg[] = "<p>DB Update Error (user_roles add) - " .
                             $dbconn->ErrorMsg() . "</p>";
                 $error = 1;
              } 
           }
        }

        // finally, do any system mods
        $addsystems = $remsystems = array();
	if(defined($allSystems) && !empty($allSystems)) {
           foreach($allSystems as $sysid=>$sag) {
              if(isset($psystems[$sysid])) {
                 $addsystems[] = "('$auname', $sysid)";
              } else {
                 $remsystems[] = $sysid;
              }
           }
           if(!empty($remsystems)) {
              $dquery = "DELETE FROM I3_system_users
                         WHERE pn_uname = '$auname' AND
                           sysID IN (" . implode(",", $remsystems) . ")";
              $dres = $dbconn->execute($dquery);
              if($dres === false) { 
                 $error = 1;
                 $errMsg[] = "I3_system_users delete: " . $dquery . "<br>" .
                             $dbconn->ErrorMsg();
              }
           }
           if(!empty( $addsystems )) {
              $iquery = "INSERT INTO I3_system_users
                          (pn_uname, sysID) VALUES " .
                         implode(",",$addsystems);
              $ires = $dbconn->execute($iquery);
              if($ires === false) { 
                 $error = 1;
                 $errMsg[] = "I3_system_users add: " . $iquery . "<br>" .
                             $dbconn->ErrorMsg();
              }
           }
	}

        // finally, do any group mods
        $addgroups = $remgroups = array();
        foreach($allGroups as $gid=>$ag) {
           if(isset($pgroups[$gid])) {
              $addgroups[] = "('$auname', $gid)";
           } else {
              $remgroups[] = $gid;
           }
        }
        if(!empty($remgroups)) {
           $dquery = "DELETE FROM user_groups
                      WHERE pn_uname = '$auname' AND
                        gid IN (" . implode(",", $remgroups) . ")";
           $dres = $dbconn->execute($dquery);
           if($dres === false) { 
              $error = 1;
              $errMsg[] = "user_groups delete: " . $dquery . "<br>" .
                          $dbconn->ErrorMsg();
           }
        }
        if(!empty($addgroups)) {
           $iquery = "INSERT INTO user_groups
                       (pn_uname, gid) VALUES " .
                      implode(",",$addgroups);
           $ires = $dbconn->execute($iquery);
           if($ires === false) { 
              $error = 1;
              $errMsg[] = "user_groups add: " . $iquery . "<br>" .
                          $dbconn->ErrorMsg();
           }
        }

        if($error == 0) {
           echo "<B>Account has been updated.</B><br>";
           logAccess("Updated user $auname" );
           $op="";
           // if user is updating own rights, reload them here.
           if ($auname == $username) {
              //$_SESSION['roles'] = getUserRoles($auname, $dbconn);
              $_SESSION['roles'] = getUserRoles($auname);
           }
        } else {
           echo "<table class='error'>
                 <tr><th>Error</th></tr>
                 <tr><td>";
           echo implode("<br>", $errMsg);
           echo "</td></tr>
                 </table>";
           logAccess("Error updating user $auname: " .
                      implode("|", $errMsg));
           require_once('footer.php');
           die();
        }

}

function view_user ( $auname ) {
    global $dbconn;

    //POPULATE SHARED GROUP ARRAY USED BY VIEW/EDIT ROUTINES
    $data = get_user_data  ( $auname );
    $ugroups = get_user_groups($auname);
    $uprofiles = get_user_profiles($auname);
    $usystems = get_user_systems($auname);
    $proles = get_user_roles($auname);
    $uzones = get_user_zones($auname);

    navbar (  $auname );

    $tmpgr = 
    $formFields = array( "User Name" => $data['pn_uname'],
       "Email Address" => $data['pn_email'],
       "ORG Membership" => getUserOrg ($auname),
       "SITE Membership" => implode("<br>",array_keys(getSiteCodes ($auname))),
       "Group Membership" => implode("<br>",array_values($ugroups)),
       "User Profiles" =>implode("<br>",array_values($uprofiles)),
       "System Membership" => implode("<br>",array_values($usystems)),
       "Zone Membership" => implode("<br>",array_values($uzones)),       
       "Roles" => implode("<br>", $proles ) );

    $formData = array( "summary" => "View User Group",
       "fields" => $formFields);

    drawForm($formData,$_SERVER['PHP_SELF']);

}

switch($disp) {

     case "add":
          new_user();
          break;

     case "chpass":
          change_password($auname);
          break;

     case "delete":
          delete_user($auname, $confirm);
          break;

     case "edit":
          edit_user($auname);
          break;

     case "savenew":
          create_new_user( $auname, $aemail, $pass1, $pass2, $locked, $expire, $proles, $pgroups );
          break;

     case "setpass":
          set_pass( $auname, $pass1, $pass2 );
          break;

     case "switch":
          switch_user( $auname );
          break;

     case "update":
          update_user( $auname, $aemail, $locked, $expire, $proles, $pgroups, $psystems );
          break;

     case "view":
          view_user (  $auname );
          break;

    default:
          main( $type, $value, $sortby, $sortdir );
          break;

}


require_once('footer.php');
?>
