<?php

//
// $Id: HOST_CHECKUP.php,v 1.0 2008/05/09 16:50:01 kkline Exp $
//
/***********************************************************/
/*                    Inprotect                            */
/* --------------------------------------------------------*/
/* Copyright (C) 2006 Inprotect                            */
/*                                                         */
/* This program is free software; you can redistribute it  */
/* and/or modify it under the terms of version 2 of the    */
/* GNU General Public License as published by the Free     */
/* Software Foundation.                                    */
/* This program is distributed in the hope that it will be */
/* useful, but WITHOUT ANY WARRANTY; without even the      */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE. See the GNU General Public License  */
/* for more details.                                       */
/*                                                         */
/* You should have received a copy of the GNU General      */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 59 Temple Place, */
/* Suite 330, Boston, MA 02111-1307 USA                    */
/*                                                         */
/* Contact Information:                                    */
/* inprotect-devel@lists.sourceforge.net                   */
/* http://inprotect.sourceforge.net/                       */
/***********************************************************/
/* See the README.txt and/or help files for more           */
/* information on how to use & config.                     */
/* See the LICENSE.txt file for more information on the    */
/* License this software is distributed under.             */
/*                                                         */
/* This program is intended for use in an authorized       */
/* manner only, and the author can not be held liable for  */
/* anything done with this program, code, or items         */
/* discovered with this program's use.                     */
/***********************************************************/

$pageTitle = "Incident Review";
require_once('config.php');
require_once('functions.inc');

$colors=array("black", "red", "orange", "magenta", "yellow", "navy", "green", "blue");

online();

$hostip = $_SERVER['REMOTE_ADDR'];
$hostname = gethostbyaddr($hostip);
$hostname = strtolower($hostname);

logAccess( "HOST CHECKUP: [ $hostip ( $hostname ) ]" );


echo <<<EOT
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<head>
   <title>InProtect - Home</title>
    <link rel="stylesheet" type="text/css" href="./css/inprotect.css" />
</head>
<body>
<center>
<h3><b>$sitename - HOST CHECKUP</b></h3>
EOT;


$checkup_value = "";

echo "YOUR IP IS $hostip<br>YOUR HOSTNAME IS $hostname<br>";

$query="SELECT id, hostname, os, status, description, 
   contact, acrSystem, subSystem, scanstate, lastscandate FROM hosts";

if(isset($hostname) && isset($hostip)) {
   $query .= " where hostname = '$hostname' AND hostip = '$hostip' order by hostname";
} elseif (isset($hostname)) {
   $query .= " where hostname = '$hostname' order by hostname ";
} elseif (isset($hostip)) {
   $query .= " where hostip = '$hostip' order by INET_ATON(hostip) ASC ";
}

$result=$dbconn->execute($query);
list( $host_id, $hostname, $os, $status, $description, $contact, $arcSystem, $subSystem, $scanstate, $lastscanned ) = $result->fields;

echo "LAST SCANNED ON $lastscanned<br>";

if ( $host_id ) {
      $query = "SELECT t1.id, t1.result_id, t1.exception_id, t1.scriptid, t1.service, t1.risk, t1.msg, t1.date_open
        FROM I3_Incidents t1
          LEFT JOIN hosts t2 on t1.host_id = t2.id 
        WHERE host_id = '$host_id'
         ORDER by t1.risk";

      if ( $uroles['debug'] ) {
        echo "sql=[$query]<br>";
     }

   $curtime = gen_strtotime("now", "");  

   $result = $dbconn->execute($query);
   $numrows = $result->NumRows();

		
   if ($numrows == 0) {
      echo "<br><br><h3><font color='green'>PASSED</font></h3><br><b>NO CRITICAL/HIGH VULNERABILITIES FOUND</b>";
      $checkup_value = "Passed";
   } else {	
      echo <<<EOT
<center><h4>Open Incidents on host [$hostname ( $hostip )]</h4></center>
   <table align="center" width="100%">

    <tr>
      <th NOWRAP>TITLE</th>
      <th NOWRAP>Priority</th>
      <th NOWRAP>Created</th>
      <th NOWRAP>Life Time<img src="images/abajo.gif" border=0></th>
    </tr>
EOT;

      while ( !$result->EOF ) {
         list($iid, $vid, $eid, $script_id, $vservice, $vrisk, $vmessage, $created ) = $result->fields;

         #$created = gen_strtotime( $vtime );
         $days = datediff("d", $curtime, $created );      

         $msg = $vmessage;
         #$lvmessage = substr($vmessage,0, 800 );

         $arrHighlight = array( "Arbitrary code can be executed on the remote host ",
      	    "execute code on the remote host",
      	    "user can elevate his privileges on the remote host",
            "may allow a user to elevate his privileges",
            "users can elevate their privileges on the remote host",
      	    "Denial of Service attack",
      	    "could allow remote code execution"
      	  );

          foreach ( $arrHighlight as $search ) {
             $msg = str_replace($search, "<FONT style='BACKGROUND-COLOR: yellow'>$search</FONT>",$msg);
          }
          $msg=activateHyperlink($msg);


          if ( $eid ) {
             $incident_link = "exceptions.php?disp=view&eid=$eid";
             $risk_color = "$colors[4]";
          } else {
             $incident_link = "exceptions.php?disp=new&host_id=$host_id&incident_id=$iid'";
             $risk_color = "$colors[$vrisk]";
          }
          echo <<<EOT
      <tr>
            <td><font size='1'>$msg</font></td>
            <td  width='50' align='center'>
               <table align="center" bgcolor="$colors[$vrisk]" fgcolor="black">
                  <tr>
                       <td bgcolor="$risk_color" fgcolor="black" style="border-width: 0px;">
                       <a href='$incident_link'>
                      <b>&nbsp;<font color="black">$vrisk</font>&nbsp;</b></a>
                      </td>
                  </tr>
                   </table>
                </td>
            <td width='200'>$created</td>
            <td width='60'>$days</td>
         </tr>
EOT;
         $result->MoveNext();

      }   
      echo "</font></table>";
   }
} else {
   echo <<<EOT
<center><h4>NO DATA FOR HOST [$hostname ($hostip)]</h4></center>
EOT;
   $checkup_value = "Hostname Not Found";
}

echo <<<EOT
</center>
</BODY>
</HTML>
EOT;



?>