<?php
//
// $Id: filter.php,v 1.14 2006/09/21 12:34:35 airwofl Exp $
//

/***********************************************************/
/*                    Inprotect                            */
/* --------------------------------------------------------*/
/* Copyright (C) 2006 Inprotect                            */
/*                                                         */
/* This program is free software; you can redistribute it  */
/* and/or modify it under the terms of version 2 of the    */
/* GNU General Public License as published by the Free     */
/* Software Foundation.                                    */
/* This program is distributed in the hope that it will be */
/* useful, but WITHOUT ANY WARRANTY; without even the      */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE. See the GNU General Public License  */
/* for more details.                                       */
/*                                                         */
/* You should have received a copy of the GNU General      */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 59 Temple Place, */
/* Suite 330, Boston, MA 02111-1307 USA                    */
/*                                                         */
/* Contact Information:                                    */
/* inprotect-devel@lists.sourceforge.net                   */
/* http://inprotect.sourceforge.net/                       */
/***********************************************************/
/* See the README.txt and/or help files for more           */
/* information on how to use & config.                     */
/* See the LICENSE.txt file for more information on the    */
/* License this software is distributed under.             */
/*                                                         */
/* This program is intended for use in an authorized       */
/* manner only, and the author can not be held liable for  */
/* anything done with this program, code, or items         */
/* discovered with this program's use.                     */
/***********************************************************/


$pageTitle = "Incident Filter";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');

$pageSize = 50;

$getParams = array( "disp", "offset", "type", "filter", "sortby", "sortdir" );
$postParams = array("disp", "offset", "type", "filter", "sortby", "sortdir"  );


switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach($getParams as $gp) {
      if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else { 
         $$gp=""; 
      }
   }
   break;
case "POST" :
   foreach($postParams as $pp) {
      if (isset($_POST[$pp])) { 
         $$pp=htmlspecialchars(mysql_real_escape_string(trim($_POST[$pp])), ENT_QUOTES); 
      } else { 
         $$pp=""; 
      }
   }
   break;
}

global $viewAll, $offset, $pageSize, $hostScanStateArray, $dbconn;

$output="";

#<li><a href="filters.php?disp=report&amp;type=sumbyrisk" tabindex="1">Sum By Risk</a></li>
echo <<<EOT
<table style="WIDTH: 100%; HEIGHT: 390px"><tr><td width="50" valign="top">
<div id="vertmenu">
<h1>Incident Reports</h1>
<ul>

<li><a href="filters.php?disp=report&amp;type=sumbyage" tabindex="1">Sum By Age</a></li>
<li><a href="filters.php?disp=report&amp;type=sumbyvuln" tabindex="2">Sum by Vulnerability</a></li>
<li><a href="filters.php?disp=report&amp;type=sumbyfamily" tabindex="3">Sum by Plugin Family</a></li>
<li><a href="filters.php?disp=report&amp;type=sumbyhost" tabindex="4">Sum by Host</a></li>
<li><a href="filters.php?disp=report&amp;type=list-os" tabindex="5">List OS</a></li>
<li><a href="filters.php?disp=report&amp;type=list-services" tabindex="6">List Services</a></li>
<li><a href="filters.php?disp=report&amp;type=list-vulns" tabindex="7">List Vulnerabilities</a></li>
</ul>
</div>
</td><td>
<div id="reports">
<table style="WIDTH: 100%; HEIGHT: 390px"><tr valign="top"><td>
EOT;

   // set up the SQL query based on the search form input (if any)
   switch($type) {

   case "sumbyrisk":
      $output = "chart";

      if ($sortby == "" ) { $sortby = "service"; }
      if ($sortdir == "" ) { $sortdir = "ASC"; }
      if($sortdir == "ASC") { $sortdir = "DESC"; } else { $sortdir = "ASC"; }
      $url = $_SERVER['PHP_SELF'] . "?type=$type&offset=$offset&sortby=%var%&sortdir=$sortdir";
      $fieldMap = array( "SEVERITY" => array( 'var' => 'scriptid', 'link' => $url ), "COUNT" => array( 'var' => 'count', 'link' => $url ));
      $query = "SELECT sum( t3.vSerious ) as vSerious, sum( t3.vHigh ) as vHigh, sum( t3.vMed ) as vMed, sum( t3.vLow ) as vLow
         FROM I3_subnets t1 LEFT JOIN I3_jobs t2 ON t1.CIDR = t2.fk_name AND ( t2.scan_SUBMIT >= t1.dtLastScanned OR t1.report_id = t2.report_id )
         LEFT JOIN nessus_report_stats t3 on t2.report_id = t3.report_id WHERE t1.status != 'available' and t1.serial_flag='N'";
      $stext = "Summary By Risk";
      break;

   case "sumbyage":
      $output = "chart";

      if ($sortby == "" ) { $sortby = "life_timer"; }
      if ($sortdir == "" ) { $sortdir = "ASC"; }
      if($sortdir == "ASC") { $sortdir = "DESC"; } else { $sortdir = "ASC"; }
      $url = $_SERVER['PHP_SELF'] . "?type=$type&offset=$offset&sortby=%var%&sortdir=$sortdir";
      $fieldMap = array( "AGE (<=DAYS) RISK WAS IDENTIFIED" => array( 'var' => 'iAge', 'link' => $url ), 
         "TOTAL" => array( 'var' => 'count', 'link' => $url ));
      $query = "SELECT ( PERIOD_DIFF( date_format(now(), '%Y%m'), date_format(date_open, '%Y%m')) * 30) as life_timer, count(*) as count 
         FROM hosts t1 LEFT JOIN I3_Incidents t2 on t1.id=t2.host_id WHERE t2.status != 'resolved' AND t2.scriptid < 60000 group by life_timer 
         ORDER by date_open ASC;";
      $stext = "Summary By Risk";
      break;

   case "sumbyvuln":
      $output = "chart";

      if ( $filter ) { $sql_family = "AND t2.family='$filter'"; $txt_filter="Filter = [FAMILY]:"; } else { $sql_family=""; $txt_filter=""; }

      if ($sortby == "" ) { $sortby = "count"; }
      if ($sortdir == "" ) { $sortdir = "ASC"; }
      if($sortdir == "ASC") { $sortdir = "DESC"; } else { $sortdir = "ASC"; }
      $url = $_SERVER['PHP_SELF'] . "?type=$type&offset=$offset&sortby=%var%&sortdir=$sortdir";
      $fieldMap = array( "PLUGIN" => array( 'var' => 'iScriptID', 'link' => $url ), "TOTAL" => array( 'var' => 'count', 'link' => $url ),
         "SEVERITY" => array( 'var' => 'description', 'link' => $url ), "NAME" => array( 'var' => 'name', 'link' => $url ),
         "FAMILY" => array( 'var' => 'FamLink', 'link' => $url ));
      $query = "SELECT t1.scriptid, count(t1.scriptid) as count, t3.description, t2.name, t2.family
         FROM I3_Incidents t1
         LEFT JOIN plugins t2 on t1.scriptid = t2.id
         LEFT JOIN risk_level t3 on t1.risk = t3.id 
         WHERE t1.scriptid !='' AND t1.status != 'resolved' AND t1.scriptid < 60000 $sql_family GROUP BY scriptid ORDER BY $sortby $sortdir";
      $stext = "$txt_filter Sum by Vulnerability";
      break;

   case "sumbyfamily":
      $output = "chart";
      if ($sortby == "" ) { $sortby = "count"; }
      if ($sortdir == "" ) { $sortdir = "ASC"; }
      if($sortdir == "ASC") { $sortdir = "DESC"; } else { $sortdir = "ASC"; }
      $url = $_SERVER['PHP_SELF'] . "?type=$type&offset=$offset&sortby=%var%&sortdir=$sortdir";
      $fieldMap = array( "FAMILY" => array( 'var' => 'FamLink', 'link' => $url ), "TOTAL" => array( 'var' => 'count', 'link' => $url ));
      $query = "SELECT t2.family, count(t2.family) as count FROM I3_Incidents t1 LEFT JOIN plugins t2 on t1.scriptid = t2.id 
         WHERE t1.scriptid !='' AND t1.status != 'resolved' AND t1.scriptid < 60000 GROUP BY family ORDER BY $sortby $sortdir";
      $stext = "Sum by Family";
      break;
   case "sumbyhost":
      $output = "chart";

      if ($sortby == "" ) { $sortby = "vHigh"; }
      if ($sortdir == "" ) { $sortdir = "ASC"; }
      if($sortdir == "ASC") { $sortdir = "DESC"; } else { $sortdir = "ASC"; }
      $url = $_SERVER['PHP_SELF'] . "?type=$type&offset=$offset&sortby=%var%&sortdir=$sortdir";
      $fieldMap = array( "HOSTNAME" => array( 'var' => 'hostname', 'link' => $url ), "TOTAL" => array( 'var' => 'total', 'link' => $url ),
         "SERIOUS" => array( 'var' => 'vSerious', 'link' => $url ), "HIGH" => array( 'var' => 'vHigh', 'link' => $url ),
         "MEDIUM" => array( 'var' => 'vMed', 'link' => $url ), "LOW" => array( 'var' => 'vLow', 'link' => $url ),
         "DATE LAST SCAN" => array( 'var' => 'lastscandate', 'link' => $url ));
      $query = "SELECT t1.hostname, vSerious, vHigh, vMed, vLow, lastscandate FROM hosts t1
         LEFT JOIN host_stats t2 ON t1.id=t2.host_id AND t1.report_id=t2.report_id
         WHERE inactive='0' ORDER BY $sortby $sortdir LIMIT 10";
      $stext = "Sum by Host (Top 10)";
      break;


   case "list-os":
      if ( $filter ) { $sql_family = "AND os='$filter'"; } else { $sql_family=""; }

      if ($sortby == "" ) { $sortby = "os"; }
      if ($sortdir == "" ) { $sortdir = "ASC"; }
      if($sortdir == "ASC") { $sortdir = "DESC"; } else { $sortdir = "ASC"; }
      $url = $_SERVER['PHP_SELF'] . "?type=$type&offset=$offset&sortby=%var%&sortdir=$sortdir";
      $fieldMap = array( "OS" => array( 'var' => 'OSLink', 'link' => $url ), "COUNT" => array( 'var' => 'count', 'link' => $url ));
      $query = "SELECT os, count( os ) as count FROM hosts WHERE os IS NOT NULL AND os != '' AND inactive='0' $sql_family 
         GROUP BY os ORDER BY $sortby $sortdir";
      break;

   case "list-os-hosts":
      if ( $filter ) { $sql_family = "AND os='$filter'"; } else { $sql_family=""; }
      if ($sortby == "" ) { $sortby = "hostip"; }
      if ($sortdir == "" ) { $sortdir = "ASC"; }
      if($sortdir == "ASC") { $sortdir = "DESC"; } else { $sortdir = "ASC"; }
      $url = $_SERVER['PHP_SELF'] . "?type=$type&offset=$offset&sortby=%var%&sortdir=$sortdir";
      $fieldMap = array( "HOSTNAME" => array( 'var' => 'hostname', 'link' => $url ), "HOST IP" => array( 'var' => 'hostip', 'link' => $url ),
         "OS" => array( 'var' => 'os', 'link' => $url ));
      $query = "SELECT hostname, hostip, os FROM hosts WHERE os IS NOT NULL AND os != '' AND inactive='0' $sql_family 
         ORDER BY $sortby $sortdir";
      break;

   case "list-services":
      if ($sortby == "" ) { $sortby = "count"; }
      if ($sortdir == "" ) { $sortdir = "ASC"; }
      if($sortdir == "ASC") { $sortdir = "DESC"; } else { $sortdir = "ASC"; }
      $url = $_SERVER['PHP_SELF'] . "?type=$type&offset=$offset&sortby=%var%&sortdir=$sortdir";
      $fieldMap = array( "SERVICE" => array( 'var' => 'iService', 'link' => $url ), "COUNT" => array( 'var' => 'count', 'link' => $url ));
      $query = "SELECT service, count( service ) AS count FROM I3_Incidents WHERE status!='resolved' 
         GROUP BY service ORDER BY $sortby $sortdir";
      break;

   case "list-vulns":
      if ( $filter ) { $sql_family = "AND t1.service='$filter'"; } else { $sql_family=""; }
      if ($sortby == "" ) { $sortby = "count"; }
      if ($sortdir == "" ) { $sortdir = "ASC"; }
      if($sortdir == "ASC") { $sortdir = "DESC"; } else { $sortdir = "ASC"; }
      $url = $_SERVER['PHP_SELF'] . "?type=$type&offset=$offset&sortby=%var%&sortdir=$sortdir";
      $fieldMap = array( "PLUGIN" => array( 'var' => 'iScriptID', 'link' => $url ), "VULNERABILITY" => array( 'var' => 'name', 'link' => $url ),
         "SERVICE" => array( 'var' => 'iService', 'link' => $url ), "COUNT" => array( 'var' => 'count', 'link' => $url ));
      $query = "SELECT t1.scriptid, t1.service, t2.name, count(t2.name) as count FROM I3_Incidents t1
         LEFT JOIN plugins t2 on t1.scriptid = t2.id WHERE t1.scriptid !='' AND
         t1.status!='resolved' AND t1.scriptid < 60000 $sql_family GROUP BY name ORDER BY $sortby $sortdir";
      break;

   case "list-aged-vulns":

      $max = $filter;
      $min = $filter - 30;

      if ($sortby == "" ) { $sortby = "hostname"; }
      if ($sortdir == "" ) { $sortdir = "ASC"; }
      if($sortdir == "ASC") { $sortdir = "DESC"; } else { $sortdir = "ASC"; }
      $url = $_SERVER['PHP_SELF'] . "?type=$type&offset=$offset&sortby=%var%&sortdir=$sortdir";
      $fieldMap = array( "HOSTNAME" => array( 'var' => 'iHost', 'link' => $url ), "ID" => array( 'var' => 'id', 'link' => $url ),
         "RISK" => array( 'var' => 'description', 'link' => $url ), "NAME" => array( 'var' => 'name', 'link' => $url ),
         "LIFE TIMER ( DAYS )" => array( 'var' => 'life_timer', 'link' => $url ));
      $query = "SELECT t1.hostname, t2.id, t4.description, t3.name, (TO_DAYS(now()) - TO_DAYS(date_open)) as life_timer
         FROM hosts t1 LEFT JOIN I3_Incidents t2 on t1.id=t2.host_id LEFT JOIN plugins t3 on t2.scriptid = t3.id 
         LEFT JOIN risk_level t4 on t2.risk = t4.id 
         WHERE (PERIOD_DIFF( date_format(now(), '%Y%m'), date_format(t2.date_open, '%Y%m')) * 30) <=$max AND 
         (PERIOD_DIFF( date_format(now(), '%Y%m'), date_format(t2.date_open, '%Y%m')) * 30) > $min AND
         t2.status!='resolved' AND t2.scriptid < 60000 ORDER BY $sortby $sortdir";
      break;

   default:

      break;
   }

   // get the hosts to display
   $result=$dbconn->GetArray($query);

   if ( $type == "sumbyrisk" ) {
      $row = $result->fields;
      $result = array();
      $result[] = array( 'Serious' =>$row['vSerious']);
      $result[] = array( 'High'    =>$row['vHigh']);
      $result[] = array( 'Medium'  =>$row['vMed']);
      $result[] = array( 'Low'     =>$row['vLow'] );

   }

   if($result === false) {
      echo <<<EOT
</td></tr></table><br>
EOT;
   } else {
      $tdata = array();
      $i = 0;
      $other = 0;
      $sqlScanTime = gen_strtotime("now", "");
      
      $total = "";
      $url_data = "";
      $totalvulns = "";
      foreach($result as $data) {
         if ( $type == "sumbyfamily" ) {
            $url_data .= "&legend[]=$data[0]&data[]=$data[1]";
            $totalvulns +=$data[1];
            $data['FamLink'] = "<a href='filters.php?disp=report&type=sumbyvuln&filter=$data[0]' title='Lookup Family' >$data[0]</a>";
         } elseif ( $type == "sumbyvuln" ) {
            if ( $i <= 50 ) {
               $url_data .= "&legend[]=ID:%20$data[0]&data[]=$data[1]";
            } else {
               $other += $data[1];
            }
            $totalvulns +=$data[1];
            $data['iScriptID'] =  "<a href='lookup.php?disp=scriptid&id=$data[0]&lookup=byincident' title='Lookup Hosts' target='_blank'>$data[0]</a>";
            $data['FamLink'] = "<a href='filters.php?disp=report&type=sumbyvuln&filter=$data[4]' title='Lookup Family'>$data[4]</a>";
         } elseif ( $type == "sumbyhost" ) {
            $total = $data[1] + $data[2] + $data[3] + $data[4];
            $data['total'] = $total;
            $url_data .= "&legend[]=ID:%20$data[0]&data[]=$total";
            $totalvulns +=$total;
         } elseif ( $type == "sumbyage" ) {
            $total += $data[1];
            $url_data .= "&legend[]=ID:%20<=$data[0]&data[]=$total";
            $totalvulns +=$total;
            $max = $data[0];
            $min = $data[0] - 30; 
            if ( $min <= 0 ) { $min = 0; }
            $data['iAge'] = "<a href='filters.php?disp=report&type=list-aged-vulns&filter=$data[0]' title='Lookup ( $min - $max ) DAYS OLD'>$data[0]</a>";
         } elseif ( $type == "sumbyrisk" ) {
            $total += $data[1];
            $url_data .= "&legend[]=ID:%20$data[0]&data[]=$total";
            $totalvulns +=$total;
         } elseif ( $type == "list-services" ) {
            $data['iService'] = "<a href='filters.php?disp=report&type=list-vulns&filter=$data[0]' title='Lookup Service'>$data[0]</a>";
         } elseif ( $type == "list-os" ) {
            $data['OSLink'] = "<a href='filters.php?disp=report&type=list-os-hosts&filter=$data[0]' title='Lookup OS Hosts'>$data[0]</a>";
         } elseif ( $type == "list-aged-vulns" ) {
            $data['iHost'] = "<a href='nessus_host.php?likefilter=$data[0]' title='Lookup Hosts' target='_blank'>$data[0]</a>";
         } elseif ( $type == "list-vulns" ) {
            $data['iScriptID'] =  "<a href='lookup.php?disp=scriptid&id=$data[0]&lookup=byincident' title='Lookup Hosts' target='_blank'>$data[0]</a>";
            $data['iService'] = "<a href='filters.php?disp=report&type=list-vulns&filter=$data[1]' title='Lookup Service'>$data[1]</a>";
         }

         $tdata[] = $data;
         $i += 1;
      }

      if ( $output == "chart" && $totalvulns > 0 ) {
      	 if ( $other >= 1 ) {
      	 	$url_data .= "&legend[]=ID:%20OTHER&data[]=$other";
      	 }
         $chart_img = "<img alt='PIE Chart' src='piegraph.php?caption=$stext&totalvulns=$totalvulns".$url_data."'>";
         echo<<<EOT
<center>$chart_img</center>
EOT;
      }

      drawTable($fieldMap, $tdata, "Hosts");
      // draw the pager again, if viewing all hosts
      if($viewAll) {
         echo <<<EOT
<p align=center>
<a href="hosts.php?offset=0" class="pager">&lt&lt First</a>
<a href="hosts.php?offset=$previous" class="pager">&lt Previous </a>
<a href="hosts.php?offset=$next" class="pager">| Next &gt;</a>
<a href="hosts.php?offset=$last" class="pager"> Last &gt;&gt;</a>
</p>
EOT;
      }
   }
       echo <<<EOT
</table></td></tr></table>
</div>
</td></tr>
</table>
EOT;

include ('footer.php');

?>