<?php
//
// gadmin.php - page to allow management of user groups
//

$pageTitle = "Group Management";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');

// set up array of GET/POST params that need to be assigned to variables
$getParams = array( "gid", "disp" );
$postParams = array( "disp", "gid", "groupName", "groupDesc" );

// process the GET/POST params
$isget = 0;
switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach($getParams as $gp) {
      if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else { 
         $$gp=""; 
      }
   }
   break;
case "POST" :
   foreach($postParams as $pp) {
      if (isset($_POST[$pp])) { 
         $$pp=htmlspecialchars(mysql_real_escape_string(trim($_POST[$pp])), ENT_QUOTES); 
      } else { 
         $$pp=""; 
      }
   }
   break;
}


$msg   = array();
$errMsg= array();
$pgroles = array();
$users = array();

if(!($uroles['admin'] || $uroles['uadmin'])) {
   echo "Insufficient rights to access this page.";
   logAccess( "Insuffient rights to access page" );
   require_once('footer.php');
   die();
} else {
   logAccess( "Accessed page" );
}

if(isset($_POST['groupMembers'])) {
   foreach($_POST['groupMembers'] as $user) {
      $users[] = htmlspecialchars(mysql_real_escape_string(trim($user)), ENT_QUOTES); 
   }
}
if(isset($_POST['groupRoles'])) {
   foreach($_POST['groupRoles'] as $grole) {
      $pgroles[] = htmlspecialchars(mysql_real_escape_string(trim($grole)), ENT_QUOTES); 
   }
}

// get array of all roles
$rquery = "SELECT roleID, roleName, roleDesc FROM roles ORDER BY roleName ASC";
$result = $dbconn->GetArray($rquery);
if($result === false) {
   echo "SQL Error:  " . $dbconn->ErrorMsg();
   require_once('footer.php');
  die();
}

$allRoles = array();
foreach($result as $role) {
   $allRoles[$role['roleID']] = "[" . $role['roleName'] . "] - " . $role['roleDesc'];
}

$uquery = "SELECT pn_uname FROM users ORDER BY pn_uname ASC";
$result = $dbconn->GetArray($uquery);
if($result === false) {
   echo "SQL Error:  " . $dbconn->ErrorMsg();
   require_once('footer.php');
   die();
}

$ausers = array();
foreach($result as $user) {
   $ausers[] = $user['pn_uname'];
}


function navbar ( $gid ) {
    global $disp, $dbconn;

    echo "<center><h3>Manage Groups</h3>";  

    if ( ! $gid && $disp == "new" ) {
       echo "</center><p>Return to <a href='gadmin.php'>Main</a></p>";
    } elseif ( ! $gid ) {
       echo "</center><p>Create a  <a href='gadmin.php?disp=new'>New Group</a></p>";
    } else {
         $query = "SELECT groupName FROM groups WHERE gid='$gid'";
         $result=$dbconn->Execute($query);
         list($groupname) = $result->fields;
         echo "[ <a href=\"gadmin.php\">Main</a> ]";
         echo " -> Edit Group [ <font color=red>$groupname</font> ] ( ";

         echo "<a href=\"gadmin.php?disp=view&gid=$gid\">OVERVIEW</a> | 
           <a href=\"gadmin.php?disp=edit&gid=$gid\">EDIT</a> )</center><br>";
    }

}

function update_group ( $gid ) {
   global $users, $pgroles, $dbconn;
   $error = 0; // for tracking SQL errors
   // create the new group and assign it to the indicated users
   // get the new users from the POST data and put in a clean array

   // update the user_groups table
   $uupdate = "INSERT INTO user_groups
               (gid, pn_uname) VALUES ($gid, ?)";
   $uustmt = $dbconn->Prepare($uupdate);
   // find all users that currently have the group assigned
   $cugq = "SELECT count(u.pn_uname) 
            FROM users as u
            LEFT JOIN user_groups as ug ON u.pn_uname = ug.pn_uname
            WHERE ug.gid = $gid AND ug.pn_uname = ?";
   $cugstmt = $dbconn->Prepare($cugq);
   if ( ! empty( $users)){
      foreach($users as $user) {
         // see if this users already has the group
         $exists = $dbconn->GetOne($cugstmt,array($user));
         if($exists == 1) {
            // yes, move on
            next;
         } else {
            // no, add the entry to the table
            $res = $dbconn->execute($uustmt,array( $user ));
            if($res === false) {
               $msg[] = "SQL Error 2:  " . $dbconn->ErrorMsg();
               $error++;
            }
         }
      }
   }
   // update the group_roles table
   $grinsq = "INSERT INTO group_roles (gid, roleID)
              VALUES ($gid, ?)";
   $grinsstmt = $dbconn->Prepare($grinsq);
   $grq = "SELECT count(gr.gid)
           FROM group_roles
           WHERE gid = $gid AND roleID = ?";
   $grstmt = $dbconn->Prepare($grq);
   if ( ! empty( $pgroles)){
      foreach($pgroles as $pgr) {
         $exists = $dbconn->GetOne($grstmt, array( $pgr ));
         if($exists == 1) {
           // already there, do nothing
         } else {
            // not there, add it
            $res = $dbconn->execute($grinsstmt, array( $pgr ));
            if($res === false) {
               $error++;
               $errMsg[] = "SQL Error - ins $pgr: " . $dbconn->ErrorMsg();
            }
         }
      }
   }

      // update the group_roles table
      //   flush all roles not in the new list
      $delgrq = "DELETE FROM group_roles
                 WHERE gid = $gid AND
                    roleID NOT IN (" . implode(",", $pgroles) . ")";
      $delgrr = $dbconn->execute($delgrq);
      if($delgrr === false) {
         $errMsg[] = "SQL Error - del group_roles: " . $dbconn->ErrorMsg();
         $error++;
      }
      // update the user_groups table with the current users
      // remove any users that shouldn't be there
      $q = "DELETE FROM user_groups
            WHERE gid = $gid 
               AND pn_uname NOT IN ('" . implode("','", $users) ."')";
      $r = $dbconn->execute($q);
      if($r === false) {
         $error++;
         $errMsg[] = "SQL Error - del user_groups: " . $dbconn->ErrorMsg();
      }

   // report back to user
   if($error == 0) {
         if ( ! empty( $msg )){
         echo implode("<br>", $msg);
         }
   } else {
      echo "<table class='error'><tr><th>Error</th></tr>
            <tr><td>";
      echo implode("<br>", $errMsg);
      echo "</td></tr></table>";
   }
   echo "<p></p>";

   edit_group ( $gid );

}

// close out the HTML page

function create_group ( $groupName, $groupDesc ) {
    global $users, $pgroles, $dbconn;

    $gcreate = "INSERT INTO groups (groupName, groupDesc) VALUES ('$groupName', '$groupDesc')";
    $gcresult = $dbconn->execute($gcreate);
    if($gcresult === false) {
       echo "SQL Error creating group entry:  " . $dbconn->ErrorMsg();
       require_once('footer.php');
       die();
    } else {
       // get the gid for use in the users table
       $gid = $dbconn->Insert_Id();
    }
                 // update the group entry in the groups table
      $gupdate = "UPDATE groups SET
                     groupName = '$groupName', 
                     groupDesc = '$groupDesc'
                  WHERE gid = $gid";
      $guresult = $dbconn->execute($gupdate);
      if($guresult === false) {
         $errMsg[] = "SQL Error - update groups:  " . $dbconn->ErrorMsg();
         $error++;
      } else {
         $msg[] = "Group attributes updated.";
      }

      update_group ( $gid );
}

function delete_group ( $gid ) {
    global $dbconn;

    // tables to remove references to this group
    $tables = array ("user_groups", "group_roles", "groups");
    foreach($tables as $t) {
       $q = "DELETE from $t
               WHERE gid = $gid";
       $r = $dbconn->execute($q);
       if($r == false) {
          $error++;
          $errMsg[] = "SQL Error - del $t: " . $dbconn->ErrorMsg();
       } else {
          $msg[] = "Group $gid has been deleted from $t.";
       }
    }
    // zero out the users array so that the common cleanup code
    // below can be used to remove the gid from the users table entries.
    $users = "";
    list_groups ( );

}

function lookup_gid ( $gid ) {
    global $data, $gusers, $groupRoles, $dbconn;

// get group information
   if($gid <> "") {
      // get all users that have this group assigned
      $uquery = "SELECT u.pn_uname FROM users as u
         LEFT JOIN user_groups as ug ON u.pn_uname = ug.pn_uname
         WHERE ug.gid = $gid ORDER BY u.pn_uname ASC";

      $result = $dbconn->GetArray($uquery);
      if($result === false) {
         echo "SQL Error:  " . $dbconn->ErrorMsg();
         require_once('footer.php');
         die();
      }

      $gusers = array();
      foreach($result as $user) {
         $gusers[] = $user['pn_uname']; 
      }

      $gq = "SELECT * FROM groups WHERE gid = $gid";
      $result = $dbconn->GetArray($gq);
      if($result === false) {
         echo "SQL Error:  " . $dbconn->ErrorMsg();
         require_once('footer.php');
         die();
      } else {
         $data = $result[0];
      }
      // get group roles
      $gr = "SELECT r.roleID, r.roleName, r.roleDesc
             FROM group_roles as gr
             LEFT JOIN roles as r ON gr.roleID = r.roleID
             WHERE gr.gid = $gid
             ORDER BY r.roleName";
      $result = $dbconn->GetArray($gr);
      $groupRoles = array();
      if($result === false) {
         echo "SQL Error:  " . $dbconn->ErrorMsg();
         require_once('footer.php');
         die();
      } else {
         foreach($result as $grole) {
            //    $groupRoles[$grole['roleID']] = array( 'roleName' => $grole['roleName'],
            //         'roleDesc' => $grole['roleDesc'] );;
            $groupRoles[$grole['roleID']] = "[" . $grole['roleName'] . "] - " . $grole['roleDesc'];
        }
     }
  }
}

function edit_group ( $gid ) {
    global $data, $gusers, $groupRoles, $allRoles, $ausers, $dbconn;

    //POPULATE SHARED GROUP ARRAY USED BY VIEW/EDIT ROUTINES
    lookup_gid ( $gid );

    navbar ( $gid );

    // prep the form fields array
    $formFields = array( "Group Name" => array( "name" => "groupName",
         "type" => "input",
         "value" => $data['groupName']),
      "Group Description" => array( "name" => "groupDesc",
         "type" => "textarea",
         "value" => $data['groupDesc']),
      "Group Roles" => array( "name" => "groupRoles[]",
         "type" => "twobox",
         "id" => "grs",
         "nameIndex" => 1,
         "value" => $allRoles,
         "selected" => array_keys($groupRoles),
         "multiple" => 5),
      "Group Members" => array("name" => "groupMembers[]",
         "type" => "twobox",
         "id" => "gms",
         "nameIndex" => 0,
         "value" => $ausers,
         "selected" => $gusers,
         "multiple" => 5) );

    $formButtons = array( "Submit" => array( "name" => "submit",
         "type" => "submit",
         "value" => "Update Group"));

    $formHidden = array( "disp" => "update", "gid" => $gid );

    $formData = array( "summary" => "Modify User Group",
         "fields" => $formFields,
         "hidden" => $formHidden,
         "onsubmit" => "selectAllOptions('gms');selectAllOptions('grs');",
         "buttons" => $formButtons);
    drawForm($formData,$_SERVER['PHP_SELF']);
}

function  list_groups ( ) {
   global $dbconn;

   navbar ( "" );

   // draw the table with the current groups
   $query = "SELECT gid, groupName, groupDesc FROM groups ORDER BY groupName ASC";
   $results = $dbconn->GetArray($query);
   if($results === false) {
      echo "SQL Error: " . $dbconn->ErrorMsg();
      require_once('footer.php');
      die();
   }

   $tableFieldMap = array( //"Group ID" => "gid",
      "Group Name" => "groupName",
      "Group Description" => "groupDesc",
      //"Group Roles" => "groupRoles",
      "Links" => array( "View" => array(
          "url" => "gadmin.php?disp=view&gid=%param%",
          "param" => "gid",
          "icon" => "images/zoom.png"),
      "Edit" => array(
          "url" => "gadmin.php?disp=edit&gid=%param%",
          "param" => "gid",
          "icon" => "images/pencil.png"),
      "Delete" => array(
          "url" => "gadmin.php?disp=delete&gid=%param%",
          "param" => "gid",
          "onclick" => "return confirmDelete();",
          "icon" => "images/delete.png")));
      drawTable($tableFieldMap, $results, "User Groups");

}

function new_group ( ) {
   global $ausers, $allRoles, $dbconn;

   navbar ( "" );

   // create a new group
   $formFields = array( "Group Name" => array( "name" => "groupName",
         "type" => "input",
         "value" => ""),
      "Group Description" => array( "name" => "groupDesc",
         "type" => "textarea",
         "value" => ""),
      "Group Roles" => array( "name" => "groupRoles[]",
         "type" => "select",
         "nameIndex" => 1,
         "value" => $allRoles,
         "multiple" => 5),
      "Group Members" => array( "name" => "groupMembers[]",
         "type" => "select",
         "nameIndex" => 0,
         "value" => $ausers,
         "multiple" => 5) );

      $formButtons = array( "Submit" => array( "name" => "submit",
         "type" => "submit",
         "value" => "Create Group"));

      $formHidden = array( "disp" => "create" );

      $formData = array( "summary" => "New User Group",
         "fields" => $formFields,
         "hidden" => $formHidden,
         "buttons" => $formButtons);

      drawForm($formData,$_SERVER['PHP_SELF']);

}

function view_group ( $gid ) {
    global $data, $gusers, $groupRoles, $dbconn;

    //POPULATE SHARED GROUP ARRAY USED BY VIEW/EDIT ROUTINES
    lookup_gid ( $gid );

    navbar ( $gid );

    $tmpgr = 
    $formFields = array( "Group Name" => $data['groupName'],
       "Group Description" => $data['groupDesc'],
       "Group Roles" => implode("<br>",array_values($groupRoles)),
       "Group Members" => implode("<br>",$gusers) );

    $formData = array( "summary" => "View User Group",
       "fields" => $formFields);

    drawForm($formData,$_SERVER['PHP_SELF']);

}

switch($disp) {

     case "create":
          create_group( $groupName, $groupDesc );
          break;

     case "delete":
          delete_group( $gid );
          break;

     case "edit":
          edit_group( $gid );
          break;

     case "new":
          new_group( );
          break;

     case "update":
          update_group( $gid );
          break;

     case "view":
          view_group( $gid );
          break;

    default:
          list_groups( $gid );
          break;

}


require_once('footer.php');

?>
