<?php
//
// $Id: orgs.php,v 1.10 2008/03/06 20:15:01 kkline Exp $
//
/***********************************************************/
/*                    Inprotect                            */
/* --------------------------------------------------------*/
/* Copyright (C) 2006 Inprotect                            */
/*                                                         */
/* This program is free software; you can redistribute it  */
/* and/or modify it under the terms of version 2 of the    */
/* GNU General Public License as published by the Free     */
/* Software Foundation.                                    */
/* This program is distributed in the hope that it will be */
/* useful, but WITHOUT ANY WARRANTY; without even the      */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE. See the GNU General Public License  */
/* for more details.                                       */
/*                                                         */
/* You should have received a copy of the GNU General      */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 59 Temple Place, */
/* Suite 330, Boston, MA 02111-1307 USA                    */
/*                                                         */
/* Contact Information:                                    */
/* inprotect-devel@lists.sourceforge.net                   */
/* http://inprotect.sourceforge.net/                       */
/***********************************************************/
/* See the README.txt and/or help files for more           */
/* information on how to use & config.                     */
/* See the LICENSE.txt file for more information on the    */
/* License this software is distributed under.             */
/*                                                         */
/* This program is intended for use in an authorized       */
/* manner only, and the author can not be held liable for  */
/* anything done with this program, code, or items         */
/* discovered with this program's use.                     */
/***********************************************************/

$pageTitle = "Manage Infrastructure";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');
//require_once('permissions.inc.php');

$users=array();	#PREDEFINED ARRAY FOR UPDATE ROUTINE SO THAT PHP WARNINGS DONT COMPLAIN
$sites=array();	#PREDEFINED ARRAY FOR UPDATE ROUTINE SO THAT PHP WARNINGS DONT COMPLAIN

$getParams = array( "disp", "nid" );
$postParams = array( "disp", "nid", "nname", "org_code", "ndescription", "npoc", "nelist", "nweb" );

switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach($getParams as $gp) {
      if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else { 
         $$gp=""; 
      }
   }
   break;
case "POST" :
   foreach($postParams as $pp) {
      if (isset($_POST[$pp])) { 
         $$pp=htmlspecialchars(mysql_real_escape_string(trim($_POST[$pp])), ENT_QUOTES); 
      } else { 
         $$pp=""; 
      }
   }
   break;
}

if(isset($_POST['authorized_users'])) {
   foreach($_POST['authorized_users'] as $user) {
      $users[] = htmlspecialchars(mysql_real_escape_string(trim($user)), ENT_QUOTES); 
   }
}

if(isset($_POST['org_sites'])) {
   foreach($_POST['org_sites'] as $site) {
      $sites[] = htmlspecialchars(mysql_real_escape_string(trim($site)), ENT_QUOTES); 
   }
}

if ( $uroles['admin'] || $uroles['infrastructure'] )  {

} else {
   logAccess( "ACCESS DENIED" );
   echo "Access Denied!!!<br>";
   include_once('footer.php');
   exit;
}

function navbar ( $nid ) {
   global $uroles, $dbconn;

   echo "<center><h3>Manage orgs</h3>
      [ <a href=\"orgs.php\">Main</a> ]";
      if ($nid) {

         $query = "SELECT name FROM I3_orgs WHERE id='$nid'";
         $result = $dbconn->execute($query);
         list($sitename) = $result->fields;

         echo " -> Edit Org [ <font color=red>$sitename</font> ] ( ";

         echo "<a href=\"orgs.php?disp=info&nid=$nid\">OVERVIEW</a>";
         if ( $uroles['infrastructure'] ) {
            echo "| <a href=\"orgs.php?disp=edit_org&nid=$nid\">NAME</a>";
            echo "| <a href=\"orgs.php?disp=editsites&nid=$nid\">SITES</a>";      
            echo "| <a href=\"orgs.php?disp=editusers&nid=$nid\">USERS</a>";
         }
         echo " )";
      }
      echo "</center><br>";
}

function delete_org($nid ){
   global $enableADSubs, $uroles, $dbconn;

   if ( $enableADSubs && $uroles['infrastructure'] )  {

      $query = "DELETE FROM I3_org_users WHERE orgID='$nid' LIMIT 1";
      $result = $dbconn->execute($query);

      $query = "DELETE FROM I3_org_sites WHERE orgID='$nid' LIMIT 1";
      $result = $dbconn->execute($query);

      $query = "DELETE FROM I3_orgs WHERE id='$nid' LIMIT 1";
      $result = $dbconn->execute($query);
      echo "Deleted ORG $nid";
   }

   show_orgs("");
}

function edit_org($nid ){
   global $username, $dbconn;

   navbar ( $nid );

   if ( $nid ) {

      $query = "SELECT name, org_code, description, poc, email_list, website FROM I3_orgs WHERE id='$nid'";
      $result = $dbconn->execute($query);
      list( $nname, $org_code, $ndescription, $npoc, $nelist, $nweb  ) = $result->fields;

      echo "<b>Edit org - \"$nname\"</b><br>";
   } else {
      echo "<b>Add new org</b><br>";
   }
   echo <<<EOT
<form method="POST" action="orgs.php">
<input type="hidden" name="disp" value="save_org">
EOT;

   if ( $nid ) {
      echo "<input type=\"hidden\" name=\"nid\" value=\"$nid\">";
   }

   echo <<<EOT
<table width='100%'>
   <tr><td width='35%' align="right">Name:</td>
      <td><input type="text" name="nname" value="$nname" size="30" maxlength="50"></td>
      </tr>
      <tr><td align="right">ABBREV:</td>
      <td><input type="text" name="org_code" value="$org_code" size="15" maxlength="25"></td>
      </tr>
      <tr><td align="right">POC:</td>
      <td><input type="text" name="npoc" value="$npoc" size="30" maxlength="100"></td>
      </tr>
      <tr><td align="right">Distribution List:</td>
      <td><input type="text" name="elist" value="$nelist" size="30" maxlength="500"></td>
      </tr>
      <tr><td align="right">Website:</td>
      <td><input type="text" name="nweb" value="$nweb" size="30" maxlength="100"></td>
      </tr>
      <tr><td align="right">Description:</td>
      <td>
      <textarea wrap="virtual" cols="70" rows="15" name="ndescription">$ndescription</textarea>
      </td>
      </tr>
      <tr><td>&nbsp;</td>
      <td>
      <input type="submit" name="submit" value="Save"></form>
      </td>
      </tr>
      </table>
EOT;


}

function manage_org_sites( $nid ) {
   global $confirm, $dbconn;

   navbar ( $nid );

   $query = "SELECT name FROM I3_orgs WHERE id='$nid'";
   $result = $dbconn->execute($query);
   list($sname) = $result->fields;


     echo <<<EOT
<br>
<form action="/orgs.php" method="POST" onSubmit="selectAllOptions('associated');">
<TABLE width=100% border=0>

<TR>
     <TD colSpan=3>
     <h4>ORG "$sname" Associated Sites:</h4>
     </TD>
</TR>
<TR>
<TD valign=top align=left width=150>Associated<br>
         <input type="hidden" name="disp" value="setsites">\n
         <input type="hidden" name="nid" value="$nid">\n
    <select name="org_sites[]" id="associated" style="WIDTH: 187px; HEIGHT: 200px" multiple="multiple" size=20>
EOT;

      $query = "SELECT t2.id, t2.name FROM I3_org_sites t1
         LEFT JOIN I3_sites t2 on t1.siteID = t2.id
         WHERE t1.orgID = '$nid'";

      $result = $dbconn->execute($query);

      while(list($nuid, $nuname) = $result->fields) {
         echo "<OPTION value=\"$nuid\">$nuname</OPTION>";
         $result->MoveNext();
      }

     echo <<<EOT

</SELECT></td>
<td><input type='button' value='<< Add' onclick="move2(this.form.available,this.form.associated )"><br/>
<input type='button' value='Remove >>' onclick="move2(this.form.associated,this.form.available)"></td>
     <td valign=top align="left">Unassigned Sites<br>
          <select name="avail_sites[]" id="available" style="WIDTH: 187px; HEIGHT: 200px" multiple="multiple" size=20>\n";
EOT;


      $query = "SELECT t1.id, t1.name
         FROM I3_sites t1
         LEFT JOIN I3_org_sites t2 ON t1.id = t2.siteID
         WHERE t2.orgID is Null ORDER BY t1.name";
      $result = $dbconn->execute($query);

      while(list($nuid, $nuname) = $result->fields) {
         echo "<OPTION value=\"$nuid\" >$nuname</OPTION>";
         $result->MoveNext();
      }
     echo <<<EOT
</select>
</td></tr>
<tr><td colspan="3"><input type='submit' name='submit' value='Update Org Sites'></input></td></tr>
</TABLE></form>
EOT;

}

function manage_org_users($nid) {
   global $dbconn;

   navbar ( $nid );

   $query = "SELECT name FROM I3_orgs WHERE id='$nid'";
   $result = $dbconn->execute($query);
   list($sname) = $result->fields;

     echo <<<EOT
<br>
<form action="/orgs.php" method="POST" onSubmit="selectAllOptions('authorized');">
<TABLE width=100% border=0>

<TR>
     <TD colSpan=3>
     <h4>ORG "$sname" User Membership:</h4>
     </TD>
</TR>
<TR>
<TD valign=top align=left width=150>Authorized Users<br>
         <input type="hidden" name="disp" value="setusers">
         <input type="hidden" name="nid" value="$nid">
    <select name="authorized_users[]" id="authorized" style="WIDTH: 187px; HEIGHT: 200px" multiple="multiple" size=20>
EOT;
      $query = "SELECT t1.pn_uname
         FROM users t1
         LEFT JOIN I3_org_users t2 on t1.pn_uname = t2.pn_uname
         WHERE t2.orgID = '$nid'";
      $result = $dbconn->execute($query);

      while(list( $nuname ) = $result->fields) {
         echo "<OPTION value=\"$nuname\">$nuname</OPTION>\n";
         $result->MoveNext();
      }

     echo <<<EOT

</SELECT></td>
<td><input type='button' value='<< Add' onclick="move2(this.form.unauthorized,this.form.authorized )"><br/>
<input type='button' value='Remove >>' onclick="move2(this.form.authorized,this.form.unauthorized)"></td>
     <td valign=top align="left">
          <select name="unauth_users[]" id="unauthorized" style="WIDTH: 187px; HEIGHT: 200px" multiple="multiple" size=20>\n";
EOT;

      $query = "SELECT t1.pn_uname FROM users t1
         LEFT JOIN I3_org_users t2 ON t1.pn_uname = t2.pn_uname
         WHERE t2.pn_uname is Null ORDER BY t1.pn_uname";
      $result = $dbconn->execute($query);

      while(list( $nuname ) = $result->fields) {
         echo "<OPTION value=\"$nuname\" >$nuname</OPTION>\n";
         $result->MoveNext();
      }

     echo <<<EOT
</select>
</td></tr>
<tr><td colspan="3"><input type='submit' name='submit' value='Update Access'></input></td></tr>
</TABLE></form>
EOT;

}

function org_info ( $nid ) {
   global $dbconn;

   navbar ( $nid );
   $query = "SELECT  name, org_code, description, poc FROM I3_orgs
      WHERE id='$nid' LIMIT 1";

   $result = $dbconn->execute($query);
   $row = $result->fields;

   list($nname) = $row;

   if (!$row) {
      echo "[ $nid ] - NO MATCH FOUND";
   } else {

      echo <<<EOT
<font color="red"><h5>ORG [ $nname ]</h5></font>
<table width="100%" summary="Search results" border=1 style="border-collapse: collapse"
      cellspacing="5" cellpadding="2">
   <tr>
      <td width="25%" align="right"><h5><b>ATTRIBUTES</b></h5></td>
      <td ><h5><b>VALUE</b></h5></td>
   </tr>
EOT;
	  if ( !empty( $row)) {
         foreach ($row as $k => $v) {
            if ( !is_numeric($k) ) {
               echo "<tr><td align=\"right\">$k</td><td>$v</td></tr>";
            }
         }
	  }
      echo "</table><br>";
   }

   $query = "SELECT t1.name
      FROM I3_sites t1
      LEFT JOIN I3_org_sites t2 on t1.id = t2.siteID
      WHERE t2.orgID = '$nid'";
   $result = $dbconn->execute($query);

   echo <<<EOT

<font color="red">
   <h5>ORG [ $nname ] Affiliated Sites</h5></font>
   <table width="100%" summary="Search results" border=1 style="border-collapse: collapse"
      cellspacing="5" cellpadding="2">
EOT;

   if ( !empty( $result)){
      while( !$result->EOF ) {
   	     list($suser ) = $result->fields;
         echo "<tr><td>$suser</td></tr>";
         $result->MoveNext();
      }
   }
   echo "</table>";

   $query = "SELECT t1.pn_uname
      FROM users t1
      LEFT JOIN I3_org_users t2 on t1.pn_uname= t2.pn_uname
      WHERE t2.orgID = '$nid'";
   $result = $dbconn->execute($query);

   echo <<<EOT
<font color="red">
   <h5>REPORT ACCESS [ $nname ]</h5></font>
   <table width="100%" summary="Search results" border=1 style="border-collapse: collapse"
      cellspacing="5" cellpadding="2" >
EOT;

   if ( !empty( $result)){
      while( !$result->EOF ) {
   	     list($suser ) = $result->fields;
         echo "<tr><td>$suser</td></tr>";
         $result->MoveNext();
      }
   }

   echo "</table>";

}

function save_org($nid, $nname, $org_code, $ndescription, $npoc, $nelist, $nweb ){
   global $username, $dbconn;

   $dtinsert = gen_timeasstr();

   $flag=1;

   if($nname==""){
      $flag=0;
      $problemtext="org Name name cannot be blank!";

      echo "<center><b>Error</b></center><br><br>"
         ."There was a problem saving configuration:<br />$problemtext<br><br>";
      exit;
   } elseif( $org_code=="" ){
      $flag=0;
      $problemtext="org code cannot be blank!";

      echo "<center><b>Error</b></center><br><br>"
         ."There was a problem saving configuration:<br />$problemtext<br><br>";
      exit;
   } 

   if( $nid ){
      $query="UPDATE I3_orgs SET name='$nname', org_code='$org_code', description='$ndescription', 
         poc='$npoc', email_list='$nelist', website='$nweb' WHERE id='$nid'";
   } else {   
      $query="INSERT INTO I3_orgs
         ( name, org_code, description, poc, email_list, website ) VALUES 
         ( '$nname', '$org_code', '$ndescription', '$npoc', '$nelist', '$nweb' )";
   }

   $result = $dbconn->execute($query);

   logAccess( "org [ $nname ] MODIFIED" );

   echo "Sucessfully added/Updated org<br><br>";

   org_info ( $nid );

}

function show_orgs( ) {
   global $enableADSubs, $uroles, $username, $org_code, $dbconn;

   navbar ( "" );

  $query = "SELECT id, name, org_code, description, poc FROM I3_orgs ORDER by name";
   $result = $dbconn->execute($query);

   echo "<B>DEFINED orgs</B><BR>
<table border=0 width='100%'>
<tr>
   <td>POC's</td><td>Name</td>
   <td>org_code</td>
   <td>Description</td>
   <td>POC Email</td><td>Manage</td>
</tr>";

   while ( !$result->EOF ) {
      list( $orgid, $sname, $ORG, $sdescription, $poc ) = $result->fields;

      $query2 = "SELECT count( t2.pn_uname ) FROM I3_orgs t1
         LEFT JOIN I3_org_users t2 ON t1.id = t2.orgID
         WHERE t2.orgID = '$orgid'";
      $result2 = $dbconn->execute($query2);

      list( $cntManual ) =  $result2->fields;

      echo "<tr>
         <td><A href=\"orgs.php?disp=editusers&nid=$orgid\">";
      if (  $cntManual < "1" ) {      
         echo "<font size=\"4\" color=\"red\">$cntManual</font>";
      } elseif (  $cntManual == "1" ) {
         echo "<font size=\"4\" color=\"orange\">$cntManual</font>";
      } else {
         echo "<font size=\"4\" color=\"green\">$cntManual</font>";
      }

      echo <<<EOT
</a></td><td><A href="orgs.php?disp=info&nid=$orgid">$sname</A></td>
      <td>$ORG</td>
      <td>$sdescription</td>
      <td>$poc</td>
      <td align="center"><a href="orgs.php?disp=info&nid=$orgid"><img src="images/zoom.png"></a>&nbsp;
      <a href="orgs.php?disp=edit_org&nid=$orgid"><img src="images/pencil.png"></a>&nbsp;      
EOT;
      if ( $enableADSubs && $uroles['admin'] ) {
         echo <<<EOT
<a href="orgs.php?disp=del_org&amp;nid=$orgid" onclick="return confirmDelete();">
   <img alt="Delete" src="images/delete.png" border=0 title="Delete report"></a></td></tr>
EOT;
      } else {
         echo <<<EOT
</td></tr>
EOT;
      }
      $result->MoveNext();
   }

   echo <<<EOT
</table><br>
<a href="orgs.php?disp=add">Add new org</A>
EOT;


}

function update_org_sites( $nid, $sites ) {
   global $orgname, $username, $dbconn;

   if ( $nid ) {
      $query = "DELETE FROM I3_org_sites WHERE orgID='$nid'";
      $result = $dbconn->execute($query);
   }

   if ( $nid && $sites ) {

      $query = "SELECT name FROM I3_orgs WHERE id='$nid'";
      $result = $dbconn->execute($query);
      list($name) = $result->fields;
      echo "Updating ORG Associated Sites: [$name]<br>";

      foreach( $sites as $nsite ) {
         if ( $nsite ) {
            $query = "INSERT INTO I3_org_sites ( orgID, siteID) 
               VALUES ( '$nid', '$nsite' );";
            $result = $dbconn->execute($query);
         }
      }
      logAccess( "org [ $name ] ASSOCIATED SITES MODIFIED" );
   }

   echo "<br>";

   manage_org_sites($nid);
}

function update_org_users( $nid,  $users ) {
   global $orgname, $username, $dbconn;

   if ( $nid ) {
      $query = "DELETE FROM I3_org_users WHERE orgID='$nid'";
      $result = $dbconn->execute($query);
   }

   if ( $nid &&  $users ) {

      $query = "SELECT name FROM I3_orgs WHERE id='$nid'";
      $result = $dbconn->execute($query);
      list($name) = $result->fields;
      echo "UPDATING USERS FOR ZONE: [$name]<br>";

      foreach( $users as $nuser ) {
         if ($nuser) {
            $query = "INSERT INTO I3_org_users (pn_uname, orgID) 
               VALUES ('$nuser', $nid );";
            $result = $dbconn->execute($query);
         }
      }
      logAccess( "org [ $name ] ACCESS MODIFIED" );
   }

   echo "<br>";

   manage_org_users($nid);
}

switch($disp) {

   case "add":
      edit_org('');
      break;

   case "del_org":
      delete_org($nid);
      break;


   case "edit_org":
      edit_org($nid);
      break;

   case "editusers":
      manage_org_users($nid);
      break;

   case "editsites":
      manage_org_sites($nid);
      break;

   case "info":
      org_info($nid);
      break;

   case "save_org":
      save_org($nid, $nname, $org_code, $ndescription, $npoc, $nelist, $nweb );
      break;

   case "setsites":
      update_org_sites( $nid, $sites );
      break;

   case "setusers":
      update_org_users( $nid,  $users );
      break;

   default:
      show_orgs( );
      break;

}

require_once('footer.php');
?>



