<?php

$pageTitle = "Portscan Results";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');

$pageSize = 50;

$isReportAdmin = ($uroles['admin'] || $uroles['reports']) ? TRUE : FALSE;


$getParams = array( "disp", "pid", "sortby", "sortdir", "allres", "wh", "bg" );
$postParams = array( "disp", "pid", "type", "value" );

$post = FALSE;

switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach($getParams as $gp) {
	   if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else {
         $$gp = "";
      }
   }
	break;
case "POST" :
   $post = TRUE;
   foreach($postParams as $pp) {
      if (isset($_POST[$pp])) {
        $$pp=htmlspecialchars(mysql_real_escape_string(trim($_POST[$pp])), ENT_QUOTES);
      } else {
        $$pp = "";
      }
   }
	break;
}

if(isset($offset)) {
   if(!is_numeric($offset)) {
      $offset=0;
   }
} else {
   $offset=0;
}


function delete_results( $pid, $wh, $bg ) {
   global $enableDelProtect, $uroles, $sitename, $username, $dbconn;

   #POTENTIALLY ALL ORG MEMBERS DELETE SHARED REPORTS IN THE FUTURE
   if ( ! $uroles[admin] ) { $sql_filter = " AND username='$username'";  }
   $query="select count(id) from portscan where id=$pid and username='$username'";
   $result=$dbconn->execute($query);
   list ($pcount)=$result->fields;

   if ( ! $pcount ) {
      logAccess( "FAILED ATTEMPT TO DELETE PORTSCAN [ $pid ]" );
      die("Cannot access this page - unable to find portscan or possible error in the URL."); 
   } else {
      logAccess( "DELETED - REPORT [ $report_id ]" );

      if ($pcount<>0) {
         $query="delete from portscan_results where id=$pid";
         $result=$dbconn->execute($query);
         $query="delete from portscan where id=$pid";
         $query=$dbconn->execute($query);
         echo "Results deleted. <a href=\"portscanres.php\">Back</a> to the results page.";
      }	else { 
         echo "Portscan results cannot be found or Permission denied. N.B. Only the report owner can delete results"; 
      }

      echo "<font face=\"Verdana\" color=\"#666666\" size=\"2\">Vulnerability test results have been deleted.<BR></font>";
      echo "<br>";
     list_results ( $type, $value, $scanstate, $sortby, $sortdir );
   }
}

function list_results ( $type, $value, $scanstate, $sortby, $sortdir ) {
   global $isReportAdmin , $allres, $offset, $pageSize, $username, $dbconn;

   $filteredView = FALSE;

   $selRadio = array( "","","","");

   $query_onlyuser="";
   if (!$isReportAdmin || (!$allres)) { $query_onlyuser=" AND username='$username' "; }

   if ($sortby == "" ) { $sortby = "submittime"; }
   if ($sortdir == "" ) { $sortdir = "DESC"; }

   echo "<H3>Reports</H3>";

   $queryw="";
   $queryl="";

   $querys="SELECT id, username, scanip, submittime, scancomplete FROM portscan WHERE scancomplete='Y' ";

   // set up the SQL query based on the search form input (if any)
   switch($type) {
   case "submittime":
      $filteredView = True;
      $selRadio[0] = "CHECKED";
      $q = $value;
      $queryw = " AND submittime LIKE '%$q%' $query_onlyuser ORDER BY $sortby $sortdir";
      $stext =  "Search for Date/Time = '*$q*'";
      break;
   case "hostip":
      $filteredView = True;
      $selRadio[1] = "CHECKED";
      $q = strtolower($value);
      $queryw = " AND scanip LIKE '%$q%' $query_onlyuser ORDER BY $sortby $sortdir";
      $stext =  "Search for HostIP = '*$q*'";
      break;
   case "username":
      $filteredView = True;
      $selRadio[3] = "CHECKED";
      $q = strtolower($value);
      $queryw = " AND username LIKE '%$q%' ORDER BY $sortby $sortdir";
      $stext = "Search for Username = '*$q*'";
      break;

   default:
      $selRadio[1] = "CHECKED";
      $queryw = " $query_onlyuser ORDER BY $sortby $sortdir";
      $queryl = " LIMIT $offset,$pageSize"; 
      $stext = "";
      break;
   }

   // put link to add new host
  
   if ($isReportAdmin) {
      $url_allres="&allres=";
      if ($allres=="" || !is_numeric($allres) || (!$allres)) {
         $allres=0;
         echo "<a href='portscanres.php?offset=$next".$url_allres."1'>Show all results</a><br>";
      } else {
         $allres=1;
         echo "<a href='portscanres.php?offset=$next".$url_allres."0'>Display only my Results</a><br>";
      }
      $url_allres .="$allres";
   }
   
   // echo the search criteria used

   // set up the pager and search fields if viewing all hosts
   $reportCount = 0;
   if(!$filteredView) {
      $queryc = "SELECT count(id) FROM portscan WHERE scancomplete='Y' ";
      $reportCount = $dbconn->GetOne($queryc.$queryw);
      $previous = $offset - $pageSize;
      if ($previous < 0) {
         $previous = 0;
      }
      $last = $reportCount - $pageSize;
      if ( $last < 0 ) { $last = 0; }
      $next = $offset + $pageSize;
      if ($next > $last) {
         $next = $last;
      }
      $pageEnd = $offset + $pageSize;
      echo "<p>There are $reportCount scans defined in the system.";
      // output the search form
      echo <<<EOT
<!--<form name="hostSearch" onSubmit="return OnSubmitForm();">-->
<form name="hostSearch" action="portscanres.php" method="GET">
<input type="text" length="25" name="value" value="$value">
EOT;
echo "
<input type=\"radio\" name=\"type\" value=\"submittime\" $selRadio[0]>Date/Time
<input type=\"radio\" name=\"type\" value=\"hostip\" $selRadio[1]>Host IP
<input type=\"radio\" name=\"type\" value=\"username\" $selRadio[3]>Username
";
     echo <<<EOT
<input type="hidden" name="sortby" value="$sortby">
<input type="hidden" name="allres" value="$allres">
<input type="hidden" name="op" value="search">
<input type="submit" name="submit" value="Find">
</form>
</p>
EOT;
      // output the pager
      echo "<p align=center><a href='portscanres.php?offset=0".$url_allres."' class='pager'>&lt&lt First</a> | ";
      if($offset != 0) {
         echo "<a href='portscanres.php?offset=$previous".$url_allres."' class='pager'>&lt Previous </a> | ";
      }
      if($pageEnd >= $reportCount) { $pageEnd = $reportCount; }
      echo "[ $offset - $pageEnd of $reportCount ] | ";
      if($next < $last) {
         echo "<a href='portscanres.php?offset=$next".$url_allres."' class='pager'>| Next &gt;</a> | ";
      }
      echo "<a href='portscanres.php?offset=$last".$url_allres."' class='pager'> Last &gt;&gt;</a></p>";
   } else {
      // get the search result count
      $queryc = "SELECT count(id) FROM portscan WHERE scancomplete='Y' ";
      $scount=$dbconn->GetOne($queryc.$queryw);
      echo "<p>$scount report";
      if($scount != 1) {
         echo "s";
      } else {
      }
      echo " found matching search criteria | "; 
      echo " <a href='portscanres.php' alt='View All Reports'>View All Reports</a></p>";
   }

   echo "<p>";
   echo $stext;
   echo "</p>";


   // get the hosts to display
   $result=$dbconn->GetArray($querys.$queryw.$queryl);
   if($result === false) {
      $errMsg[] = "Error getting results: " . $dbconn->ErrorMsg();
      $error++;
      dispSQLError($errMsg,$error);
   } else {
   	  $tdata = array();
      foreach($result as $data) {
         $data['hlink'] = "portscanres.php?disp=view&amp;pid=".$data['id'];
         $tdata[] = $data;

      }

      if($sortdir == "ASC") { $sortdir = "DESC"; } else { $sortdir = "ASC"; }
      $url = $_SERVER['PHP_SELF'] . "?offset=$offset&sortby=%var%&sortdir=$sortdir";
      $fieldMap = array(

          "Links" => array( "View" => array(
                'url' => '%param%',
                'param' => 'hlink',
                'icon' => 'images/html.png')),
          "Username" => array( 'var' => 'username',
                                              'link' => $url ),
          "Host IP" => array( 'var' => 'scanip',
                                        'link' => $url ),
          "Submit Time" => array( 'var' => 'submittime',
                                            'link' => $url ),
          "Scan Complete" => array( 'var' => 'scancomplete',
                                                 'link' => $url ));
      drawTable($fieldMap, $tdata, "Hosts");

   }

   // draw the pager again, if viewing all hosts
   if(!$filteredView) {
      echo <<<EOT
<p align=center>
<a href="portscanres.php?offset=0" class="pager">&lt&lt First</a>
<a href="portscanres.php?offset=$previous" class="pager">&lt Previous </a>
<a href="portscanres.php?offset=$next" class="pager">| Next &gt;</a>
<a href="portscanres.php?offset=$last" class="pager"> Last &gt;&gt;</a>
</p>
EOT;
   }
}

function view_scan ( $pid ) {
   global $isReportAdmin , $allres, $offset, $pageSize, $username, $dbconn;

   if (!$isReportAdmin ) { $query_onlyuser=" AND username='$username' "; }

   $query="SELECT id FROM portscan WHERE id=$pid $query_onlyuser";
   $result=$dbconn->execute($query);
   list ( $scan_id )=$result->fields;

   if ( $scan_id ) {
      $query="SELECT host, port, type, status, description, version FROM portscan_results WHERE id=$scan_id";
      $result=$dbconn->execute($query);

      if ( $result->EOF ) {
        echo "<br><font color='red'>No Scan Results</font><br><br>";
        echo "<a href='portscanres.php'>Return to List</a><br>";
        require_once('footer.php');
        exit;
      }

      while(!$result->EOF) {
         list($phost, $pport, $ptype, $pstatus, $pdescription, $pversion)=$result->fields;
         if ($previp<>$phost) {
            if ($firstresloop>1) { echo "</table>"; }
            $firstresloop=1;
            echo "<br><font color=\"#FF0000\"><b>$phost</b></font>";

            $hostos="";
            $query1="select os from portscan_os where id=$pid and host='$phost'";
            $result1=$dbconn->execute($query1);
            while(!$result1->EOF) {
               list($hostos)=$result1->fields;
               $result1->MoveNext();
            }

            if ($hostos=="") { $hostos="Unknown OS"; }
            echo " - $hostos<br>";
            $previp=$phost;
         }
         if ($firstresloop==1) {
            echo <<<EOT
<table summary="Nmap Results" border="1" cellpadding="1" cellspacing="1" style="border-collapse:collapse">
<tr>
   <td><b>Port&nbsp;&nbsp;</b></td>
   <td><b>Protocol&nbsp;&nbsp;</b></td>
   <td><b>Status&nbsp;&nbsp;</b></td>
   <td><b>Service&nbsp;&nbsp;</b></td>
   <td><b>Version / Banner info&nbsp;&nbsp;</b></td>
</tr>
EOT;
         }
         echo <<<EOT
<tr>
    <td>$pport&nbsp;&nbsp;</td>
    <td>$ptype&nbsp;&nbsp;</td>
    <td>$pstatus&nbsp;&nbsp;</td>
    <td>$pdescription&nbsp;&nbsp;</td>
    <td>$pversion&nbsp;&nbsp;</td>
</tr>
EOT;
         $firstresloop++;
         $result->MoveNext();
      }
      echo "</table>";
      echo "<a href='portscanres.php'>Return to List</a><br>";
   } else { 
      echo "Cannot access this page - Portscan details not in the database.";
   }
}

switch($disp) {

   case "delete":
      delete_results( $scantime, $scantype, $reporttype, $key, $sortby, $allres, $fp, $nfp, $op, $output, $wh, $bg );
      break;

   case "view":
      view_scan( $pid );
      break;

   default:
      list_results( $type, $value, $scanstate, $sortby, $sortdir );
      break;

}


require_once('footer.php');
?>
