<?php

//
// $Id: systems.php,v 1.10 2008/03/06 04:57:01 kkline Exp $
//
/***********************************************************/
/*                    Inprotect                            */
/* --------------------------------------------------------*/
/* Copyright (C) 2006 Inprotect                            */
/*                                                         */
/* This program is free software; you can redistribute it  */
/* and/or modify it under the terms of version 2 of the    */
/* GNU General Public License as published by the Free     */
/* Software Foundation.                                    */
/* This program is distributed in the hope that it will be */
/* useful, but WITHOUT ANY WARRANTY; without even the      */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE. See the GNU General Public License  */
/* for more details.                                       */
/*                                                         */
/* You should have received a copy of the GNU General      */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 59 Temple Place, */
/* Suite 330, Boston, MA 02111-1307 USA                    */
/*                                                         */
/* Contact Information:                                    */
/* inprotect-devel@lists.sourceforge.net                   */
/* http://inprotect.sourceforge.net/                       */
/***********************************************************/
/* See the README.txt and/or help files for more           */
/* information on how to use & config.                     */
/* See the LICENSE.txt file for more information on the    */
/* License this software is distributed under.             */
/*                                                         */
/* This program is intended for use in an authorized       */
/* manner only, and the author can not be held liable for  */
/* anything done with this program, code, or items         */
/* discovered with this program's use.                     */
/***********************************************************/

$pageTitle = "Manage Infrastructure";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');
//require_once('permissions.inc.php');


 $daysMap = array ( 
     "0" => "NONE", 
    "Su" => "Sunday",
    "Mo" => "Monday",
    "Tu" => "Tuesday",
    "We" => "Wednesday",
    "Th" => "Thursday",
    "Fr" => "Friday", 
    "Sa" => "Saturday"
          );

$getParams = array( "disp", "nid", "hid", "sid", "op", "sname", "likefilter" );
$postParams = array( "disp", "nid", "hid", "sub", "nname", "nacro", "sacro", "ndescription", "nprogram", "nowner", 
   "nowner_tele", "nowner_email", "nisso_poc", "nisso_phone", "nisso_email", "nisso_alt", "ndaa", "nadmin_sys", 
   "nadmin_net", "nhostip", "nos", "importhosts" );
      
switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach($getParams as $gp) {
      if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else { 
         $$gp=""; 
      }
   }
   break;
case "POST" :
   foreach($postParams as $pp) {
      if (isset($_POST[$pp])) { 
         $$pp=htmlspecialchars(mysql_real_escape_string(trim($_POST[$pp])), ENT_QUOTES); 
      } else { 
         $$pp=""; 
      }
   }
   break;
}

$addhosts = array();
$rmhosts = array();

if(isset($_POST['authorized_users'])) {
   foreach($_POST['authorized_users'] as $user) {
      $users[] = htmlspecialchars(mysql_real_escape_string(trim($user)), ENT_QUOTES); 
   }
}

if(isset($_POST['assigned_hosts'])) {
   foreach($_POST['assigned_hosts'] as $ahost) {
      $addhosts[] = htmlspecialchars(mysql_real_escape_string(trim($ahost)), ENT_QUOTES); 
   }
}

if(isset($_POST['unassign_hosts'])) {
   foreach($_POST['unassign_hosts'] as $dhost) {
      $rmhosts[] = htmlspecialchars(mysql_real_escape_string(trim($dhost)), ENT_QUOTES); 
   }
}


if ( !$uroles['infrastructure'] )  {
    echo "Insufficient rights to view this page.";
    require_once('footer.php');
    // should do this better, but it'll work for now.
    die();
}

function navbar ( $nid ) {
   global $uroles, $nacro,  $sacro, $dbconn;

   echo <<<EOT
<center><h3>Manage Accredited Systems</h3>
      [ <a href="systems.php">Main</a> ]
EOT;
   if ($nid) {

      $query = "SELECT name, acronym, parent 
                FROM I3_systems 
		WHERE id='$nid'";
      $result = $dbconn->execute($query);
      list($sysname, $nacro, $sacro ) = $result->fields;

      if ( $sacro != "SELF") {
         $query = "SELECT id, name 
	           FROM I3_systems 
		   WHERE acronym='$sacro' AND parent='SELF'";
         $result = $dbconn->execute($query);
         list( $pid, $pname ) = $result->fields;
         $compname= $sysname;
         $sysname = "<a href=\"systems.php?disp=systems&nid=$pid\">$pname</a>-\>$compname";
      }
      echo <<<EOT
 -> Edit System [ <font color=red>$sysname</font> ] ( 
<a href="systems.php?disp=hosts&nid=$nid">HOSTS</a>
| <a href="systems.php?disp=systems&nid=$nid">INFO</a>
| <a href="systems.php?disp=edit_sys&nid=$nid">NAME</a>
EOT;
   $query = "SELECT count(id) FROM I3_systems Where Active='1' AND parent='$nacro'";
   $result = $dbconn->execute($query);
   list($subcount) = $result->fields;

   if ( $subcount > "0" ) {
         echo <<<EOT
| <a href="systems.php?disp=man_subs&nid=$nid">Manage Subs</a>
EOT;
   }

      if ( $uroles['infrastructure'] ) {
         echo <<<EOT
| <a href="systems.php?disp=editusers&nid=$nid">USERS</a>
| <a href="systems.php?disp=import_hosts&nid=$nid">Import Hosts</a>
EOT;
      }
      echo " )";
   }
   echo "</center><br>";
}

function add_hosts ( $nid, $importhosts ) {
   global $username, $dbconn;

   if ( $nid && $importhosts ) {

      $query = "SELECT id, name, acronym from I3_systems WHERE id='$nid'";
      $result = $dbconn->execute($query);
      list( $sysid, $sysname, $sysacro ) = $result->fields;
      #echo "ADDING/UPDATING HOSTS TO SYSTEM: [$sysname]<br>";

      if ( strlen($importhosts) > 0 ) {
         $vals=split("[\\n\\r\\t;, ]+", $importhosts );
         $inputhostcount=1;
         foreach($vals as $v) {
            $v=trim($v);
            $ip = gethostbyname($v);
            echo "v=[$ip]<br>";

            if ( strlen($ip)>0 ) {

               $query = "SELECT id FROM I3_system_hosts WHERE sysID='$sysid AND hostip='$ip'";
               $result = $dbconn->execute($query);
               list( $hid ) = $result->fields; 

               $query = "SELECT id FROM hosts WHERE hostip='$ip'";
               $result = $dbconn->execute($query);
               list( $hostid ) = $result->fields;

               if ( $hostid ) { $txt_hostid = "'$hostid'"; } else { $txt_hostid = "NULL"; }

               if ( $hid == "" ) {
                     $query2 = "INSERT INTO I3_system_hosts ( sysID, host_id, hostip) VALUES 
                        ('$sysid', $txt_hostid, '$ip' );";
                  $result2 = $dbconn->execute($query2);
               }
            }
         }
      }
   $dbconn->execute("INSERT INTO log ( ip, username, action)
      VALUES ( '$ip', '$username', 'SYSTEMS.PHP update associated hosts for system $sysname' )");
   
   }
   
   echo "<br>";

}

function delete_host( $nid, $hid ){
   global $uroles, $dbconn;

   if ( $uroles['infrastructure'] || $uroles['admin'] ) {
      if ( $hid ) {
         $query = "DELETE FROM I3_system_hosts WHERE id='$hid'";
         $result = $dbconn->execute($query);
         logAccess( "Deleted HOST $hid FROM system $nid");
      }
   }

   host_info ( $nid );

}

function delete_system ( $nid ) {
   global $uroles, $dbconn;

   if ( $uroles['infrastructure'] || $uroles['admin'] ) {
      if ( $nid ) {

         $query = "DELETE FROM I3_system_hosts WHERE sysID='$nid'";
         $result = $dbconn->execute($query);

         $query = "DELETE FROM I3_systems WHERE id='$nid'";
         $result = $dbconn->execute($query);
         logAccess( "Deleted System $nid");
      }
   }

   show_systems( "" );

}

function edit_host( $nid, $hid ){
   global $dbconn;

   navbar ( $nid );

   if ( $hid ) {

      $query = "SELECT id, hostip, hostname, description, status, os, contact, scanstate FROM hosts WHERE id='$hid'";

      $result = $dbconn->execute($query);

      list($hid, $hostip, $sname, $sdescription, $status, $os, $npoc, $scanstate ) = $result->fields;

      echo "<b>Edit Host - \"$sname\"</b><br>";
   } else {
      echo "<b>Add new Host</b><br>";
   }
   echo <<<EOT
<form method="POST" action="systems.php">
   <input type="hidden" name="disp" value="save_host">
   <input type="hidden" name="hid" value="$hid">
   <input type="hidden" name="nname" value="$sname">
EOT;

   if ( $nid ) {
      echo "<input type=\"hidden\" name=\"nid\" value=\"$nid\">";
   }

   echo <<<EOT
<table width='100%'>
   <tr><td width="35%" align="right">HostName:</td>
   <td>$sname</td>
   </tr>
   <tr><td align="right">SYSTEM:</td>
   <td>$acrSystem</td>
   </tr>
   <tr><td align="right">IP ADDRESS:</td>
   <td><input type="text" name="nhostip" value="$hostip" size="50" maxlength="100"></td>
   </tr>
   <tr><td align="right">OPERATING SYSTEM:</td>
   <td><input type="text" name="nos" value="$os" size="50" maxlength="100"></td>
   </tr>
   <tr><td align="right">POC:</td>
   <td><input type="text" name="nisso_email" value="$npoc" size="50" maxlength="100"></td>
   </tr>
   <tr><td align="right">Description:</td>
   <td>
   <textarea wrap="virtual" cols="70" rows="15" name="ndescription">$sdescription</textarea>
   </td>
   </tr>
   <tr><td align="right">&nbsp;</td>
   <td><input type="submit" name="submit" value="Save"></td>
   </tr>
   </table>
   </form>
EOT;


}

function edit_system($nid, $sub ){
   global $dbconn;

   navbar( $nid );

   $nname ="";
   $nacro ="";
   $parent ="";
   $ndescription ="";
   $nprogram ="";
   $nowner ="";
   $nowner_tele ="";
   $nowner_email ="";
   $nisso_poc ="";
   $nisso_phone ="";
   $nisso_email ="";
   $nisso_alt ="";
   $ndaa ="";
   $nadmin_sys ="";
   $nadmin_net ="";

   if ( $nid ) {
 
      $query = "SELECT  name, acronym, parent, description, program, owner, owner_phone, owner_email, isso_poc, 
         isso_phone, isso_email, isso_alt, da_authority, admin_sys, admin_network FROM I3_systems
         WHERE id='$nid'";

      $result = $dbconn->execute($query);

      list($nname, $nacro, $parent, $ndescription, $nprogram, $nowner, $nowner_tele, $nowner_email, $nisso_poc, 
         $nisso_phone, $nisso_email, $nisso_alt, $ndaa, $nadmin_sys, $nadmin_net ) = $result->fields;

      if ( $sub == "_NEW" ) {
      	 echo "<b>Add new SubComponent to System \"$nname\"</b><br>";
      	 $nname = ""; #Blank value for a sub componenet
      } else {
         echo "<b>Edit System - \"$nname\"</b><br>";
      }
   } else {
      echo "<b>Add new System</b><br>";
   }

   echo <<<EOT
<form method="POST" action="systems.php">
  <input type="hidden" name="disp" value="save_system">
EOT;
   if ( $nid && $sub == "_NEW" ) {
      echo <<<EOT
<input type="hidden" name="sub" value="$sub">
<input type="hidden" name="nacro" value="$nacro">
EOT;
   	
   } elseif ( $nid ) {
      echo <<<EOT
<input type="hidden" name="nid" value="$nid">
<input type="hidden" name="sacro" value="$parent">
EOT;
   }
   echo <<<EOT
<table border=0 width="100%">
      <tr><td>Name: (<b> Required</b>)</td>
      <td><input type="text" name="nname" value="$nname" size="40"></td>
      </tr>
EOT;
   if ( $nid && $sub == "_NEW" ) {
   echo <<<EOT
      <tr><td>Acronym: (<b> Parent Acronym</b>)</td>
      <td>$nacro</td>
      </tr>
      <tr><td>Sub Acronym: (<b> Required</b>)</td>
      <td><input type="text" name="sacro" value="" size="40"></td>
      </tr>
EOT;
	
   } else {
   echo <<<EOT
      <tr><td>Acronym: (<b> Required</b>)</td>
      <td><input type="text" name="nacro" value="$nacro" size="40"></td>
      </tr>
EOT;
   	
   }
   
   echo <<<EOT
      </tr>
      <tr><td>Program:</td>
      <td><input type="text" name="nprogram" value="$nprogram" size="25"></td>
      </tr>
      <tr><td>Owner:</td>
      <td><input type="text" name="nowner" value="$nowner" size="40"></td>
      </tr>
      <tr><td>Owner Phone:</td>
      <td><input type="text" name="nowner_tele" value="$nowner_tele" size="15"></td>
      </tr>
      <tr><td>Owner Email:</td>
      <td><input type="text" name="nowner_email" value="$nowner_email" size="40"></td>
      </tr>
      <tr><td>ISSO Name:</td>
      <td><input type="text" name="nisso_poc" value="$nisso_poc" size="40"></td>
      </tr>
      <tr><td>ISSO Phone:</td>
      <td><input type="text" name="nisso_phone" value="$nisso_phone" size="15"></td>
      </tr>
      <tr><td>ISSO Email:</td>
      <td><input type="text" name="nisso_email" value="$nisso_email" size="40"></td>
      </tr>
      <tr><td>ALT POC:</td>
      <td><input type="text" name="nisso_alt" value="$nisso_alt" size="40"></td>
      </tr>
      <tr><td>Designated Accrediating Authority:</td>
      <td><input type="text" name="ndaa" value="$ndaa" size="40"></td>
      </tr>
      <tr><td>System Admins:</td>
      <td><input type="text" name="nadmin_sys" value="$nadmin_sys" size="40"></td>
      </tr>
      <tr><td>Network Admins:</td>
      <td><input type="text" name="nadmin_net" value="$nadmin_net" size="40"></td>
      </tr>
      <tr><td>Description:</td>
      <td>
      <textarea wrap="virtual" cols="70" rows="15" name="ndescription">$ndescription</textarea>
      </td>
      </table>
      <input type="submit" name="submit" value="Save">
      </form>
EOT;

}

function host_info ( $nid ) {
   global $username, $nacro, $sacro, $dbconn;

   navbar( $nid );

   $query = "SELECT t1.id, t1.hostip, t2.hostname, t2.os,
       t2.contact, t2.id, t2.lastscandate
       FROM I3_system_hosts t1
       LEFT JOIN hosts t2 on t1.hostip=t2.hostip AND t2.inactive='0'
       WHERE t1.sysID=$nid";

  $result = $dbconn->execute($query);

   echo <<<EOT
<h4>$all DEFINED "$nacro" HOSTS</h4>
   <table border=1 width="100%"><tr><td>FQDN</td>
   <td>IP Address</td>
   <td>Operating System</td>
   <td>Contact</td>
   <td>Last Scanned</td>
   <td>&nbsp;</td>
</tr>
EOT;

   while(list( $hid, $hostip, $hostname, $os, $contact, $host_id, $lastscanned ) = $result->fields ) {

      $curtime = gen_strtotime("now", "");

      if ( $lastscanned != "" && $lastscanned != "0000-00-00 00:00:00") {
         $days_since_scanned = datediff ( "d", $curtime, $lastscanned ) . " days";
      } else {
         $days_since_scanned = "Never";
      }

      echo <<<EOT
<tr>
   <td>$hostname</td>
   <td>$hostip</td>
   <td>$os</td>
   <td>$contact</td>
   <td>$days_since_scanned</td>
   <td width="50"><a href="systems.php?disp=edit_host&amp;nid=$nid&amp;hid=$host_id"><img src="images/pencil.png"></a>&nbsp;
   <a href="systems.php?disp=delete_host&amp;nid=$nid&amp;hid=$hid" onclick="return confirmDelete();"><img src="images/delete.png"></a>&nbsp;
   </td></tr>
EOT;

      $result->MoveNext();
   }

   echo "</table><br>";

}

function import_hosts ( $nid, $importhosts ) {
   global $username, $dbconn;

   navbar( $nid );

   $query = "SELECT id, name, acronym FROM I3_systems WHERE id='$nid' limit 1"; 
   $result = $dbconn->execute($query);
   list( $sysid, $sysname, $sysacro )= $result->fields;

   add_hosts ($nid, $importhosts);

   echo <<<EOT
<table summary="Target Hosts">
   <tr><td>Input Target List to Import into System</td></tr>
   <tr><td valign="top">
   <form method="post" action="systems.php">
    <input type="hidden" name="disp" value="import_hosts">
   <input type="hidden" name="nid" value="$nid">
   Hostname/IP Address<BR>
   <textarea name="importhosts" style="WIDTH: 400px; HEIGHT: 300px"></textarea></td></tr>
   <tr><td align="right"><input type="submit" value="Import">
   </td></tr>
   </table>
</form>
EOT;

}

function manage_sys_users($nid) {
   global $dbconn;

   navbar ( $nid );

   $query = "SELECT name FROM I3_systems WHERE id='$nid'";
   $result = $dbconn->execute($query);
   list($sname) = $result->fields;

     echo <<<EOT
<br>
<form action="/systems.php" method="POST" onSubmit="selectAllOptions('authorized');">
<TABLE width=100% border=0>

<TR>
     <TD colSpan=3>
     <h4>SYSTEM "$sname" User Membership:</h4>
     </TD>
</TR>
<TR>
<TD valign=top align=left width=150>Authorized Users<br>
         <input type="hidden" name="disp" value="setusers">
         <input type="hidden" name="nid" value="$nid">
    <select name="authorized_users[]" id="authorized" style="WIDTH: 187px; HEIGHT: 200px" multiple="multiple" size=20>
EOT;
      $query = "SELECT t1.pn_uname
         FROM users t1
         LEFT JOIN I3_system_users t2 on t1.pn_uname = t2.pn_uname
         WHERE t2.sysID = '$nid'";
      $result = $dbconn->execute($query);

      while(list( $nuname ) = $result->fields) {
         echo "<OPTION value=\"$nuname\">$nuname</OPTION>\n";
         $result->MoveNext();
      }

     echo <<<EOT

</SELECT></td>
<td><input type='button' value='<< Add' onclick="move2(this.form.unauthorized,this.form.authorized )"><br/>
<input type='button' value='Remove >>' onclick="move2(this.form.authorized,this.form.unauthorized)"></td>
     <td valign=top align="left">
          <select name="unauth_users[]" id="unauthorized" style="WIDTH: 187px; HEIGHT: 200px" multiple="multiple" size=20>\n";
EOT;

      $query = "SELECT t1.pn_uname FROM users t1
         LEFT JOIN I3_system_users t2 ON t1.pn_uname = t2.pn_uname AND t2.sysID = '$nid'
         WHERE t2.pn_uname is Null ORDER BY t1.pn_uname";
      $result = $dbconn->execute($query);

      while(list( $nuname ) = $result->fields) {
         echo "<OPTION value=\"$nuname\" >$nuname</OPTION>\n";
         $result->MoveNext();
      }

     echo <<<EOT
</select>
</td></tr>
<tr><td colspan="3"><input type='submit' name='submit' value='Update Access'></input></td></tr>
</TABLE></form>
EOT;

}

function save_host($nid, $hid, $nname, $nhostip, $nos, $ndescription, $nisso_email ){
   global $uroles, $username, $dbconn;

   $dtinsert = gen_strtotime("now", "");

   $flag=1;

   if($nname==""){
      $flag=0;
      $problemtext="System name cannot be blank!";

      echo "<center><b>"._ERROR."</b></center><br><br>"
         ."There was a problem saving configuration:<br />$problemtext<br><br>";
      exit;
   } 
 
   if( $nid ){
   	  logAccess( 'SYSTEMS.PHP updated associated hosts' );
   	
   	  $query="UPDATE hosts SET status='', hostIP='$nhostip', os='$nos', description='$ndescription', 
             contact='$nisso_email' WHERE id='$hid' LIMIT 1 ;";
   } else {   
      logAccess( 'SYSTEMS.PHP created $nname in hosts table' );  	
      $query="INSERT INTO hosts
         ( hostname, hostIP, description, os, contact, createdate  ) VALUES 
         ( '$nname', '$nhostip', $ndescription', '$nos', '$nisso_email', '$dtinsert' )";
   }

   $result = $dbconn->execute($query);

   if ( $uroles['debug'] ) { echo "sql=$query<br>"; }

   if ( !$nid ){
   	  echo "Sucessfully added New Host [ $nname ]<br />";
   } else {
   	  echo "Sucessfully Update Host [ $nname ]<br />";
   }
   
   host_info($nid);  

}

function save_system($nid, $sub, $nname, $nacro, $sacro, $ndescription, $nprogram, $nowner, $nowner_tele, $nowner_email, $nisso_poc,    $nisso_phone, $nisso_email, $nisso_alt, $ndaa, $nadmin_sys, $nadmin_net){
   global $uroles, $username, $dbconn;


   $dtinsert = gen_strtotime("now", "");

   navbar( $nid );

   $flag=1;

   if($nname==""){
      $flag=0;
      $problemtext="System name cannot be blank!";

      echo "<center><b>"._ERROR."</b></center><br><br>"
         ."There was a problem saving configuration:<br />$problemtext<br><br>";
      exit;
   } 

   if ( $sub == "_NEW" ){
      $parent = $nacro;
      $nacro = $sacro;	
   } elseif ( $nacro && $sacro ) {
   	  $parent = $sacro;
   } else {
   	  $parent = "SELF";
   }

   if( $nid &&  $sub != "_NEW" ){
   	  $dbconn->execute("INSERT INTO log ( ip, username, action)
           VALUES ( '$ip', '$username', 'SYSTEMS.PHP updated system $nacro' )");

      $query="UPDATE I3_systems SET name='$nname', acronym='$nacro', parent='$parent',description='$ndescription',
         program='$nprogram', owner='$nowner', owner_phone='$nowner_tele', owner_email='$nowner_email',
         isso_poc='$nisso_poc', isso_phone='$nisso_phone', isso_email='$nisso_email', isso_alt='$nisso_alt',
         da_authority='$ndaa', admin_sys='$nadmin_sys',
         admin_network='$nadmin_net', dtLastUpdated='$dtinsert', updatedBy='$username' WHERE id='$nid'";
   } else {

      logAccess( 'SYSTEMS.PHP created system $nacro' );

      $query="INSERT INTO I3_systems
         ( name, acronym, parent, description, program, owner, owner_phone, owner_email, isso_poc, isso_phone, 
            isso_email, isso_alt, da_authority, admin_sys, admin_network, dtLastUpdated, updatedBy  ) VALUES 
         ( '$nname', '$nacro', '$parent', '$ndescription', '$nprogram', '$nowner', '$nowner_tele', '$nowner_email', 
            '$nisso_poc', '$nisso_phone', '$nisso_email', '$nisso_alt', '$ndaa', '$nadmin_sys', 
            '$nadmin_net', '$dtinsert', '$username')";
   }

   $result = $dbconn->execute($query);

   if ( $uroles['debug'] ) { echo "sql=$query<br>"; }

   if ( !$nid ){
   	  echo "Sucessfully added New System<br />";
   } elseif ( $nid && $sub == "_NEW" ){
      echo "Sucessfully added Subsystem $nacro to System $parent<br /><br />";
   } else {
   	  echo "Sucessfully Edited System<br />";
   }

   echo "Please click <a href=\"systems.php\">here</a> to go to the main systems menu.";


}

function show_systems( $nid ) {
   global $uroles, $username, $nacro, $sacro, $dbconn;

   navbar( $nid );

   #QUERY PARENT / SUB FIELD
   if ( $nacro == "" ) {
   	   $sql_select_field = "acrSystem";   
   } else {
       $sql_select_field = "subSystem";

   }

   if ( $nid ) { 
   	  $system_type = "SUB-SYSTEMS";
      $query = "SELECT t1.id, t1.name, t1.acronym, t1.isso_email, t3.scan_END, t1.dtLastUpdated
         FROM I3_systems t1
            LEFT JOIN ( Select MAX(scan_SUBMIT) as scan_SUBMIT, fk_name
               FROM I3_jobs GROUP BY fk_name ) t2 on t1.acronym = t2.fk_name
            LEFT JOIN I3_jobs t3 on t2.fk_name = t3.fk_name AND t2.scan_SUBMIT=t3.scan_SUBMIT
         Where t1.Active='1' AND t1.parent='$nacro'";

   } else {  
   	  $system_type = "SYSTEMS"; 
      $query = "SELECT t1.id, t1.name, t1.acronym, t1.isso_email, t3.scan_END, t1.dtLastUpdated
         FROM I3_systems t1
            LEFT JOIN ( Select MAX(scan_SUBMIT) as scan_SUBMIT, fk_name
               FROM I3_jobs GROUP BY fk_name ) t2 on t1.acronym = t2.fk_name
            LEFT JOIN I3_jobs t3 on t2.fk_name = t3.fk_name AND t2.scan_SUBMIT=t3.scan_SUBMIT
         Where t1.Active='1' AND t1.parent='SELF'";
   }

   $result = $dbconn->execute($query);

   echo <<<EOT
<h4>DEFINED $system_type</h4>
   <table border=1 width="100%"><tr><td>Host Cnt</td>
   <td>Acro</td><td>Name</td>
   <td>Owner Email</td>
   <td>Days Since Last Scanned</td>
   <td>Days Since System Data Verfied</td>
   <td>&nbsp;</td>
</tr>
EOT;

   while(list($sysid, $sysname, $sysacro, $issoemail, $lastscanned, $lastupdated ) = $result->fields ) {
      $query2 = "select count(t3.hostip) from I3_systems t1
			LEFT JOIN I3_systems t2 on t1.acronym = t2.parent or t2.acronym=t1.acronym
			LEFT JOIN I3_system_hosts t3 on t2.id = t3.sysID
			WHERE t1.id='$sysid' AND t3.hostip IS NOT NULL";
      $result2 = $dbconn->execute($query2);
      list( $hostcount ) =  $result2->fields;
      $curtime = gen_strtotime("now", "");

      if ( $lastscanned != "" && $lastscanned != "0000-00-00 00:00:00") {
         $days_since_scanned = datediff ( "d", $curtime, $lastscanned );
      } else {
         $days_since_scanned = "Never";
      }

      if ( $lastupdated != "" && $lastupdated != "0000-00-00 00:00:00") {
         $days_since_updated = datediff ( "d", $curtime, $lastupdated );
      } else {
      	 $days_since_updated = "Never";
      }

      echo <<<EOT
<tr>
   <td align="center"><A href="systems.php?disp=hosts&nid=$sysid"><b>$hostcount</b></a></td>
   <td>$sysacro</td>
   <td>$sysname</td>
   <td>$issoemail</td>
   <td>$days_since_scanned</td>
   <td>$days_since_updated</td>
   <td width="120"><a href="systems.php?disp=systems&nid=$sysid"><img src="images/zoom.png"></a>&nbsp;
      <a href="systems.php?disp=edit_sys&nid=$sysid"><img src="images/pencil.png"></a>&nbsp;
EOT;

      if ( $uroles['admin'] ) {
         echo <<<EOT
   <a href="systems.php?disp=delete_sys&nid=$sysid"" onclick="return confirmDelete();"><img src="images/delete.png"></a>&nbsp;
EOT;
      }
      echo "</td></tr>";
      $result->MoveNext();
   }

   echo "</table><br>";

   if ( !$sacro ) {
      echo <<<EOT
<a href="systems.php?disp=add">Add New System</A>
EOT;
   }
}

function system_info ( $nid ) {
   global $sacro, $dbconn;

   navbar( $nid );

   $query = "SELECT  name, acronym, description, program, owner, owner_phone, owner_email, isso_poc, 
      isso_phone, isso_email, isso_alt, da_authority, admin_sys, admin_network FROM I3_systems
      WHERE id='$nid' LIMIT 1";

   $result = $dbconn->execute($query);
   $row = $result->fields;
   $nname = $row[0];

   if (!$row) {
      echo "[ $nid ] - NO MATCH FOUND";
   } else {

      echo <<<EOT
<font color="red">
   <h4>SYSTEM [ $nname ]</h4></font>
<table width="100%" summary="Search results" border=0 style="border-collapse: collapse" cellspacing="5" cellpadding="2">
   <tr><td width="25%" align="right"><h5><b>ATTRIBUTES</b></h5></td>
   <td ><h5><b>VALUE</b></h5></td></tr>
EOT;

      foreach ($row as $k => $v) {
         if ( !is_numeric($k) ) {
               echo "<tr><td align=\"right\">$k</td><td>$v</td></tr>";
         }
      }
      echo <<<EOT
</table>
EOT;

      if ( $sacro == "SELF" ) {
         echo <<<EOT
<a href="systems.php?disp=add_sub&nid=$nid">Add New Sub-Component</a><br><br>
EOT;
      }
   }
}

function update_sys_hosts( $nid, $nacro, $sacro, $addhosts ) {
   global $sitename, $dbconn;   

   if ( $nid && $addhosts ) {

      $query = "SELECT name, acronym, parent from I3_systems WHERE id='$nid'";
      $result = $dbconn->execute($query);
      list( $sysname, $sysacro, $parent ) = $result->fields;
      #echo "UPDATING ASSOCIATED HOSTS FOR SYSTEM: [$sysname]<br>";

      $query = "UPDATE hosts SET acrSystem = Null, SET subSystem = Null WHERE acrSystem='$sysacro' AND parent='$parent'";
      $result = $dbconn->execute($query);

      foreach( $addhosts as $ahost ) {
         if ($ahost) {
         	if ( $parent == "SELF" ) {
       			$query = "UPDATE hosts SET acrSystem = '$nacro', subSystem = NULL WHERE id ='$ahost';";
         	} else {
         		$query = "UPDATE hosts SET acrSystem = '$sacro', subSystem = '$nacro' WHERE id ='$ahost';";
         	}
       		$result = $dbconn->execute($query);
         }
      }      
      logAccess( 'SYSTEM [ $sysname ] ASSOCIATED HOSTS MODIFIED' );
   }

   echo "<br>";

   manage_hosts( $nid, '');
}

function update_sys_users( $nid,  $users ) {
   global $sysname, $username, $dbconn;

   if ( $nid ) {
      $query = "DELETE FROM I3_system_users WHERE sysID='$nid'";
      $result = $dbconn->execute($query);
   }

   if ( $nid &&  $users ) {

      $query = "SELECT name FROM I3_systems WHERE id='$nid'";
      $result = $dbconn->execute($query);
      list($name) = $result->fields;
      echo "UPDATING USERS FOR SYSTEM: [$name]<br>";

      foreach( $users as $nuser ) {
         if ($nuser) {
            $query = "INSERT INTO I3_system_users (pn_uname, sysID) 
               VALUES ('$nuser', '$nid' );";
            $result = $dbconn->execute($query);
         }
      }
      logAccess( "system [ $name ] ACCESS MODIFIED" );
   }

   echo "<br>";

   manage_sys_users($nid);
}



switch($disp) {

   case "add_sub":
      edit_system($nid,'_NEW');
      break;	
	
   case "add":
      edit_system('','');
      break;

   case "delete_host":
      delete_host($nid, $hid);
      break;

   case "delete_sys":
      delete_system( $nid );
      break;

   case "edit_host":
      edit_host($nid, $hid);
      break;

   case "edit_sys":
      edit_system($nid, '');
      break;

   case "editusers":
      manage_sys_users($nid);
      break;

   case "hosts":
      host_info($nid);
      break;

   case "import_hosts":
      import_hosts ( $nid, $importhosts );
      break;

   case "man_subs":
      show_systems($nid);
      break; 

   case "save_host":
      save_host($nid, $hid, $nname, $nhostip, $nos, $ndescription, $nisso_email );
      break;

   case "save_system":
      save_system($nid, $sub, $nname, $nacro, $sacro, $ndescription, $nprogram, $nowner, $nowner_tele, $nowner_email, $nisso_poc, 
         $nisso_phone, $nisso_email, $nisso_alt, $ndaa, $nadmin_sys, $nadmin_net);
      break;

   case "setusers":
      update_sys_users( $nid,  $users );
      break;

   case "systems":
      system_info($nid);
      break;

   default:
      show_systems( "" );
      break;

}


require_once('footer.php');

?>
