<?php

//
// $Id: threats-db.php,v 1.0 2008/02/21 15:03:00 kkline Exp $
//

/***********************************************************/
/*                    Inprotect                            */
/* --------------------------------------------------------*/
/* Copyright (C) 2006 Inprotect                            */
/*                                                         */
/* This program is free software; you can redistribute it  */
/* and/or modify it under the terms of version 2 of the    */
/* GNU General Public License as published by the Free     */
/* Software Foundation.                                    */
/* This program is distributed in the hope that it will be */
/* useful, but WITHOUT ANY WARRANTY; without even the      */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE. See the GNU General Public License  */
/* for more details.                                       */
/*                                                         */
/* You should have received a copy of the GNU General      */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 59 Temple Place, */
/* Suite 330, Boston, MA 02111-1307 USA                    */
/*                                                         */
/* Contact Information:                                    */
/* inprotect-devel@lists.sourceforge.net                   */
/* http://inprotect.sourceforge.net/                       */
/***********************************************************/
/* See the README.txt and/or help files for more           */
/* information on how to use & config.                     */
/* See the LICENSE.txt file for more information on the    */
/* License this software is distributed under.             */
/*                                                         */
/* This program is intended for use in an authorized       */
/* manner only, and the author can not be held liable for  */
/* anything done with this program, code, or items         */
/* discovered with this program's use.                     */
/***********************************************************/

$pageTitle = "Nessus Threats Database";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');
//require_once('permissions.inc.php');


$getParams = array(  'disp', 'increment', 'page', 'kw', 'family', 'risk', 'start_date', 'end_date'
                   );


$postParams = array( 'disp', 'increment', 'page', 'kw', 'family', 'risk', 'start_date', 'end_date'
                   );


$schedOptions = array(      "N" => "Immediately",
                     "O" => "Run Once", 
                     "D" => "Daily", 
                     "W" => "Weekly", 
                     "M" => "Monthly" );          

switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach ($getParams as $gp) {
      if (isset($_GET[$gp])) { 
         if(is_array($_GET[$gp])) {
            foreach ($_GET[$gp] as $i=>$tmp) {
               ${$gp}[$i] = sanitize($tmp);
            }
         } else {
            $$gp = sanitize($_GET[$gp]);
         }
      } else { 
         $$gp=""; 
      }
   }
   break;
case "POST" :
   foreach ($postParams as $pp) {
      if (isset($_POST[$pp])) { 
         if(is_array($_POST[$pp])) {
            foreach($_POST[$pp] as $i=>$tmp) {
               ${$pp}[$i] = sanitize($tmp);
//echo $pp . "[" . $i . "] = " . $$pp[$i] . "<br>";
            }
         } else {
            $$pp = sanitize($_POST[$pp]);
//echo $pp . " = " . $$pp . "<br>";
         }
      } else { 
         $$pp=""; 
      }
//echo $pp . " = " . $$pp . "<Br>";
   }
   break;
}

if ($increment == 'Previous') {
     $page = $page -1;
} elseif ($increment == 'Next') {
     $page = $page + 1;
}

if (!$page) { $page=1; }


function home() {
     global $sitename, $module_name, $dbconn;

     echo <<<EOT

<h3>Vulnerabilities and Threats Database</h3>
           <form method="POST" action="threats-db.php">
          <input type="hidden" name="disp" value="search">
          <table align="center" cellpadding="5" cellspacing="0">
          <tr><td style="padding: 0 30px 0 30px">
     <div class="field">Keywords</div>
     <input type="text" name="kw" size="20" />
      </td>
      <td style="padding: 0 30px 0 30px" nowrap>
     <div class="field">Risk Factor</div>
     <select name="risk" size="1">
       <option value=""></option>
       <option value="1">Serious</option>
       <option value="2">High</option>
       <option value="3">Medium</option>
       <option value="6">Low</option>
       <option value="7">Info</option>
     </select>
      </td>
      <td style="padding: 0 30px 0 30px">
     <div class="field">Start Date</div>
     <input type="text" id="start_date" name="start" size="12" />
      </td>
      <td style="padding: 0 30px 0 30px">
     <div class="field">End Date</div>
     <input type="text" id="end_date" name="end" size="12" />
      </td>
    </tr>
  </table>
    <input type="submit" value="Search" class="button" />
</form>
<br>

  <div class="title">Browse</div>
<p>
  The database can be browsed by threat family or risk factor.  Click
  on one of the links in the summary table below to view the list of
  vulnerabilities in that group.
</p>

<table id="family-table" class="tabular" width="100%">
  <thead>
    <tr>
      <th sort:format="str" style="text-align: left">Threat Family</th>
      <th sort:format="int" class="risk1">Serious-1</th>
      <th sort:format="int" class="risk2">High-2</th>
      <th sort:format="int" class="risk3">Medium-3</th>
      <th sort:format="int" class="risk6">Low-6</th>
      <th sort:format="int" class="risk7">Info-7</th>
      <th sort:format="int">Total</th>
    </tr>
  </thead>

EOT;

     $query = "SELECT t2.id, t2.name, count( t1.risk = '1'OR NULL ) AS Urgent, 
          count( t1.risk = '2' OR NULL ) AS Critical, count( t1.risk = '3' OR NULL ) AS High, 
          count( t1.risk = '6' OR NULL ) AS MEDIUM , count( t1.risk = '7'OR NULL ) AS Low, 
          count( t1.risk ) AS Total 
          FROM nessus_plugins t1
          LEFT JOIN nessus_family t2 ON t1.family = t2.id
          GROUP BY t1.family";
     $result = $dbconn->execute($query);

     $http_base = "threats-db.php?disp=search";

     while (!$result->EOF) {
          list( $fam_id, $fam_name, $fam_urg, $fam_ser, $fam_high, $fam_med, $fam_low, $fam_total )
          =  $result->fields;

          echo "<tr class=\"even\"><td style=\"text-align: left\">$fam_name</td>
                      <td align=\"center\"><a href=\"$http_base&family=$fam_id&risk=1\" >$fam_urg</a></td>
                    <td align=\"center\"><a href=\"$http_base&family=$fam_id&risk=2\" >$fam_ser</a></td>
                      <td align=\"center\"><a href=\"$http_base&family=$fam_id&risk=3\" >$fam_high</a></td>
                      <td align=\"center\"><a href=\"$http_base&family=$fam_id&risk=6\" >$fam_med</a></td>
                      <td align=\"center\"><a href=\"$http_base&family=$fam_id&risk=7\" >$fam_low</a></td>
                      <td align=\"center\"><a href=\"$http_base&family=$fam_id\" >$fam_total</a></td>
          </tr>";

          $result->MoveNext();

     }

     $query = "SELECT count( risk = '1' OR NULL ) AS Urgent, 
          count( risk = '2' OR NULL ) AS Critical, count( risk = '3' OR NULL ) AS High, 
          count( risk = '6' OR NULL ) AS MEDIUM , count( risk = '7'OR NULL ) AS Low, 
          count( risk ) AS Total 
          FROM nessus_plugins t1";
     $result = $dbconn->execute($query);

     list( $fam_urg, $fam_ser, $fam_high, $fam_med, $fam_low, $fam_total ) 
         =  $result->fields;

     echo "<tr><td colspan=7><hr></td></tr>
          <tr class=\"even\"><td style=\"text-align: left\">&nbsp;</td>
            <td align=\"center\"><a href=\"$http_base&risk=1\" >$fam_urg</a></td>
          <td align=\"center\"><a href=\"$http_base&risk=2\" >$fam_ser</a></td>
            <td align=\"center\"><a href=\"$http_base&risk=3\" >$fam_high</a></td>
            <td align=\"center\"><a href=\"$http_base&risk=6\" >$fam_med</a></td>
            <td align=\"center\"><a href=\"$http_base&risk=7\" >$fam_low</a></td>
            <td align=\"center\"><a href=\"$http_base&family=All&risk=All\" >$fam_total</a></td>
          </tr></table>";

}

function search($page, $kw, $family, $risk, $start_date, $end_date) {
     global $sitename, $module_name, $dbconn;

     $Limit=20;

     if ( $kw == "" ) { $txt_kw = "All"; } else { $txt_kw = $kw; }
     if ( $family == "" ) { $txt_family = "All"; } else { $txt_family = $family; }
     if ( $risk == "" ) { $txt_risk = "All"; } else { $txt_risk = $risk; }
     if ( $start_date == "" ) { $txt_start_date = "All"; } else { $txt_start_date = gen_strtotime($start_date); }
     if ( $end_date == "" ) { $txt_end_date = "All"; } else { $txt_end_date = gen_strtotime($end_date); }

     echo <<<EOT

<div class="title">Search Criteria</div>
     <table cellpadding="0" cellspacing="0" align="center" width="100%">
          <tr><td><div class="field">Keywords</div><span atest="criteria:kw">$txt_kw</span></td>
          <td><div class="field">Family</div><span atest="criteria:family">$txt_family</span></td>
          <td><div class="field">Risk Factor</div><span atest="criteria:risk">$txt_risk</span></td>
          <td><div class="field">Start Date</div><span atest="criteria:start">$txt_start_date</span></td>
          <td><div class="field">End Date</div><span atest="criteria:end">$txt_end_date</span></td>
          </tr>
     </table>
</div>

EOT;

     $query_filter = "";

     if ( $kw != "" ) { $query_filter .= "AND ( t1.summary LIKE '%$kw%' OR t1.cve_id LIKE '%$kw%' )"; }
     if ( $family != "" ) {  $query_filter .= "AND t2.family = '$family'"; }
     if ( $risk != "" ) {  $query_filter .= "AND t2.risk = '$risk'"; }
     if ( $start_date != "" ) {  $query_filter .= "AND t2.created > '$start_date'"; }
     if ( $end_date != "" ) {  $query_filter .= "AND t2.created < '$end_date'"; }

     $query_filter = ltrim($query_filter, "AND ");

     if ( $query_filter == "" ) { $query_filter = "1"; }

     $query_filter = "WHERE $query_filter";

     $query = "SELECT count( t1.id ) FROM plugins t1 LEFT JOIN nessus_plugins t2 on t1.id = t2.id $query_filter";
     $result = $dbconn->execute($query);

     list ( $numrec ) =  $result->fields;

     if ($numrec > 0) {
          $numpages=intval($numrec/$Limit);
     } else {
          $numpages = 1;
     }

     if ($numrec%$Limit) { $numpages++; } // add one page if remainder 
        if ($page > 0) { $previous = $page -1; } else { $previous = -1; }
        if ($numpages > $page) { $next = $page +1; } else { $next = -1;     }

        $offset = (($page-1) * $Limit);  

     $query = "SELECT t1.id, t2.risk, t2.created, t1.family, t1.summary 
          FROM plugins t1 LEFT JOIN nessus_plugins t2 on t1.id = t2.id
          $query_filter LIMIT $offset,$Limit";

     $result = $dbconn->execute($query);

     echo <<<EOT
<form action="threats-db.php" method="post">
    <INPUT TYPE=HIDDEN NAME="disp" VALUE="search">
    <INPUT TYPE=HIDDEN NAME="page" VALUE="$page">
    <INPUT TYPE=HIDDEN NAME="kw" VALUE="$kw">
    <INPUT TYPE=HIDDEN NAME="family" VALUE="$family">
    <INPUT TYPE=HIDDEN NAME="risk" VALUE="$risk">
    <INPUT TYPE=HIDDEN NAME="start_date" VALUE="$start_date">
    <INPUT TYPE=HIDDEN NAME="end_date" VALUE="$end_date">

    <table id="results-table" class="tabular" cellpadding="2" cellspacing="0" width="100%">
            <thead><tr><th sort:format="int" align="center">ID</th>
            <th sort:format="int" align="center">Risk</th>
            <th sort:format="int" align="center">Defined On</th>
            <th sort:format="str" align="left">Threat Family &amp; Summary</th></tr></thead>

EOT;

     while (!$result->EOF) {
          list( $pid, $prisk, $pcreated, $pfamily, $psummary )
          =  $result->fields;

          $dt_pcreated = gen_strtotime( $pcreated, "" );
          echo "<tr>
               <td sort:by=\"18606\" align=\"center\" valign=\"top\">
                   <a href=\"lookup.php?id=$pid\" atest=\"ids\">$pid</a>
              </td>
                 <td sort:by=\"4\" align=\"center\" valign=\"top\">
                   <img src=\"/images/risk".$prisk.".gif\" style=\"width: 25px; height: 10px; border: 1px solid\" />
                 </td>
                 <td sort:by=\"1120546800\" align=\"center\" valign=\"top\">
                   $dt_pcreated
                 </td>
                 <td sort:by=\"Gentoo Local Checks\">
              <div class=\"field\">
                     $pfamily
              </div>
              $psummary
                 </td>
               </tr>";
          $result->MoveNext();
     }

     echo "<tr><td class=\"catBottom\" align=\"center\" colSpan=\"12\" height=\"28\">";    
     if ($previous > 0) {
          echo "<input type=\"submit\" name=\"increment\" value=\"Previous\" class=\"liteoption\">\n";
     }
     if ($next > 0) { 
          echo "<input type=\"submit\" name=\"increment\" value=\"Next\" class=\"mainoption\">\n";
     }
     echo "</td></tr></table>";     

}

switch($disp) {

     case "search":
          search($page, $kw, $family, $risk, $start_date, $end_date);
          break;
     
     
    default:
        home( );
        break;
}

     include_once('footer.php');

?>