ALTER TABLE `I3_job_schedule` 
ADD `meth_Wcheck` TEXT NULL AFTER `meth_VSET`,
ADD `meth_Wfile` TEXT NULL AFTER `meth_Wcheck`,
ADD `meth_Ucheck` TEXT NULL AFTER `meth_Wfile`,
ADD `scan_ASSIGNED` VARCHAR( 25 ) NULL AFTER `meth_TIMEOUT` ;

CREATE TABLE `I3_assets_hardware` (
  `id` int(11) NOT NULL auto_increment,
  `MACAddress` varchar(12) NOT NULL default '',
  `ComputerName` varchar(64) NOT NULL default '',
  `SystemVendor` varchar(25) NOT NULL default '',
  `ServiceTag` varchar(20) NOT NULL default '',
  `SystemModel` varchar(50) NOT NULL default '',
  `UUID` varchar(50) NOT NULL default '',
  `OSBootDevice` varchar(25) NOT NULL default '',
  `OSBuildNumber` varchar(8) NOT NULL default '',
  `OSCaption` varchar(100) NOT NULL default '',
  `OSCSDVersion` varchar(25) NOT NULL default '',
  `OSCurrentTimeZone` varchar(25) NOT NULL default '',
  `OSDistributed` varchar(8) NOT NULL default '',
  `OSFreeDiskSpace` varchar(16) NOT NULL default '',
  `OSEncryptionLevel` varchar(16) NOT NULL default '',
  `OSFreePhysicalMemory` varchar(16) NOT NULL default '',
  `OSFreeSpaceInPagingFiles` varchar(16) NOT NULL default '',
  `OSFreeVirtualMemory` varchar(16) NOT NULL default '',
  `OSInstallDate` varchar(25) NOT NULL default '',
  `OSLastBootUpTime` varchar(25) NOT NULL default '',
  `OSLocalDateTime` varchar(25) NOT NULL default '',
  `OSNumberOfUsers` int(8) NOT NULL default '0',
  `OSOrganization` varchar(25) NOT NULL default '',
  `OSOSType` int(2) NOT NULL default '0',
  `OSSerialNumber` varchar(25) NOT NULL default '',
  `OSServicePackMajorVersion` int(2) NOT NULL default '0',
  `OSServicePackMinorVersion` varchar(8) NOT NULL default '',
  `OSSizeStoredInPagingFiles` varchar(25) NOT NULL default '',
  `OSSystemDevice` varchar(25) NOT NULL default '',
  `OSSystemDirectory` varchar(25) NOT NULL default '',
  `OSSystemDrive` varchar(8) NOT NULL default '',
  `OSTotalVirtualMemorySize` varchar(8) NOT NULL default '',
  `OSTotalVisibleMemorySize` varchar(8) NOT NULL default '',
  `OSVersion` varchar(16) NOT NULL default '',
  `OSWindowsDirectory` varchar(25) NOT NULL default '',
  `BoardName` varchar(50) NOT NULL default '',
  `BoardManufacturer` varchar(50) NOT NULL default '',
  `BoardProduct` varchar(50) NOT NULL default '',
  `BoardSerialNumber` varchar(25) NOT NULL default '',
  `BiosSerialNumber` varchar(25) NOT NULL default '',
  `BiosReleaseDate` varchar(25) NOT NULL default '',
  `BiosVersion` varchar(25) NOT NULL default '',
  `Biossmbiosversion` varchar(8) NOT NULL default '',
  `Biossmmajorversion` varchar(4) NOT NULL default '',
  `Biossmminorversion` varchar(4) NOT NULL default '',
  `ProcArchitecture` varchar(8) NOT NULL default '',
  `ProcCurrentClockSpeed` varchar(16) NOT NULL default '',
  `ProcMaxClockSpeed` varchar(16) NOT NULL default '',
  `ProcCurrentVoltage` varchar(16) NOT NULL default '',
  `ProcL2CacheSize` varchar(16) NOT NULL default '',
  `ProcManufacturer` varchar(25) NOT NULL default '',
  `ProcRevision` varchar(16) NOT NULL default '',
  `ProcVersion` varchar(25) NOT NULL default '',
  `FloppyDeviceID` varchar(25) default NULL,
  `FloppyName` varchar(25) default NULL,
  `CDRomDrive` varchar(4) default NULL,
  `CDRomName` varchar(25) default NULL,
  `SystemAdminPasswordStatus` varchar(8) NOT NULL default '',
  `SystemDescription` varchar(25) NOT NULL default '',
  `SystemDomain` varchar(25) NOT NULL default '',
  `SystemDomainRole` int(4) NOT NULL default '0',
  `SystemManufacturer` varchar(25) NOT NULL default '',
  `SystemNumberofProcessors` int(4) NOT NULL default '0',
  `SystemPartofDomain` varchar(8) default 'False',
  `SystemSystemStartupDelay` int(4) NOT NULL default '0',
  `SystemSystemType` varchar(25) NOT NULL default '',
  `SystemTotalPhysicalMemory` varchar(8) NOT NULL default '',
  `SystemUserName` varchar(25) default NULL,
  `DiskConfig` varchar(8) default NULL,
  `DiskIndex` varchar(8) default NULL,
  `DiskInterfaceType` varchar(8) default NULL,
  `DiskMediaLoaded` varchar(25) default NULL,
  `DiskMediaType` varchar(25) default NULL,
  `DiskModel` varchar(25) NOT NULL default '',
  `DiskName` varchar(25) NOT NULL default '',
  `DiskPartitions` int(8) NOT NULL default '1',
  `DiskSCSIBus` varchar(25) NOT NULL default '',
  `DiskSignature` varchar(25) NOT NULL default '',
  `DiskSize` varchar(25) NOT NULL default '',
  `MemoryCapacity` varchar(25) NOT NULL default '',
  `MemoryDeviceLocator` varchar(8) NOT NULL default '',
  `MemoryMemoryType` varchar(25) NOT NULL default '',
  `MemorySpeed` varchar(25) NOT NULL default '',
  `NetworkManufacturer` varchar(25) default NULL,
  `NetworkIPAddress` varchar(16) NOT NULL default '',
  `NetworkName` varchar(25) default NULL,
  `NetworkServiceName` varchar(16) default NULL,
  `NetworkDHCPEnabled` tinyint(2) default NULL,
  `NetworkDHCPServer` varchar(25) default NULL,
  `NetworkDNS1` varchar(16) default NULL,
  `NetworkDNS2` varchar(16) default NULL,
  `NetworkDNS3` varchar(16) default NULL,
  `dtLastUpdate` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `MACAddress` (`MACAddress`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE `I3_assets_process` (
  `MACAddress` varchar(12) NOT NULL default '',
  `ComputerName` varchar(64) NOT NULL default '',
  `Caption` varchar(255) NOT NULL default '',
  `ExecutablePath` varchar(255) NOT NULL default '',
  `Name` varchar(255) NOT NULL default '',
  KEY `Computer` (`MACAddress`,`ComputerName`),
  KEY `Process` (`Caption`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE `I3_assets_services` (
  `MACAddress` varchar(12) NOT NULL default '',
  `ComputerName` varchar(64) NOT NULL default '',
  `DisplayName` varchar(255) NOT NULL default '',
  `PathName` varchar(255) NOT NULL default '',
  `ServiceType` varchar(25) NOT NULL default '',
  `Started` varchar(8) NOT NULL default '',
  `StartMode` varchar(8) NOT NULL default '',
  `State` varchar(25) NOT NULL default '',
  KEY `Computer` (`MACAddress`,`ComputerName`),
  KEY `Service` (`DisplayName`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 ;

CREATE TABLE `I3_assets_software` (
  `MACAddress` varchar(12) NOT NULL default '',
  `ComputerName` varchar(64) NOT NULL default '',
  `Publisher` varchar(50) NOT NULL default '',
  `DisplayName` varchar(255) NOT NULL default '',
  `DisplayVersion` varchar(25) NOT NULL default '',
  `InstallDate` varchar(8) NOT NULL default '',
  `URLUpdateInfo` varchar(255) NOT NULL default '',
  `NoModify` tinyint(1) NOT NULL default '0',
  `NoRepair` tinyint(1) NOT NULL default '0',
  `NoRemove` tinyint(1) NOT NULL default '0',
  KEY `Computer` (`MACAddress`,`ComputerName`),
  KEY `Software` (`DisplayName`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 ;


UPDATE inprotect_settings SET settingValue='1.00.0_alpha_04' WHERE settingName='version';